#include "../jrd/jrd.h"
#include <windows.h>
#ifdef SHLIB_DEFS
#define LOCAL_SHLIB_DEFS
#endif

#include "../jrd/ib_stdio.h"
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include "../jrd/codes.h"
#include "../jrd/jrd.h"
#include "../jrd/flu_proto.h"
#include "../jrd/gds_proto.h"
#include "../jrd/isc_proto.h"
#include "../jrd/isc_f_proto.h"
#include "../jrd/jrd_proto.h"

#ifdef	WINDOWS_ONLY
#include "../jrd/seg_proto.h"
#endif

#ifndef NO_NFS
#define NFS	1
#endif

#ifndef GETWD
#define GETWD			getwd
#endif

#ifndef NON_MNTENT
#ifdef NFS
#ifdef apollo
#include <sys/types.h>
#include <mtab.h>
#define MTAB_OPEN(path,type)	setmntent (MTAB_FILE)
#else
#include <mntent.h>
#define MTAB_OPEN(path,type)	setmntent (path, "r")
#endif
#define MTAB_CLOSE(stream)	endmntent (stream)
#endif
#endif

#ifndef MTAB
#define MTAB			"/etc/mtab"
#endif

typedef struct mnt {
    TEXT	*mnt_node;
    TEXT	*mnt_mount;
    TEXT	*mnt_path;
} MNT;

/* Unix specific stuff */

#ifdef UNIX
#ifndef NeXT
#include <unistd.h>
#endif
#include <sys/types.h>
#ifndef NeXT
#include <sys/ipc.h>
#endif
#include <sys/file.h>
#include <errno.h>

#ifdef DELTA
#include <sys/sysmacros.h>
#include <sys/param.h>
#endif

extern struct passwd	*getpwnam(), *getpwuid();
#endif

/* MS/DOS / OS2 / NLM Junk */

#ifdef PC_PLATFORM
#include <stdlib.h>

#define PARSE_FILENAME
#define ISC_DATABASE	"ISC_DATABASE"	/* default database directory
					   environment variable */

#if defined WINDOWS_ONLY && !defined WIN_NT
#define DRIVE_CDROM 5
#define DRIVE_RAMDISK 6
#endif	/* WINDOWS_ONLY && !WIN_NT */

/* definition of toupper () */
#ifndef __CTYPE_H
#include <ctype.h>
#endif	/* __CTYPE_H */

#endif	/* PC_PLATFORM */

#ifdef NETWARE_386
#define PARSE_FILENAME
#endif

#ifdef OS2_ONLY
#define PARSE_FILENAME
#define INCL_DOSFILEMGR
#define INCL_DOSERRORS
#include <os2.h>

static PFN		netusegetinfo, netsharegetinfo;

#define FILENAME_UPPER(c)	UPPER7(c)
#define MAXPATHLEN		512
#endif

/* Windows NT stuff */

#ifdef WIN_NT
#include <windows.h>
#ifndef TEXT
#define TEXT		SCHAR
#endif

#ifndef MAXPATHLEN
#define MAXPATHLEN	_MAX_PATH
#endif
#endif

/* Windows specific stuff */

#ifdef WINDOWS_ONLY
#define TEXT		SCHAR

#define NO_ERROR  WN_SUCCESS
#endif  /* WINDOWS_ONLY */

/* HP MPE/XL specific stuff */

#ifdef mpexl

#include <fcntl.h>
#include <mpe.h>
#include "../jrd/mpexl.h"
#endif

/* Apollo specific Stuff */

#ifdef APOLLO

#include <apollo/base.h>
#include <apollo/pm.h>
#include <apollo/task.h>
#include <apollo/loader.h>
#include <apollo/ec2.h>
#include <apollo/ms.h>
#include <apollo/name.h>
#include <apollo/error.h>
#endif

#ifndef MAXPATHLEN
#define MAXPATHLEN	512
#endif

#ifndef MAXHOSTLEN
#define MAXHOSTLEN	64
#endif

#ifndef INET_FLAG
#define INET_FLAG	':'
#endif

static int	apollo_expand (TEXT *, USHORT, TEXT *);
static int	expand_filename2 (TEXT *, USHORT, TEXT *);

#ifndef WINCE
#if (defined WIN_NT || defined WINDOWS_ONLY)
static void	expand_share_name (TEXT *);
#if defined WIN_NT
static void	share_name_from_resource (TEXT*, TEXT*, LPNETRESOURCE);
static void     share_name_from_unc      ( TEXT*, TEXT*, LPREMOTE_NAME_INFO);
#endif
#endif
#endif

#if (defined AIX || defined AIX_PPC || defined DECOSF)
static BOOLEAN	get_mounts (MNT *, TEXT *, TEXT **, int *);
#else
#ifdef DELTA
static BOOLEAN	get_mounts (MNT *, TEXT *, int);
#else
#ifdef ultrix
static BOOLEAN	get_mounts (MNT *, TEXT *, int *);
#else
static BOOLEAN	get_mounts (MNT *, TEXT *, IB_FILE *);
#endif
#endif
#endif
static BOOLEAN	get_server (TEXT *, TEXT *);
#if (defined SPX) || ((defined PC_PLATFORM) && !(defined NETWARE_386))
static void     string_parse (TEXT *, TEXT **, TEXT **, TEXT **, TEXT *);
static void convert_slashes (char oldslash, char newslash, char *string);
#endif

#ifdef SHLIB_DEFS
#define strlen		(*_libgds_strlen)
#define strcmp		(*_libgds_strcmp)
#define strcpy		(*_libgds_strcpy)
#define _iob		(*_libgds__iob)
#define errno		(*_libgds_errno)
#define ib_fopen		(*_libgds_fopen)
#define ib_fclose		(*_libgds_fclose)
#define open		(*_libgds_open)
#define strcat		(*_libgds_strcat)
#define strncpy		(*_libgds_strncpy)
#define strchr		(*_libgds_strchr)
#define getpwnam	(*_libgds_getpwnam)
#define geteuid		(*_libgds_geteuid)
#define getpwuid	(*_libgds_getpwuid)
#define close		(*_libgds_close)
#define ib_fscanf		(*_libgds_fscanf)
#define _ctype		(*_libgds__ctype)
#define readlink	(*_libgds_readlink)

extern int		strlen();
extern int		strcmp();
extern SCHAR		*strcpy();
extern IB_FILE		_iob [];
extern int		errno;
extern IB_FILE		*ib_fopen();
extern int		ib_fclose();
extern int		open();
extern SCHAR		*strcat();
extern SCHAR		*strncpy();
extern SCHAR		*strchr();
extern struct passwd	*getpwnam();
extern uid_t		geteuid();
extern struct passwd	*getpwuid();
extern int		close();
extern int		ib_fscanf();
extern SCHAR		_ctype [];
extern int		readlink();

#ifndef SCO
#define GETWD		(*_libgds_getwd)
#define setmntent	(*_libgds_setmntent)
#define getmntent	(*_libgds_getmntent)
#define endmntent	(*_libgds_endmntent)

extern SCHAR		*GETWD();
extern IB_FILE		*setmntent();
extern struct mntent	*getmntent();
extern int		endmntent();
#else
#define getcwd		(*_libgds_getcwd)
#define popen		(*_libgds_popen)
#define pclose		(*_libgds_pclose)

extern IB_FILE		*popen();
extern IB_FILE		*pclose();
extern SCHAR		*getcwd();
#endif
#endif

long ce_time()
{
	SYSTEMTIME t;

	GetSystemTime(&t);

	return (((((t.wYear - 1957) * 365) + (t.wMonth * 30)) * 60 + t.wHour) * 60 + t.wMinute * 60) + t.wSecond;
}

char *ce_ctime(int t)
{
	static char result[1024];

	GetTimeFormat(LOCALE_SYSTEM_DEFAULT, LOCALE_NOUSEROVERRIDE, NULL, NULL, result, 1023);

	return result;
}

int DLL_EXPORT ISC_analyze_tcp (
    TEXT	*file_name,
    TEXT	*node_name)
{
/**************************************
 *
 *	I S C _ a n a l y z e _ t c p		( G E N E R I C )
 *
 **************************************
 *
 * Functional description
 *	Analyze a filename for a TCP node name on the front.  If
 *	one is found, extract the node name, compute the residual
 *	file name, and return TRUE.  Otherwise return FALSE.
 *
 **************************************/
TEXT	*p;
USHORT  dtype;

/* Scan file name looking for separator character */

if (!(p = strchr (file_name, INET_FLAG)))
    return FALSE;

#ifdef NETWARE_386
/* Filename for NetWare is of form node:[/][vol:][dir/../]filename.ext
   so if only one ':' is found then path does not contain a node.
   One has already been found, look for another. */

if (!strchr (p + 1, ':'))
    return FALSE;

#else
#if (defined PC_PLATFORM || defined OS2_ONLY)
/* for DOS and OS/2, introduce a restriction against one-character
   machine names as a kludge to prevent the situation of 
   trying to attach to C: as a remote machine -- there has
   got to be a better way to resolve this */

if (p - file_name == 1)
    return FALSE;
#endif
#endif

#if (defined(WIN_NT) && !defined(WINCE))
/* For Windows NT, insure that a single character node name does
   not conflict with an existing drive letter. */

if (p - file_name == 1)
    {
    *node_name = *file_name;
    strcpy (node_name + 1, ":\\");
    dtype = GetDriveType (node_name);
    if (dtype > 1 && dtype != DRIVE_REMOTE)
	return FALSE;
    }
#endif

*p = 0;
strcpy (node_name, file_name);

#ifdef NETWARE_386
/* for NetWare [node:] may be followed by a '\' or a '/' if so
   do not include it in file name. */

if (( *(p+1) == '/') || (*(p+1) == '\\'))
 p++;
#endif

while (*file_name++ = *++p)

    ;

return TRUE;
}

int abort()
{
	TerminateProcess(GetCurrentProcess(), 1);
}