#include <stdlib.h>

EXEC SQL SET DATABASE DB = 'camp.ucsd.edu:/scratch/database/ramp.gdb'
		USER 'sysdba'
		PASSWORD '#li%r)kT';

XSQLDA *intDa = 0;
XSQLDA *userDa = 0;
XSQLDA *resultDa = 0;
static char *sql1 = "INSERT INTO INT_TEST VALUES (?)";
static char *sql2 = "EXECUTE PROCEDURE add_sample2(?, ?, ?, ?, ?)";
//static char *sql2 = "INSERT INTO SAMPLES VALUES (?, ?, ?, ?, ?)";
static char *sql3 = "INSERT INTO TEST_RESULTS VALUES (?, ?, ?)";

#include <windows.h>


int connectDb()
{
	EXEC SQL WHENEVER SQLERROR GO TO ConnErr;
	EXEC SQL CONNECT DB;
	EXEC SQL SET TRANSACTION;

	return 1;

	ConnErr:
		return 0;
}

int disconnectDb()
{
	EXEC SQL WHENEVER SQLERROR GO TO DisErr;
	EXEC SQL COMMIT;
	EXEC SQL DISCONNECT DB;

	if (intDa)
		free(intDa);
	intDa = 0;

	if (userDa)
		free(userDa);
	userDa = 0;

	if (resultDa)
		free(resultDa);
	resultDa = 0;

	DisErr:
	return 1;
}

int insertInt(long val)
{
	EXEC SQL WHENEVER SQLERROR GO TO InsErr;
	if (!intDa)
	{
		intDa = (XSQLDA*) malloc(XSQLDA_LENGTH(5));
		if (!intDa)
			goto InsErr;
		EXEC SQL PREPARE SQL_STMT1 FROM :sql1;

		intDa->version = SQLDA_VERSION1;
		intDa->sqln = 5;
		EXEC SQL DESCRIBE INPUT SQL_STMT1 USING SQL DESCRIPTOR intDa;
	}

	intDa->sqlvar[0].sqlind = 0;
	intDa->sqlvar[0].sqltype = SQL_LONG;
	intDa->sqlvar[0].sqldata = &val;
	EXEC SQL EXECUTE SQL_STMT1 USING SQL DESCRIPTOR intDa;

	return 1;

	InsErr:
		return 0;
}

int insertUserRec(char *userName, long power, long powerState, long other, char *bigStr)
{
	isc_blob_handle newBlob = NULL;
	ISC_QUAD	blobId;
	long		userId = 1;

	EXEC SQL WHENEVER SQLERROR GO TO Ins2Err;
	if (!userDa)
	{
		userDa = (XSQLDA*) malloc(XSQLDA_LENGTH(5));
		if (!userDa)
			goto Ins2Err;
		EXEC SQL PREPARE SQL_STMT2 FROM :sql2;

		userDa->version = SQLDA_VERSION1;
		userDa->sqln = 5;
		EXEC SQL DESCRIBE INPUT SQL_STMT2 USING SQL DESCRIPTOR userDa;
	}

	/*isc_create_blob2(gds__status, &DB, &gds__trans, &newBlob, &blobId, 0, 0);
	if (gds__status[0] == 1 && gds__status[1])
		goto Ins2Err;
	isc_put_segment(gds__status, &newBlob, strlen(bigStr), bigStr);
	if (gds__status[0] == 1 && gds__status[1])
		goto Ins2Err;
	isc_close_blob(gds__status, &newBlob);
	if (gds__status[0] == 1 && gds__status[1])
		goto Ins2Err;
	*/

	userDa->sqlvar[0].sqlind = 0;
	userDa->sqlvar[0].sqltype = SQL_TEXT;
	//userDa->sqlvar[0].sqltype = SQL_LONG;
	userDa->sqlvar[1].sqlind = 0;
	userDa->sqlvar[1].sqltype = SQL_LONG;
	userDa->sqlvar[2].sqlind = 0;
	userDa->sqlvar[2].sqltype = SQL_LONG;
	userDa->sqlvar[3].sqlind = 0;
	userDa->sqlvar[3].sqltype = SQL_LONG;
	//userDa->sqlvar[4].sqlind = 0;
	//userDa->sqlvar[4].sqltype = SQL_TEXT;
	userDa->sqlvar[4].sqlind = 0;
	userDa->sqlvar[4].sqltype = SQL_BLOB;
	userDa->sqlvar[0].sqldata = userName;
	userDa->sqlvar[0].sqllen = strlen(userName);
	//userDa->sqlvar[0].sqldata = &userId;
	userDa->sqlvar[1].sqldata = &power;
	userDa->sqlvar[2].sqldata = &powerState;
	userDa->sqlvar[3].sqldata = &other;
	userDa->sqlvar[4].sqldata = bigStr;
	userDa->sqlvar[4].sqllen = strlen(bigStr);
	//userDa->sqlvar[4].sqldata = &blobId;
	//userDa->sqlvar[4].sqllen = sizeof(ISC_QUAD);
	EXEC SQL EXECUTE SQL_STMT2 USING SQL DESCRIPTOR userDa;

	return 1;

	Ins2Err:
		return 0;
}

int insertTestResultRec(long id, long milliSecs, long testSize)
{
	EXEC SQL WHENEVER SQLERROR GO TO Ins3Err;
	if (!resultDa)
	{
		resultDa = (XSQLDA*) malloc(XSQLDA_LENGTH(5));
		if (!resultDa)
			goto Ins3Err;
		EXEC SQL PREPARE SQL_STMT3 FROM :sql3;

		resultDa->version = SQLDA_VERSION1;
		resultDa->sqln = 5;
		EXEC SQL DESCRIBE INPUT SQL_STMT3 USING SQL DESCRIPTOR resultDa;
	}

	resultDa->sqlvar[0].sqlind = 0;
	resultDa->sqlvar[0].sqltype = SQL_LONG;
	resultDa->sqlvar[1].sqlind = 0;
	resultDa->sqlvar[1].sqltype = SQL_LONG;
	resultDa->sqlvar[2].sqlind = 0;
	resultDa->sqlvar[2].sqltype = SQL_LONG;
	resultDa->sqlvar[0].sqldata = &id;
	resultDa->sqlvar[1].sqldata = &milliSecs;
	resultDa->sqlvar[2].sqldata = &testSize;
	EXEC SQL EXECUTE SQL_STMT3 USING SQL DESCRIPTOR resultDa;

	return 1;

	Ins3Err:
	{
		long *pvector;
		char buff[512];

		pvector = isc_status;
		isc_interprete(buff, &pvector);
		while(isc_interprete(buff, &pvector))
			;
	}
		return 0;
}

int check_and_update(int prod_id, char *install_loc)
{
	char	data[1025];
	int	dataLen = 1024;
	DWORD	neededSize;
	VS_FIXEDFILEINFO	*versInfo;
	_int64	currVers;
	ISC_QUAD blobId;
	int	needsUpdate = 0;
	TCHAR	tbuff[1024];
	TCHAR	tbuff2[1024];
	HANDLE	newFile;

	EXEC SQL WHENEVER SQLERROR GO TO c_a_u_end;

	if (0 == MultiByteToWideChar(CP_ACP, MB_COMPOSITE, install_loc, -1, tbuff, 1024))
		return -1;

	if (0 == GetFileVersionInfoSize(tbuff, &neededSize))
		return -1;
	if (neededSize > 1024)
		return -2;

	if (0 == GetFileVersionInfo(tbuff, 0, 1024, data))
		return -1;

	if (0 == VerQueryValue(data, _T("\\"), &versInfo, &neededSize))
		return -1;

	currVers = versInfo->dwFileVersionMS;
	currVers = currVers << 32;
	currVers |= versInfo->dwFileVersionLS;

	EXEC SQL DECLARE VERS_CURSOR CURSOR FOR
		SELECT product FROM versions WHERE prod_id = :prod_id AND version > :currVers ORDER BY version DESC;
	EXEC SQL OPEN VERS_CURSOR;
	EXEC SQL FETCH VERS_CURSOR INTO :blobId;
	if (SQLCODE == 0)
		needsUpdate = 1;
	EXEC SQL CLOSE VERS_CURSOR;
	if (!needsUpdate)
		return 0;

	_tcscpy(tbuff2, tbuff);
	_tcscat(tbuff2, _T(".new"));
	newFile = CreateFile(tbuff2, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0);
	if (INVALID_HANDLE_VALUE == newFile)
		return -1;

	EXEC SQL WHENEVER SQLERROR GO TO c_a_u_cleanup;
	EXEC SQL DECLARE FILE_BLOB CURSOR FOR READ BLOB product FROM versions;
	EXEC SQL OPEN FILE_BLOB USING :blobId;
	EXEC SQL FETCH FILE_BLOB INTO :data:dataLen;
	while (SQLCODE != 100 || SQLCODE == 101)
	{
		WriteFile(newFile, data, dataLen, &neededSize, NULL);
		EXEC SQL FETCH FILE_BLOB INTO :data:dataLen;
	}
	EXEC SQL CLOSE FILE_BLOB;
	SetEndOfFile(newFile);
	CloseHandle(newFile);

	EXEC SQL WHENEVER SQLERROR GO TO c_a_u_end;
	return 0;

	c_a_u_cleanup:
		CloseHandle(newFile);
		DeleteFile(tbuff2);

	c_a_u_end:
		return -3;
}

DWORD do_update()
{
	int	prod_id;
	char	install_loc[300];
	DWORD	winError = 0;

	EXEC SQL WHENEVER SQLERROR GO TO d_u_end;
	EXEC SQL DECLARE PROD_CURSOR CURSOR FOR
		SELECT PROD_ID, INSTALL_LOC FROM products;
	EXEC SQL OPEN PROD_CURSOR;
	EXEC SQL FETCH PROD_CURSOR INTO :prod_id, :install_loc;
	while (!SQLCODE && !winError)
	{
		if (-1 == check_and_update(prod_id, install_loc))
		{
			winError = GetLastError();
			if (winError == 1814)
				winError = 0;
		}
		EXEC SQL FETCH PROD_CURSOR INTO :prod_id, :install_loc;
	}
	EXEC SQL CLOSE PROD_CURSOR;

	d_u_end:
		return winError;
}

void load_error_msg(char* buff)
{
        long *pvector;
        int len, more = 1;

        for( pvector = isc_status;more; )
        {
                more = isc_interprete(&buff[strlen(buff)], &pvector);
                if (!more)
                        break;
                len = strlen(buff);
                buff[len] = '\n';
                buff[len+1] = 0;
        }
}

void all_done_with_db()
{
        gds__cleanup();
}
