// db_test.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "db_test.h"
#include <commctrl.h>
#include <windows.h>

#define MAX_LOADSTRING 100

#define TEST_SIZE	1

//char *THE_BIG_STR = "1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789";
char *THE_BIG_STR = "1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,1234567890123456789,";

TCHAR *get_hello_str();

// Global Variables:
HINSTANCE			hInst;			// The current instance
HWND				hwndCB;			// The command bar handle

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_DB_TEST);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_DB_TEST));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_DB_TEST, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance, szWindowClass);

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{	
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	if (hwndCB)
		CommandBar_Show(hwndCB, TRUE);

	return TRUE;
}

extern "C" void all_done_with_db();

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	TCHAR szHello[MAX_LOADSTRING];

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_HELP_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_FILE_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			hwndCB = CommandBar_Create(hInst, hWnd, 1);			
			CommandBar_InsertMenubar(hwndCB, hInst, IDM_MENU, 0);
			CommandBar_AddAdornments(hwndCB, 0, 0);
			break;
		case WM_PAINT:
			RECT rt;
			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rt);
			rt.top += 30;
			rt.left += 10;
			//LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
			DrawText(hdc, get_hello_str(), -1, &rt, DT_LEFT | DT_WORDBREAK);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			CommandBar_Destroy(hwndCB);
			PostQuitMessage(0);
			all_done_with_db();
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;

	switch (message)
	{
		case WM_INITDIALOG:
			// trying to center the About dialog
			if (GetWindowRect(hDlg, &rt1)) {
				GetClientRect(GetParent(hDlg), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
				
				// if the About box is larger than the physical screen 
				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hDlg, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			return TRUE;

		case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

int done = 0;

extern "C" char *load_db_str(char *);
extern "C" int connectDb();
extern "C" int disconnectDb();
extern "C" int insertInt(long);
extern "C" int insertTestResultRec(long, long, long);
extern "C" int insertUserRec(char *, long, long, long, char*);
extern "C" void load_error_msg(char*);
extern "C" DWORD do_update();

long testResults[TEST_SIZE];

TCHAR *get_hello_str()
{
	static TCHAR	result[4096];
	static char		resBuff[2048];
	int k = 0;
	DWORD err;

	if (done == 0)
	{
		char insertStr[300];
		DWORD stTime, eTime;
		SYSTEMTIME sTime;

		GetLocalTime(&sTime);
		//sprintf(resBuff, "pocket pc insert at %d:%d:%d %d/%d/%d", sTime.wHour, sTime.wMinute, sTime.wSecond, sTime.wMonth, sTime.wDay, sTime.wYear);

		//strcpy(resBuff, load_db_str(resBuff));

		/*resBuff[0] = 0;
		for(int j = 0; j < TEST_SIZE; j++)
		{
			stTime = GetTickCount();*/
			if (!connectDb())
			{
				sprintf(resBuff, "Connect error during test\n");
				load_error_msg(&resBuff[strlen(resBuff)]);
				//break;
	        }
			else
			{
				err = do_update();
\				/*for(int i = 0; i < 5000
					; i++)
				{
			        //if (!insertInt(300 + (k++) ))
					if (!insertUserRec("john", 5000 + (k++), 1, 1, THE_BIG_STR))
				    {
							sprintf(resBuff, "Insert error during test %d:%d:\n", j, i);
							load_error_msg(&resBuff[strlen(resBuff)]);
						    disconnectDb();
							break;
	                }
				}
				if (resBuff[0] != 0)
					break;*/
				if (!disconnectDb())
				{
					sprintf(resBuff, "Disconnect error during test\n");
					load_error_msg(&resBuff[strlen(resBuff)]);
					//break;
				}
			}
			eTime = GetTickCount();
			//testResults[j] = eTime - stTime;
		//}

		/*if (resBuff[0] == 0)
		{
			if (connectDb())
			{
				for( int i = 0; i < TEST_SIZE; i++)
					if (!insertTestResultRec(14, testResults[i], i ))
					{
						sprintf(resBuff, "Insert error during result upload %d:\n", i);
						load_error_msg(&resBuff[strlen(resBuff)]);
						disconnectDb();
						break;
					}
				if (resBuff[0] == 0 && !disconnectDb())
				{
					sprintf(resBuff, "Disconnect error during result upload:\n", j);
					load_error_msg(&resBuff[strlen(resBuff)]);
				}
				else
					sprintf(resBuff, "Test Successful");
			}
			else
			{
				sprintf(resBuff, "Connect error during result upload:\n", j);
				load_error_msg(&resBuff[strlen(resBuff)]);
			}
		}
		*/

		//sprintf(insertStr, "%ld", eTime - sTime);

		if (!err)
		{
			if (!MultiByteToWideChar(CP_ACP, MB_COMPOSITE, resBuff, -1, result, 4094))
				result[0] = result[0];
		}
		else
		{
			FormatMessage(FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_FROM_SYSTEM, 0, err, 0, result, 2048, 0);
		}
	}

	done = 1;
	return result;
}

extern "C" long getTickCount()
{
	return GetTickCount();
}