/* This list is maintained in alphabetical sorted order by 2nd column.
   The following command will resort the list -- except for this comment
   sort -t , -k 2b,2b keywords.h 
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): 
 *       2001.08.03   John Bellardo changed LIMIT token to SKIP
 *       2001.07.28   John Bellardo added tokens for FIRST and LIMIT
   See dsql/parse.y for a chronological list. */

DSQL_KEYWORD(NOT_LSS,  "!<", 1)
DSQL_KEYWORD(NEQ,	  "!=", 1)
DSQL_KEYWORD(NOT_GTR,  "!>", 1)
DSQL_KEYWORD(LPAREN,   "(", 1)
DSQL_KEYWORD(RPAREN,	  ")", 1)
DSQL_KEYWORD(COMMA,	  ",", 1)
DSQL_KEYWORD(LSS,	  "<", 1)
DSQL_KEYWORD(LEQ,	  "<=", 1)
DSQL_KEYWORD(NEQ,	  "<>", 1)			/* Alias of != */
DSQL_KEYWORD(EQL,	  "=", 1)
DSQL_KEYWORD(GTR,	  ">", 1)
DSQL_KEYWORD(GEQ,	  ">=", 1)
DSQL_KEYWORD(ACTION,   "ACTION", 1)
DSQL_KEYWORD(ACTIVE,	  "ACTIVE", 1)
DSQL_KEYWORD(ADD,	  "ADD", 1)
DSQL_KEYWORD(ADMIN,	  "ADMIN", 1)
DSQL_KEYWORD(AFTER,	  "AFTER", 1)
DSQL_KEYWORD(ALL,	  "ALL", 1)
DSQL_KEYWORD(ALTER,	  "ALTER", 1)
DSQL_KEYWORD(AND,	  "AND", 1)
DSQL_KEYWORD(ANY,	  "ANY", 1)
DSQL_KEYWORD(AS,	  "AS", 1)
DSQL_KEYWORD(ASC,	  "ASC", 1)		/* Alias of ASCENDING */
DSQL_KEYWORD(ASC,	  "ASCENDING", 1)
DSQL_KEYWORD(AT,	  "AT", 1)
DSQL_KEYWORD(AUTO,	  "AUTO", 1)
DSQL_KEYWORD(AVG,	  "AVG", 1)
DSQL_KEYWORD(BASENAME, "BASE_NAME", 1)
DSQL_KEYWORD(BEFORE,	  "BEFORE", 1)
DSQL_KEYWORD(BEGIN,    "BEGIN", 1)
DSQL_KEYWORD(BETWEEN,  "BETWEEN", 1)
DSQL_KEYWORD(BLOB,	  "BLOB", 1)
DSQL_KEYWORD(KW_BREAK, "BREAK", 2) 
DSQL_KEYWORD(BY,	  "BY", 1)
DSQL_KEYWORD(CACHE,    "CACHE", 1)
DSQL_KEYWORD(CASCADE,  "CASCADE", 1)
DSQL_KEYWORD(CAST,	  "CAST", 1)
DSQL_KEYWORD(KW_CHAR,  "CHAR", 1)
DSQL_KEYWORD(CHARACTER,"CHARACTER", 1)
DSQL_KEYWORD(CHECK,	  "CHECK", 1)
DSQL_KEYWORD(CHECK_POINT_LEN, "CHECK_POINT_LENGTH", 1)
DSQL_KEYWORD(COLLATE,  "COLLATE", 1)
DSQL_KEYWORD(COLUMN,	  "COLUMN", 2)
DSQL_KEYWORD(COMMIT,	  "COMMIT", 1)
DSQL_KEYWORD(COMMITTED, "COMMITTED", 1)
DSQL_KEYWORD(COMPUTED, "COMPUTED", 1)
DSQL_KEYWORD(CONDITIONAL, "CONDITIONAL", 1)
DSQL_KEYWORD(CONSTRAINT, "CONSTRAINT", 1)
DSQL_KEYWORD(CONTAINING, "CONTAINING", 1)
DSQL_KEYWORD(COUNT,	  "COUNT", 1)
DSQL_KEYWORD(CREATE,	  "CREATE", 1)
DSQL_KEYWORD(CSTRING,  "CSTRING", 1)
DSQL_KEYWORD(CURRENT,  "CURRENT", 1)
DSQL_KEYWORD(CURRENT_DATE, "CURRENT_DATE", 2)
DSQL_KEYWORD(CURRENT_ROLE, "CURRENT_ROLE", 2)
DSQL_KEYWORD(CURRENT_TIME, "CURRENT_TIME", 2)
DSQL_KEYWORD(CURRENT_TIMESTAMP, "CURRENT_TIMESTAMP", 2)
DSQL_KEYWORD(CURRENT_USER, "CURRENT_USER", 2)
DSQL_KEYWORD(CURSOR,	  "CURSOR", 1)
DSQL_KEYWORD(DATABASE, "DATABASE", 1)
DSQL_KEYWORD(DATE,     "DATE", 1)
DSQL_KEYWORD(DAY,      "DAY", 2)
DSQL_KEYWORD(DEBUG,    "DEBUG", 1)
DSQL_KEYWORD(KW_DEC,   "DEC", 1)
DSQL_KEYWORD(DECIMAL,  "DECIMAL", 1)
DSQL_KEYWORD(DECLARE,  "DECLARE", 1)
DSQL_KEYWORD(DEFAULT,  "DEFAULT", 1)
DSQL_KEYWORD(DELETE,	  "DELETE", 1)
DSQL_KEYWORD(DESC,	  "DESC", 1)		/* Alias of DESCENDING */
DSQL_KEYWORD(DESC,	  "DESCENDING", 1)
DSQL_KEYWORD(KW_DESCRIPTOR,	"DESCRIPTOR", 2)
DSQL_KEYWORD(DISTINCT, "DISTINCT", 1)
DSQL_KEYWORD(DO,	  "DO", 1)
DSQL_KEYWORD(DOMAIN,	  "DOMAIN", 1)
DSQL_KEYWORD(KW_DOUBLE, "DOUBLE", 1)
DSQL_KEYWORD(DROP,	  "DROP", 1)
DSQL_KEYWORD(ELSE,      "ELSE", 1)
DSQL_KEYWORD(END,      "END", 1)
DSQL_KEYWORD(ENTRY_POINT, "ENTRY_POINT", 1)
DSQL_KEYWORD(ESCAPE,   "ESCAPE", 1)
DSQL_KEYWORD(EXCEPTION,"EXCEPTION", 1)
DSQL_KEYWORD(EXECUTE,  "EXECUTE", 1)
DSQL_KEYWORD(EXISTS,	  "EXISTS", 1)
DSQL_KEYWORD(EXIT,	  "EXIT", 1)
DSQL_KEYWORD(EXTERNAL, "EXTERNAL", 1)
DSQL_KEYWORD(EXTRACT,  "EXTRACT", 2)
DSQL_KEYWORD(KW_FILE,  "FILE", 1)
DSQL_KEYWORD(FILTER,	  "FILTER", 1)
DSQL_KEYWORD(FIRST,    "FIRST", 2)
DSQL_KEYWORD(KW_FLOAT, "FLOAT", 1)
DSQL_KEYWORD(FOR,	  "FOR", 1)
DSQL_KEYWORD(FOREIGN,  "FOREIGN", 1)
DSQL_KEYWORD(FREE_IT,  "FREE_IT", 1)
DSQL_KEYWORD(FROM,	  "FROM", 1)
DSQL_KEYWORD(FULL,	  "FULL", 1)
DSQL_KEYWORD(FUNCTION, "FUNCTION", 1)
DSQL_KEYWORD(GDSCODE,  "GDSCODE", 1)
DSQL_KEYWORD(GENERATOR,"GENERATOR", 1)
DSQL_KEYWORD(GEN_ID,   "GEN_ID", 1)
DSQL_KEYWORD(GRANT, 	  "GRANT", 1)
DSQL_KEYWORD(GROUP,	  "GROUP", 1)
DSQL_KEYWORD(GROUP_COMMIT_WAIT, "GROUP_COMMIT_WAIT_TIME", 1)
DSQL_KEYWORD(HAVING,	  "HAVING", 1)
DSQL_KEYWORD(HOUR,     "HOUR", 2)
DSQL_KEYWORD(IF,	  "IF", 1)
DSQL_KEYWORD(IN,	  "IN", 1)
DSQL_KEYWORD(INACTIVE, "INACTIVE", 1)
DSQL_KEYWORD(INDEX,	  "INDEX", 1)
DSQL_KEYWORD(INNER, 	  "INNER", 1)
DSQL_KEYWORD(INPUT_TYPE, "INPUT_TYPE", 1)
DSQL_KEYWORD(INSERT,	  "INSERT", 1)
DSQL_KEYWORD(KW_INT,   "INT", 1)
DSQL_KEYWORD(INTEGER,  "INTEGER", 1)
DSQL_KEYWORD(INTO,	  "INTO", 1)
DSQL_KEYWORD(IS,	  "IS", 1)
DSQL_KEYWORD(ISOLATION, "ISOLATION", 1)
DSQL_KEYWORD(JOIN,     "JOIN", 1)
DSQL_KEYWORD(KEY,      "KEY", 1)
DSQL_KEYWORD(LEFT,	  "LEFT", 1)
DSQL_KEYWORD(LENGTH,	  "LENGTH", 1)
DSQL_KEYWORD(LEVEL,	  "LEVEL", 1)
DSQL_KEYWORD(LIKE,	  "LIKE", 1)
DSQL_KEYWORD(LOGFILE,  "LOGFILE", 1)
DSQL_KEYWORD(LOG_BUF_SIZE, "LOG_BUFFER_SIZE", 1)
DSQL_KEYWORD(KW_LONG,  "LONG", 1)
DSQL_KEYWORD(MANUAL,	  "MANUAL", 1)
DSQL_KEYWORD(MAXIMUM,  "MAX", 1)
DSQL_KEYWORD(MAX_SEGMENT, "MAXIMUM_SEGMENT", 1)
DSQL_KEYWORD(MERGE,    "MERGE", 1)
DSQL_KEYWORD(MESSAGE,  "MESSAGE", 1)
DSQL_KEYWORD(MINIMUM,  "MIN", 1)
DSQL_KEYWORD(MINUTE,   "MINUTE", 2)
DSQL_KEYWORD(MODULE_NAME, "MODULE_NAME", 1)
DSQL_KEYWORD(MONTH,    "MONTH", 2)
DSQL_KEYWORD(NAMES,    "NAMES", 1)
DSQL_KEYWORD(NATIONAL, "NATIONAL", 1)
DSQL_KEYWORD(NATURAL,  "NATURAL", 1)
DSQL_KEYWORD(NCHAR,    "NCHAR", 1)
DSQL_KEYWORD(NO,	  "NO", 1)
DSQL_KEYWORD(NOT,	  "NOT", 1)
DSQL_KEYWORD(KW_NULL,  "NULL", 1)
DSQL_KEYWORD(KW_NUMERIC,  "NUMERIC", 1)
DSQL_KEYWORD(NUM_LOG_BUFS, "NUM_LOG_BUFFERS", 1)
DSQL_KEYWORD(OF,	  "OF", 1)
DSQL_KEYWORD(ON,	  "ON", 1)
DSQL_KEYWORD(ONLY,	  "ONLY", 1)
DSQL_KEYWORD(OPTION,   "OPTION", 1)
DSQL_KEYWORD(OR,	  "OR", 1)
DSQL_KEYWORD(ORDER,	  "ORDER", 1)
DSQL_KEYWORD(OUTER,	  "OUTER", 1)
DSQL_KEYWORD(OUTPUT_TYPE, "OUTPUT_TYPE", 1)
DSQL_KEYWORD(OVERFLOW, "OVERFLOW", 1)
DSQL_KEYWORD(PAGE,     "PAGE", 1)
DSQL_KEYWORD(PAGES,    "PAGES", 1)
DSQL_KEYWORD(PAGE_SIZE,"PAGE_SIZE", 1)
DSQL_KEYWORD(PARAMETER, "PARAMETER", 1)
DSQL_KEYWORD(PASSWORD, "PASSWORD", 1)
DSQL_KEYWORD(PLAN,     "PLAN", 1)
DSQL_KEYWORD(POSITION, "POSITION", 1)
DSQL_KEYWORD(POST_EVENT, "POST_EVENT", 1)
DSQL_KEYWORD(PRECISION,"PRECISION", 1)
DSQL_KEYWORD(PRIMARY,  "PRIMARY", 1)
DSQL_KEYWORD(PRIVILEGES, "PRIVILEGES", 1)
DSQL_KEYWORD(PROCEDURE,"PROCEDURE", 1)
DSQL_KEYWORD(PROTECTED,"PROTECTED", 1)
DSQL_KEYWORD(RAW_PARTITIONS,      "RAW_PARTITIONS", 1)
DSQL_KEYWORD(DB_KEY,   "RDB$DB_KEY", 1)
DSQL_KEYWORD(READ,	  "READ", 1)
DSQL_KEYWORD(REAL,	  "REAL", 1)
DSQL_KEYWORD(VERSION,  "RECORD_VERSION", 1)
DSQL_KEYWORD(RECREATE, "RECREATE", 2)
DSQL_KEYWORD(REFERENCES,  "REFERENCES", 1)
DSQL_KEYWORD(RESERVING,   "RESERV", 1)			/* Alias of RESERVING */
DSQL_KEYWORD(RESERVING,   "RESERVING", 1)
DSQL_KEYWORD(RESTRICT, "RESTRICT", 1)
DSQL_KEYWORD(RETAIN,   "RETAIN", 1)
DSQL_KEYWORD(RETURNING_VALUES,   "RETURNING_VALUES", 1)
DSQL_KEYWORD(RETURNS,   "RETURNS", 1)
DSQL_KEYWORD(REVOKE,	  "REVOKE", 1)
DSQL_KEYWORD(RIGHT, 	  "RIGHT", 1)
DSQL_KEYWORD(ROLE,     "ROLE", 1)
DSQL_KEYWORD(ROLLBACK, "ROLLBACK", 1)
DSQL_KEYWORD(DATABASE, "SCHEMA", 1)	/* Alias of DATABASE */
DSQL_KEYWORD(SECOND,   "SECOND", 2)
DSQL_KEYWORD(SEGMENT,  "SEGMENT", 1)
DSQL_KEYWORD(SELECT,	  "SELECT", 1)
DSQL_KEYWORD(SET,	  "SET", 1)
DSQL_KEYWORD(SHADOW,	  "SHADOW", 1)
DSQL_KEYWORD(SHARED,	  "SHARED", 1)
DSQL_KEYWORD(SINGULAR, "SINGULAR", 1)
DSQL_KEYWORD(SIZE,     "SIZE", 1)
DSQL_KEYWORD(SKIP,     "SKIP", 2)
DSQL_KEYWORD(SMALLINT, "SMALLINT", 1)
DSQL_KEYWORD(SNAPSHOT, "SNAPSHOT", 1)
DSQL_KEYWORD(SOME,	  "SOME", 1)
DSQL_KEYWORD(SORT,	  "SORT", 1)
DSQL_KEYWORD(SQLCODE,  "SQLCODE", 1)
DSQL_KEYWORD(STABILITY, "STABILITY", 1)
DSQL_KEYWORD(STARTING, "STARTING", 1)
DSQL_KEYWORD(STARTING,   "STARTS", 1)			/* Alias of STARTING */
DSQL_KEYWORD(STATISTICS,	"STATISTICS", 1)
DSQL_KEYWORD(SUBSTRING,	"SUBSTRING", 2)
DSQL_KEYWORD(SUB_TYPE,	"SUB_TYPE", 1)
DSQL_KEYWORD(SUM,	  "SUM", 1)
DSQL_KEYWORD(SUSPEND,  "SUSPEND", 1)
DSQL_KEYWORD(TABLE,	  "TABLE", 1)
DSQL_KEYWORD(THEN,	  "THEN", 1)
DSQL_KEYWORD(TIME,     "TIME", 2)
DSQL_KEYWORD(TIMESTAMP,"TIMESTAMP", 2)
DSQL_KEYWORD(TO,	  "TO", 1)
DSQL_KEYWORD(TRANSACTION, "TRANSACTION", 1)
DSQL_KEYWORD(TRIGGER,  "TRIGGER", 1)
DSQL_KEYWORD(TYPE,	"TYPE", 2)
DSQL_KEYWORD(UNCOMMITTED,	"UNCOMMITTED", 1)
DSQL_KEYWORD(UNION,	  "UNION", 1)
DSQL_KEYWORD(UNIQUE,	  "UNIQUE", 1)
DSQL_KEYWORD(UPDATE,	  "UPDATE", 1)
DSQL_KEYWORD(KW_UPPER, "UPPER", 1)
DSQL_KEYWORD(USER,	  "USER", 1)
DSQL_KEYWORD(KW_VALUE, "VALUE", 1)
DSQL_KEYWORD(VALUES,	  "VALUES", 1)
DSQL_KEYWORD(VARCHAR,  "VARCHAR", 1)
DSQL_KEYWORD(VARIABLE, "VARIABLE", 1)
DSQL_KEYWORD(VARYING,  "VARYING", 1)
DSQL_KEYWORD(VIEW,	  "VIEW", 1)
DSQL_KEYWORD(WAIT,	  "WAIT", 1)
DSQL_KEYWORD(WEEKDAY,  "WEEKDAY", 2)
DSQL_KEYWORD(WHEN,	  "WHEN", 1)
DSQL_KEYWORD(WHERE,	  "WHERE", 1)
DSQL_KEYWORD(WHILE,	  "WHILE", 1)
DSQL_KEYWORD(WITH,	  "WITH", 1)
DSQL_KEYWORD(WORK,	  "WORK", 1)
DSQL_KEYWORD(WRITE,	  "WRITE", 1)
DSQL_KEYWORD(YEAR,     "YEAR", 2)
DSQL_KEYWORD(YEARDAY,  "YEARDAY", 2)
DSQL_KEYWORD(NOT_LSS,  "^<", 1)			/* Alias of !< */
DSQL_KEYWORD(NEQ,	  "^=", 1)			/* Alias of != */
DSQL_KEYWORD(NOT_GTR,  "^>", 1)			/* Alias of !> */
DSQL_KEYWORD(CONCATENATE, "||", 1)
DSQL_KEYWORD(NOT_LSS,  "~<", 1)			/* Alias of !< */
DSQL_KEYWORD(NEQ,	  "~=", 1)			/* Alias of != */
DSQL_KEYWORD(NOT_GTR,  "~>", 1)			/* Alias of !> */
