/*
 *	PROGRAM:	JRD Remote Interface
 *	MODULE:		interface.c
 *	DESCRIPTION:	User visible entrypoints remote interface
 *
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 */

#include "../remote/remote.h"
#include "../remote/remot_proto.h"

/*
#include "../jrd/ib_stdio.h"
#include "../jrd/ibsetjmp.h"
#include <stdlib.h>
#include <string.h>
#include "../remote/remote.h"
#include "../jrd/gdsassert.h"
#include <stdarg.h>

#include "../jrd/gds.h"
#include "../jrd/thd.h"
#include "../jrd/license.h"
#include "../jrd/fil.h"
#include "../jrd/sdl.h"
#include "../jrd/pwd.h"
#include "../remote/inet_proto.h"
#include "../remote/inter_proto.h"
#include "../remote/merge_proto.h"
#include "../remote/parse_proto.h"
#include "../remote/proto_proto.h"
#include "../jrd/cvt_proto.h"
#include "../jrd/enc_proto.h"
#include "../jrd/gds_proto.h"
#include "../jrd/isc_f_proto.h"
#include "../jrd/sdl_proto.h"
#include "../jrd/thd_proto.h"
#include "../jrd/sch_proto.h"

#ifdef	WIN_NT
#include "../jrd/isc_proto.h"
#endif

#ifdef APOLLO
#include "../remote/ambx_proto.h"
#endif
#ifdef OS2_ONLY
#include "../remote/mslan_proto.h"
#endif
#if (defined WIN_NT || defined WINDOWS_ONLY)
#include "../remote/wnet_proto.h"
#ifdef  XNET
#include "../remote/xnet_proto.h"
#endif
#include "../remote/spxnet32_proto.h"
#endif
#ifdef mpexl
#include "../remote/ipc_proto.h"
#endif
#if (defined ultrix || defined DECOSF)
#include "../remote/dnet_proto.h"
#endif
#ifdef VMS
#include "../remote/decne_proto.h"
#endif
#ifdef SPX
*/
/* SPX is defined only for 16bit windows */
/*#include "../remote/spxwi_proto.h"
#endif
*/

/*
#define GDS_ATTACH_DATABASE	REM_attach_database
#define GDS_BLOB_INFO		REM_blob_info
#define GDS_CANCEL_BLOB		REM_cancel_blob
#define GDS_CLOSE_BLOB		REM_close_blob
#define GDS_COMMIT		REM_commit_transaction
#define GDS_COMMIT_RETAINING	REM_commit_retaining
#define GDS_COMPILE		REM_compile_request
#define GDS_CREATE_BLOB2	REM_create_blob2
#define GDS_CREATE_DATABASE	REM_create_database
#define GDS_CANCEL_EVENTS	REM_cancel_events
#define GDS_DATABASE_INFO	REM_database_info
#define GDS_DDL			REM_ddl
#define GDS_DETACH		REM_detach_database
#define GDS_DROP_DATABASE	REM_drop_database
#define GDS_GET_SEGMENT		REM_get_segment
#define GDS_GET_SLICE		REM_get_slice
#define GDS_OPEN_BLOB2		REM_open_blob2
#define GDS_PREPARE		REM_prepare_transaction
#define GDS_PUT_SEGMENT		REM_put_segment
#define GDS_PUT_SLICE		REM_put_slice
#define GDS_QUE_EVENTS		REM_que_events
#define GDS_RECEIVE		REM_receive
#define GDS_RECONNECT		REM_reconnect_transaction
#define GDS_RELEASE_REQUEST	REM_release_request
#define GDS_REQUEST_INFO	REM_request_info
#define GDS_ROLLBACK_RETAINING	REM_rollback_retaining
#define GDS_ROLLBACK		REM_rollback_transaction
#define GDS_SEEK_BLOB		REM_seek_blob
#define GDS_SEND		REM_send
#define GDS_SERVICE_ATTACH	REM_service_attach
#define GDS_SERVICE_DETACH	REM_service_detach
#define GDS_SERVICE_QUERY	REM_service_query
#define GDS_SERVICE_START	REM_service_start
#define GDS_START_AND_SEND	REM_start_and_send
#define GDS_START		REM_start_request
#define GDS_START_TRANSACTION	REM_start_transaction
#define GDS_TRANSACT_REQUEST	REM_transact_request
#define GDS_TRANSACTION_INFO	REM_transaction_info
#define GDS_UNWIND		REM_unwind_request
*/

/* DSQL definitions */

/*
#define GDS_DSQL_ALLOCATE	REM_allocate_statement
#define GDS_DSQL_EXECUTE	REM_execute
#define GDS_DSQL_EXECUTE2	REM_execute2
#define GDS_DSQL_EXECUTE_IMMED	REM_execute_immediate
#define GDS_DSQL_EXECUTE_IMMED2	REM_execute_immediate2
#define GDS_DSQL_FETCH		REM_fetch
#define GDS_DSQL_FREE		REM_free_statement
#define GDS_DSQL_INSERT		REM_insert
#define GDS_DSQL_PREPARE	REM_prepare
#define GDS_DSQL_SET_CURSOR	REM_set_cursor_name
#define GDS_DSQL_SQL_INFO	REM_sql_info
*/


extern STATUS REM_attach_database (
    STATUS	*user_status,
    SSHORT	file_length,
    SCHAR	*file_name,
    RDB		*handle,
    SSHORT	dpb_length,
    SCHAR	*dpb,
    UCHAR	*expanded_filename);

extern STATUS REM_blob_info (
    STATUS	*user_status,
    RBL		*blob_handle,
    SSHORT	item_length,
    SCHAR	*items,
    SSHORT	buffer_length,
    SCHAR	*buffer);

extern STATUS REM_cancel_blob (
    STATUS	*user_status,
    RBL		*blob_handle);

extern STATUS REM_cancel_events (
    STATUS	*user_status,
    RDB		*handle,
    SLONG	*id);

extern STATUS REM_close_blob (
    STATUS	*user_status,
    RBL		*blob_handle);

extern STATUS REM_commit_transaction (
    STATUS	*user_status,
    RTR		*rtr_handle);

extern STATUS REM_commit_retaining (
    STATUS	*user_status,
    RTR		*rtr_handle);

extern STATUS REM_compile_request (
    STATUS	*user_status,
    RDB		*db_handle,
    RRQ		*req_handle,
    USHORT	blr_length,
    UCHAR	*blr);

extern STATUS REM_create_blob2 (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*rtr_handle,
    RBL		*blob_handle,
    BID		blob_id,
    USHORT	bpb_length,
    UCHAR	*bpb);

extern STATUS REM_create_database (
    STATUS	*user_status,
    SSHORT	file_length,
    SCHAR	*file_name,
    RDB		*handle,
    SSHORT	dpb_length,
    SCHAR	*dpb,
    SSHORT	db_type,
    UCHAR	*expanded_filename);

extern STATUS REM_database_info (
    STATUS	*user_status,
    RDB		*handle,
    SSHORT	item_length,
    SCHAR	*items,
    SSHORT	buffer_length,
    SCHAR	*buffer);

extern STATUS REM_ddl (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*rtr_handle,
    USHORT	blr_length,
    UCHAR	*blr);

extern STATUS REM_detach_database (
    STATUS	*user_status,
    RDB		*handle);

extern STATUS REM_drop_database (
    STATUS	*user_status,
    RDB		*handle);

extern STATUS REM_allocate_statement (
    STATUS	*user_status,
    RDB		*db_handle,
    RSR		*stmt_handle);

extern STATUS REM_execute (
    STATUS	*user_status,
    RTR		*rtr_handle,
    RSR		*stmt_handle,
    USHORT	blr_length,
    UCHAR	*blr,
    USHORT	msg_type,
    USHORT	msg_length,
    UCHAR	*msg);

extern STATUS REM_execute2 (
    STATUS	*user_status,
    RTR		*rtr_handle,
    RSR		*stmt_handle,
    USHORT	in_blr_length,
    UCHAR	*in_blr,
    USHORT	in_msg_type,
    USHORT	in_msg_length,
    UCHAR	*in_msg,
    USHORT	out_blr_length,
    UCHAR	*out_blr,
    USHORT	out_msg_type,
    USHORT	out_msg_length,
    UCHAR	*out_msg);

extern STATUS REM_execute_immediate (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*rtr_handle,
    USHORT	length,
    TEXT	*string,
    USHORT	dialect,
    USHORT	blr_length,
    UCHAR	*blr,
    USHORT	msg_type,
    USHORT	msg_length,
    UCHAR	*msg);

extern STATUS REM_execute_immediate2 (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*rtr_handle,
    USHORT	length,
    TEXT	*string,
    USHORT	dialect,
    USHORT	in_blr_length,
    UCHAR	*in_blr,
    USHORT	in_msg_type,
    USHORT	in_msg_length,
    UCHAR	*in_msg,
    USHORT	out_blr_length,
    UCHAR	*out_blr,
    USHORT	out_msg_type,
    USHORT	out_msg_length,
    UCHAR	*out_msg);

extern STATUS REM_fetch (
    STATUS	*user_status,
    RSR		*stmt_handle,
    USHORT	blr_length,
    UCHAR	*blr,
    USHORT	msg_type,
    USHORT	msg_length,
    UCHAR	*msg);

extern STATUS REM_free_statement (
    STATUS	*user_status,
    RSR		*stmt_handle,
    USHORT	option);

extern STATUS REM_insert (
    STATUS	*user_status,
    RSR		*stmt_handle,
    USHORT	blr_length,
    UCHAR	*blr,
    USHORT	msg_type,
    USHORT	msg_length,
    UCHAR	*msg);

extern STATUS REM_prepare (
    STATUS	*user_status,
    RTR		*rtr_handle,
    RSR		*stmt_handle,	/* a remote statement block */
    USHORT	length,
    TEXT	*string,
    USHORT	dialect,
    USHORT	item_length,
    SCHAR	*items,
    USHORT	buffer_length,
    SCHAR	*buffer);

extern STATUS REM_set_cursor_name (
    STATUS	*user_status,
    RSR		*stmt_handle,
    TEXT	*cursor,
    USHORT	type);

extern STATUS REM_sql_info (
    STATUS	*user_status,
    RSR		*stmt_handle,
    SSHORT	item_length,
    SCHAR	*items,
    SSHORT	buffer_length,
    SCHAR	*buffer);

extern STATUS REM_get_segment (
    STATUS	*user_status,
    RBL		*blob_handle,
    USHORT	*length,
    USHORT	buffer_length,
    UCHAR	*buffer);

extern STATUS REM_get_slice (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*tra_handle,
    BID		array_id,
    USHORT	sdl_length,
    UCHAR	*sdl,
    USHORT	param_length,
    UCHAR	*param,
    SLONG	slice_length,
    UCHAR	*slice,
    SLONG	*return_length);

extern STATUS REM_open_blob2 (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*rtr_handle,
    RBL		*blob_handle,
    BID		blob_id,
    USHORT	bpb_length,
    UCHAR	*bpb);

extern STATUS REM_prepare_transaction (
    STATUS	*user_status,
    RTR		*rtr_handle,
    USHORT	msg_length,
    UCHAR	*msg);

extern STATUS REM_put_segment (
    STATUS	*user_status,
    RBL		*blob_handle,
    USHORT	segment_length,
    UCHAR	*segment);

extern STATUS REM_put_slice (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*tra_handle,
    BID		array_id,
    USHORT	sdl_length,
    UCHAR	*sdl,
    USHORT	param_length,
    UCHAR	*param,
    SLONG	slice_length,
    UCHAR	*slice);

extern STATUS REM_que_events (
    STATUS	*user_status,
    RDB		*handle,
    SLONG	*id,
    SSHORT	length,
    UCHAR	*items,
    void	(*ast)(),
    void	*arg);

extern STATUS REM_receive (
    STATUS	*user_status,
    RRQ		*req_handle,
    USHORT	msg_type,
    USHORT	msg_length,
    UCHAR	*msg,
    SSHORT	level
#ifdef SCROLLABLE_CURSORS
    , 
    USHORT	direction, 
    ULONG	offset
#endif
    );

extern STATUS REM_reconnect_transaction (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*rtr_handle,
    USHORT	length,
    UCHAR	*id);

extern STATUS REM_release_request (
    STATUS	*user_status,
    RRQ		*req_handle);

extern STATUS REM_request_info (
    STATUS	*user_status,
    RRQ		*req_handle,
    SSHORT	level,
    SSHORT	item_length,
    UCHAR	*items,
    SSHORT	buffer_length,
    UCHAR	*buffer);

extern STATUS REM_rollback_retaining (
    STATUS	*user_status,
    RTR		*rtr_handle);

extern STATUS REM_rollback_transaction (
    STATUS	*user_status,
    RTR		*rtr_handle);

extern STATUS REM_seek_blob (
    STATUS	*user_status,
    RBL		*blob_handle,
    SSHORT	mode,
    SLONG	offset,
    SLONG	*result);

extern STATUS REM_send (
    STATUS	*user_status,
    RRQ		*req_handle,
    USHORT	msg_type,
    USHORT	msg_length,
    UCHAR	*msg,
    SSHORT	level);

extern STATUS REM_service_attach (
    STATUS	*user_status,
    USHORT	service_length,
    TEXT	*service_name,
    RDB		*handle,
    USHORT	spb_length,
    SCHAR	*spb);

extern STATUS REM_service_detach (
    STATUS	*user_status,
    RDB		*handle);

extern STATUS REM_service_query (
    STATUS	*user_status,
    RDB		*svc_handle,
    ULONG    	*reserved,
    USHORT	item_length,
    SCHAR	*items,
    USHORT	recv_item_length,
    SCHAR	*recv_items,
    USHORT	buffer_length,
    SCHAR	*buffer);

extern STATUS REM_service_start (
    STATUS	*user_status,
    RDB		*svc_handle,
    ULONG    	*reserved,
    USHORT	item_length,
    SCHAR	*items);

extern STATUS REM_start_and_send (
    STATUS	*user_status,
    RRQ		*req_handle,
    RTR		*rtr_handle,
    USHORT	msg_type,
    USHORT	msg_length,
    UCHAR	*msg,
    SSHORT	level);

extern STATUS REM_start_request (
    STATUS		*user_status,
    register RRQ	*req_handle,
    register RTR	*rtr_handle,
    USHORT		level);

extern STATUS REM_start_transaction (
    STATUS	*user_status,
    RTR		*rtr_handle,
    SSHORT	count,
    RDB		*db_handle,
    SSHORT	tpb_length,
    UCHAR	*tpb);

extern STATUS REM_transact_request (
    STATUS	*user_status,
    RDB		*db_handle,
    RTR		*rtr_handle,
    USHORT	blr_length,
    UCHAR	*blr,
    USHORT	in_msg_length,
    UCHAR	*in_msg,
    USHORT	out_msg_length,
    UCHAR	*out_msg);

extern STATUS REM_transaction_info (
    STATUS	*user_status,
    RTR		*tra_handle,
    SSHORT	item_length,
    UCHAR	*items,
    SSHORT	buffer_length,
    UCHAR	*buffer);

extern STATUS REM_unwind_request (
    STATUS	*user_status,
    RRQ		*req_handle,
    USHORT	level);
