#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (DSQL_yychar=(-1))
#define yyerrok (DSQL_yyerrflag=0)
#define YYRECOVERING (DSQL_yyerrflag!=0)
#define YYPREFIX "yy"
/* 
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		parse.y
 *	DESCRIPTION:	Dynamic SQL parser
 *
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 * 2001.05.20 Neil McCalden: Allow a udf to be used in a 'group by' clause.
 * 2001.05.30 Claudio Valderrama: DROP TABLE and DROP VIEW lead now to two
 *   different node types so DDL can tell which is which.
 * 2001.06.13 Claudio Valderrama: SUBSTRING is being surfaced.
 * 2001.06.30 Claudio valderrama: Feed (line,column) for each node. See node.h.
 * 2001.07.10 Claudio Valderrama: Better (line,column) report and "--" for comments.
 * 2001.07.28 John Bellardo: Changes to support parsing LIMIT and FIRST
 * 2001.08.03 John Bellardo: Finalized syntax for LIMIT, change LIMIT to SKIP
 * 2001.08.05 Claudio Valderrama: closed Bug #448062 and other spaces that appear
 *   in rdb$*_source fields when altering domains plus one unexpected null pointer.
 * 2001.08.12 Claudio Valderrama: adjust SUBSTRING's starting pos argument here
 *   and not in gen.c; this closes Bug #450301.
 * 2001.10.01 Claudio Valderrama: enable explicit GRANT...to ROLE role_name.
 * 2001.10.06 Claudio Valderrama: Honor explicit USER keyword in GRANTs and REVOKEs.
 */

#if defined(DEV_BUILD) && defined(WIN32) && defined(SUPERSERVER)
#include <windows.h>
/*#include <wincon.h>*/
#endif


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include <stdarg.h>

#include "../jrd/iberror.h"
#include "../dsql/dsql.h"
#include "../dsql/node.h"
#include "../dsql/sym.h"
#include "../jrd/gds.h"
#include "../jrd/flags.h"
#include "../dsql/alld_proto.h"
#include "../dsql/errd_proto.h"
#include "../dsql/hsh_proto.h"
#include "../dsql/make_proto.h"
#include "../dsql/parse_proto.h"
#include "../jrd/gds_proto.h"
#include "../jrd/thd_proto.h"
#ifndef WINDOWS_ONLY
#include "../wal/wal.h"
#endif

/* Can't include ../jrd/err_proto.h here because it pulls jrd.h. */
#if !defined(_JRD_ERR_PROTO_H_)
extern TEXT * DLL_EXPORT ERR_string (TEXT *, int);
#endif


ASSERT_FILENAME

/* Remove compiler warning produced by redef of WRITE & READ from WINDOWS.H */
#ifdef WINDOWS_ONLY
#undef READ
#undef WRITE
#endif

/* since UNIX isn't standard, we have to define
   stuff which is in <limits.h> (which isn't available
   on all UNIXes... */

#define SHRT_POS_MAX		32767
#define SHRT_UNSIGNED_MAX	65535
#define SHRT_NEG_MAX		32768
#define LONG_POS_MAX		2147483647
#define POSITIVE		0
#define NEGATIVE		1
#define UNSIGNED		2

#define MIN_CACHE_BUFFERS       250
#define DEF_CACHE_BUFFERS       1000

/* Fix 69th procedure problem - solution from Oleg Loa */
#define YYSTACKSIZE		2048
#define YYMAXDEPTH		2048

#define YYSTYPE		NOD
#if defined(DEBUG) || defined(DEV_BUILD)
#define YYDEBUG		1
#endif

static CONST UCHAR
	INTERNAL_FIELD_NAME [] = "DSQL internal"; /* NTX: placeholder */
static CONST UCHAR
	NULL_STRING [] = "";	

#ifndef SHLIB_DEFS
NOD		DSQL_parse;
#else
extern NOD	DSQL_parse;
#endif

static FLD	g_field;
static FIL	g_file;
static NOD	g_field_name;
static TEXT	*beginning;
static SSHORT	log_defined, cache_defined;
static void	yyerror (TEXT *);

#define ACTIVE 257
#define ADD 258
#define AFTER 259
#define ALL 260
#define ALTER 261
#define AND 262
#define ANY 263
#define AS 264
#define ASC 265
#define AT 266
#define AVG 267
#define AUTO 268
#define BASENAME 269
#define BEFORE 270
#define BEGIN 271
#define BETWEEN 272
#define BLOB 273
#define BY 274
#define CACHE 275
#define CAST 276
#define CHARACTER 277
#define CHECK 278
#define CHECK_POINT_LEN 279
#define COLLATE 280
#define COLLATION 281
#define COMMA 282
#define COMMIT 283
#define COMMITTED 284
#define COMPUTED 285
#define CONCATENATE 286
#define CONDITIONAL 287
#define CONSTRAINT 288
#define CONTAINING 289
#define COUNT 290
#define CREATE 291
#define CSTRING 292
#define CURRENT 293
#define CURSOR 294
#define DATABASE 295
#define DATE 296
#define DB_KEY 297
#define DEBUG 298
#define DECIMAL 299
#define DECLARE 300
#define DEFAULT 301
#define DELETE 302
#define DESC 303
#define DISTINCT 304
#define DO 305
#define DOMAIN 306
#define DROP 307
#define ELSE 308
#define END 309
#define ENTRY_POINT 310
#define EQL 311
#define ESCAPE 312
#define EXCEPTION 313
#define EXECUTE 314
#define EXISTS 315
#define EXIT 316
#define EXTERNAL 317
#define FILTER 318
#define FOR 319
#define FOREIGN 320
#define FROM 321
#define FULL 322
#define FUNCTION 323
#define GDSCODE 324
#define GEQ 325
#define GENERATOR 326
#define GEN_ID 327
#define GRANT 328
#define GROUP 329
#define GROUP_COMMIT_WAIT 330
#define GTR 331
#define HAVING 332
#define IF 333
#define IN 334
#define INACTIVE 335
#define INNER 336
#define INPUT_TYPE 337
#define INDEX 338
#define INSERT 339
#define INTEGER 340
#define INTO 341
#define IS 342
#define ISOLATION 343
#define JOIN 344
#define KEY 345
#define KW_CHAR 346
#define KW_DEC 347
#define KW_DOUBLE 348
#define KW_FILE 349
#define KW_FLOAT 350
#define KW_INT 351
#define KW_LONG 352
#define KW_NULL 353
#define KW_NUMERIC 354
#define KW_UPPER 355
#define KW_VALUE 356
#define LENGTH 357
#define LOGFILE 358
#define LPAREN 359
#define LEFT 360
#define LEQ 361
#define LEVEL 362
#define LIKE 363
#define LOG_BUF_SIZE 364
#define LSS 365
#define MANUAL 366
#define MAXIMUM 367
#define MAX_SEGMENT 368
#define MERGE 369
#define MESSAGE 370
#define MINIMUM 371
#define MODULE_NAME 372
#define NAMES 373
#define NATIONAL 374
#define NATURAL 375
#define NCHAR 376
#define NEQ 377
#define NO 378
#define NOT 379
#define NOT_GTR 380
#define NOT_LSS 381
#define NUM_LOG_BUFS 382
#define OF 383
#define ON 384
#define ONLY 385
#define OPTION 386
#define OR 387
#define ORDER 388
#define OUTER 389
#define OUTPUT_TYPE 390
#define OVERFLOW 391
#define PAGE 392
#define PAGES 393
#define PAGE_SIZE 394
#define PARAMETER 395
#define PASSWORD 396
#define PLAN 397
#define POSITION 398
#define POST_EVENT 399
#define PRECISION 400
#define PRIMARY 401
#define PRIVILEGES 402
#define PROCEDURE 403
#define PROTECTED 404
#define RAW_PARTITIONS 405
#define READ 406
#define REAL 407
#define RECREATE 408
#define REFERENCES 409
#define RESERVING 410
#define RETAIN 411
#define RETURNING_VALUES 412
#define RETURNS 413
#define REVOKE 414
#define RIGHT 415
#define RPAREN 416
#define ROLLBACK 417
#define SEGMENT 418
#define SELECT 419
#define SET 420
#define SHADOW 421
#define SHARED 422
#define SINGULAR 423
#define SIZE 424
#define SMALLINT 425
#define SNAPSHOT 426
#define SOME 427
#define SORT 428
#define SQLCODE 429
#define STABILITY 430
#define STARTING 431
#define STATISTICS 432
#define SUB_TYPE 433
#define SUSPEND 434
#define SUM 435
#define TABLE 436
#define THEN 437
#define TO 438
#define TRANSACTION 439
#define TRIGGER 440
#define UNCOMMITTED 441
#define UNION 442
#define UNIQUE 443
#define UPDATE 444
#define USER 445
#define VALUES 446
#define VARCHAR 447
#define VARIABLE 448
#define VARYING 449
#define VERSION 450
#define VIEW 451
#define WAIT 452
#define WHEN 453
#define WHERE 454
#define WHILE 455
#define WITH 456
#define WORK 457
#define WRITE 458
#define FLOAT 459
#define NUMBER 460
#define NUMERIC 461
#define SYMBOL 462
#define STRING 463
#define INTRODUCER 464
#define ACTION 465
#define ADMIN 466
#define CASCADE 467
#define FREE_IT 468
#define RESTRICT 469
#define ROLE 470
#define COLUMN 471
#define TYPE 472
#define EXTRACT 473
#define YEAR 474
#define MONTH 475
#define DAY 476
#define HOUR 477
#define MINUTE 478
#define SECOND 479
#define WEEKDAY 480
#define YEARDAY 481
#define TIME 482
#define TIMESTAMP 483
#define CURRENT_DATE 484
#define CURRENT_TIME 485
#define CURRENT_TIMESTAMP 486
#define CURRENT_USER 487
#define CURRENT_ROLE 488
#define KW_BREAK 489
#define SUBSTRING 490
#define KW_DESCRIPTOR 491
#define FIRST 492
#define SKIP 493
#define NUMBER64BIT 494
#define SCALEDINT 495
#define YYERRCODE 256
static short yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    9,
    9,    9,    9,    9,   20,   20,   19,   19,   19,   30,
   30,   23,   31,   31,   31,   31,   31,   22,   22,   28,
   28,   24,   13,   13,   13,   13,   13,   13,   13,   34,
   25,   25,   25,   25,   35,   35,   35,   35,   21,   21,
   36,   36,   36,   26,   26,   41,   27,   27,   42,   42,
    6,   43,   43,   45,   50,   50,   50,   47,   47,   47,
   54,   54,   55,   55,   48,   48,   57,   57,   57,   57,
   57,   44,    5,   60,   60,   60,   60,   60,   60,   60,
   60,   60,   60,   60,   12,   75,   75,   62,   62,   65,
   65,   65,   73,   84,   84,   84,   85,   85,   86,   86,
   87,   87,   91,   91,   72,   94,   94,   96,   96,   97,
   97,  100,  100,  101,  102,  102,  103,  104,   70,   74,
   71,   88,   88,  107,  108,  108,  110,  110,  111,  111,
  111,  111,  111,  109,  109,  112,  112,  113,  113,  113,
  113,  115,  115,  115,  115,  114,  114,  119,  119,  118,
   92,  120,  120,  121,  124,  125,  125,  126,  122,  123,
  123,  127,  127,  128,  128,  129,  129,  129,   90,   90,
   90,   67,   77,  130,  130,  130,  131,  131,  132,  132,
  133,  133,  133,  139,   80,   80,  135,  135,   98,   98,
   93,  143,  144,   56,  136,  136,   99,   99,   99,   99,
   99,  137,  137,  150,  150,  151,  153,  153,  153,  153,
  153,  134,  152,  152,  156,  156,  156,  156,  158,  159,
  160,  155,  154,  154,  154,  154,  154,  161,  162,  163,
  163,  163,  163,   66,   76,  168,  164,  164,  165,  165,
  169,  169,  170,  166,  166,  171,  171,  172,  173,  173,
  167,  167,  175,  175,  174,  174,  174,  174,  174,  174,
  174,  174,  174,  174,  174,  174,  174,  174,  178,  179,
  180,  180,  181,  187,  183,  183,  183,  184,  184,  184,
  189,  189,  189,  189,  189,  189,  189,  189,  185,  185,
  185,  185,  182,  186,  186,  176,  176,  192,  193,  193,
  194,  194,  194,  194,   11,  196,  196,  196,  197,  197,
  197,  197,  197,  197,   69,  199,  202,  202,  202,  203,
  207,  212,  212,  213,  213,  214,  214,  141,  201,   81,
   83,  200,  200,   68,  217,  217,  217,  218,  218,  218,
  218,  218,  218,  219,  219,  220,    2,  222,  222,  222,
  222,  222,  222,  222,  230,  231,  228,  228,  232,  232,
  232,  232,  232,  232,  232,  223,  223,  233,  233,  233,
  233,  233,  233,  233,  227,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  235,  235,  237,
  237,  236,  234,  234,  234,  229,  229,  225,  226,  226,
  239,  239,  239,  239,  240,  240,  224,  241,  241,  242,
  242,    8,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,   95,   95,  138,  138,  246,  246,
  249,  249,  251,  251,   51,   51,  248,  248,  248,  248,
  248,  248,  248,  248,  256,  256,  247,  247,  247,  247,
  257,  257,   59,   59,   59,   53,   53,  253,  253,  253,
  250,  250,  250,  261,  261,  261,  260,  260,  259,  259,
  259,  254,  254,  264,  262,  262,  262,  263,  263,  255,
  255,  255,  255,  265,  265,   16,   16,   16,  267,  267,
  267,    4,   14,  269,  269,  270,  270,  271,  271,  266,
  272,  272,  273,  273,  274,  274,  274,  274,  275,  275,
  276,  276,  277,  277,  279,  279,  279,  280,  280,  280,
  281,  281,  281,  278,  283,  283,  283,  284,  284,  282,
  282,  285,  287,  287,  286,  286,  268,   15,  288,  288,
  288,  289,  289,  292,  292,  293,  293,   63,   63,   63,
  290,  290,  294,  294,  291,  205,  205,  206,  206,  297,
  297,  298,  298,  298,  295,  301,  301,  302,  302,  303,
  303,  304,  304,  305,  305,  307,  307,  308,  308,  215,
  215,   29,  216,  216,  216,  216,  216,  216,  216,  216,
  309,  309,  309,  310,  310,  310,  204,  204,  204,  204,
  209,  209,  311,  311,  312,  312,  312,  210,  210,  208,
  208,  211,  211,  314,  315,  315,  315,  315,  315,  316,
  316,  317,  317,  318,  318,  319,  319,  319,  320,  320,
   10,   10,  321,  321,    7,    7,  322,  323,  324,   17,
   17,  325,  326,  327,  327,  177,  299,  299,    3,    3,
  329,  329,  329,  331,  331,   59,  330,  330,  332,  332,
   32,   32,   79,   78,   78,  190,  190,  190,  140,  328,
  328,  105,  105,  105,  105,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  335,  335,  335,  335,
  335,  335,  335,  335,  340,  340,  340,  340,  340,  340,
  340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
  346,  346,  336,  336,  337,  337,  337,  337,  338,  338,
  342,  342,  343,  343,  343,  343,  341,  344,  339,  339,
  347,  347,  345,  349,   82,   82,   82,   82,   82,   82,
   82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
   82,   82,   82,   82,   82,   82,   82,  149,  149,  149,
  350,  353,  353,  145,  145,  354,  354,  354,  354,  354,
  352,  352,  352,  352,  352,  348,  348,  348,  348,  348,
  348,  348,  348,  198,  146,  146,  147,   49,   49,   18,
   18,  221,  355,   52,  117,  252,  252,   89,  351,  351,
  351,  351,  351,  351,  351,  351,  351,  351,  351,  351,
  351,  351,  351,  351,  351,  313,  313,  356,  356,  356,
  356,  356,  356,  356,  356,  296,  296,  148,   46,  258,
  116,  142,  333,  157,  191,  245,   61,   58,  195,  106,
   64,  300,   33,   39,  306,  244,   37,   40,  188,   38,
};
static short yylen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    7,
    8,    6,    7,    5,    1,    2,    1,    2,    1,    1,
    3,    1,    1,    1,    1,    2,    2,    3,    0,    3,
    0,    1,    7,    8,    6,    7,    6,    7,    4,    3,
    1,    3,    3,    3,    2,    2,    2,    2,    1,    3,
    1,    2,    2,    1,    3,    1,    1,    3,    1,    2,
    2,    2,    3,    8,    1,    1,    5,    0,    1,    3,
    1,    3,    2,    4,    1,    3,    2,    3,    4,    4,
    2,    9,    2,    3,    7,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    1,    0,    1,
    1,    6,    6,    1,    1,    0,    0,    1,    0,    4,
    0,    1,    1,    2,    8,    1,    0,    3,    0,    0,
    1,    1,    2,    1,    1,    1,    2,    6,    1,    1,
    3,    0,    1,    1,    0,    1,    1,    2,    3,    4,
    2,    2,    3,    0,    1,    1,    2,    1,    1,    1,
    4,    3,    3,    3,    3,    1,    1,    6,    3,    1,
    3,    1,    3,    2,    1,    0,    2,    3,    1,    0,
    1,    1,    2,    3,    4,    0,    1,    2,    0,    1,
    1,    5,    5,    3,    2,    0,    1,    3,    1,    1,
    6,    3,    2,    6,    2,    1,    2,    2,    2,    0,
    1,    1,    2,    0,    2,    0,    1,    1,    1,    1,
    1,    0,    1,    1,    2,    2,    2,    4,    1,    1,
    2,    2,    2,    0,    1,    1,    1,    1,    2,    3,
    7,    6,    1,    1,    2,    2,    0,    3,    3,    1,
    2,    2,    2,    8,    8,    8,    3,    0,    2,    0,
    1,    3,    2,    1,    0,    1,    2,    5,    1,    1,
    3,    4,    1,    2,    2,    2,    3,    1,    1,    1,
    2,    3,    1,    2,    1,    2,    2,    2,    6,    7,
    8,    6,    4,    2,    1,    3,    0,    2,    4,    0,
    1,    1,    1,    1,    3,    3,    3,    3,    1,    1,
    3,    3,    6,    3,    0,    1,    2,    4,    1,    3,
    2,    2,    2,    1,    4,    1,    3,    0,    1,    1,
    1,    3,    3,    3,    7,    1,    1,    3,    4,    9,
    2,    1,    3,    1,    1,    6,    3,    0,    0,    0,
    0,    3,    0,    9,    1,    1,    0,    2,    2,    2,
    2,    2,    2,    2,    0,    4,    2,    3,    3,    2,
    2,    3,    3,    2,    3,    6,    1,    2,    4,    3,
    2,    2,    2,    2,    3,    1,    3,    3,    3,    2,
    2,    4,    4,    5,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
    2,    1,    1,    1,    0,    2,    2,    0,    1,    2,
    2,    2,    2,    2,    1,    3,    7,    1,    0,    1,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    3,    2,    2,    2,    1,    1,    1,    1,    4,    5,
    1,    3,    1,    3,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    4,    4,    6,    5,
    3,    0,    2,    2,    0,    3,    0,    4,    1,    5,
    4,    1,    4,    1,    2,    2,    1,    1,    1,    2,
    2,    2,    2,    1,    0,    3,    5,    1,    1,    2,
    3,    1,    2,    3,    0,    1,    1,    1,    5,    5,
    6,    3,    2,    1,    0,    2,    0,    1,    0,    3,
    1,    0,    1,    2,    1,    1,    1,    1,    2,    2,
    1,    2,    3,    1,    1,    3,    3,    1,    2,    3,
    1,    2,    0,    2,    1,    1,    0,    1,    1,    1,
    3,    2,    3,    0,    1,    3,    4,    3,    1,    3,
    4,    3,    0,    1,    3,    3,    3,    1,    1,    0,
    3,    0,    2,    0,    9,    1,    1,    1,    1,    1,
    3,    1,    2,    3,    2,    1,    3,    1,    1,    6,
    3,    3,    2,    3,    0,    1,    3,    1,    1,    1,
    2,    1,    1,    1,    2,    1,    2,    1,    2,    0,
    2,    4,    2,    2,    4,    2,    2,    1,    1,    0,
    3,    0,    1,    3,    1,    1,    3,    2,    0,    2,
    0,    2,    0,    4,    1,    2,    1,    1,    0,    1,
    3,    2,    1,    1,    2,    1,    4,    2,    1,    3,
    8,    5,    1,    3,    1,    1,    4,    4,    4,    1,
    1,    5,    5,    1,    3,    3,    1,    1,    7,    7,
    5,    3,    0,    1,    1,    1,    2,    0,    1,    1,
    1,    0,    3,    1,    3,    1,    3,    3,    1,    1,
    3,    1,    3,    3,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    1,    1,    5,    6,    3,    4,    5,    6,    3,    4,
    3,    4,    3,    4,    4,    5,    4,    4,    3,    4,
    3,    3,    9,    9,    1,    1,    1,    1,    1,    1,
    1,    2,    2,    3,    3,    3,    3,    3,    3,    3,
    3,    1,    1,    1,    3,    1,    1,    1,    1,    1,
    4,    1,    3,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    2,    2,    2,    1,    1,    1,    1,    3,
    3,    3,    3,    1,    1,    1,    1,    1,    2,    1,
    2,    1,    1,    1,    1,    1,    2,    1,    4,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    6,
    4,    6,    6,    6,    8,    4,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    0,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
};
static short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,  516,  517,  518,    0,  569,
  665,  666,  670,  671,  428,    0,    0,    0,    0,    0,
    0,  367,  524,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  108,    0,    0,   93,    0,  822,    0,   19,
  820,    0,    0,   71,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  442,    0,    0,
   35,   32,   34,    0,   33,    0,  874,    0,    0,    0,
    0,   30,   66,   64,    0,    0,    0,    0,    0,  105,
    0,    0,    0,    0,    0,  523,    0,    0,    0,    0,
  629,    0,    0,    0,  876,  610,    0,    0,    2,    0,
    0,    0,    0,  414,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,  415,  416,  417,    0,  395,  867,    0,  871,
    0,  374,  873,    0,  371,    0,  612,  877,    0,  370,
    0,  522,  818,    0,  144,  101,    0,  863,  102,    0,
  211,  699,    0,  870,  100,  139,    0,   96,    0,  103,
  824,    0,   97,    0,   98,  880,    0,   99,  140,  104,
  578,  579,    0,  823,  821,    0,  868,   72,    0,    0,
  866,  450,  443,    0,  449,  454,  444,  445,  452,  446,
  447,  448,  453,    0,   28,    0,   37,  691,   36,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  106,    0,
  107,    0,    0,    0,    0,    0,    0,  828,    0,  814,
  621,  623,    0,  624,  626,  856,  586,    0,  587,  627,
    0,    0,    0,    0,    0,    0,    0,  541,  530,    0,
  533,  535,  536,  537,  538,  544,  545,    0,  875,  611,
    0,    0,  570,    0,  568,    0,    0,    0,    0,  429,
    0,    0,  350,    0,  214,    0,  377,  368,  426,  427,
    0,    0,    0,    0,    0,    0,  386,    0,  355,  356,
    0,  528,  526,  819,    0,    0,    0,    0,    0,    0,
    0,  147,  126,    0,   94,    0,  115,  114,    0,    0,
    0,    0,    0,    0,  859,   73,    0,    0,    0,  667,
  668,  451,    0,  858,  798,  797,  796,    0,    0,  799,
  800,    0,    0,  802,  330,  331,  325,    0,  329,  794,
  801,    0,  694,    0,    0,   25,    0,    0,  878,    0,
   69,   67,   65,   31,    0,    0,    0,    0,    0,   50,
    0,    0,    0,    0,    0,    0,    0,    0,  784,    0,
    0,  786,    0,    0,    0,  815,    0,    0,  788,  789,
  790,  816,  817,    0,    0,    0,    0,    0,    0,    0,
  696,  782,  783,  787,  770,    0,  769,    0,  771,  766,
  767,  768,    0,  589,    0,  678,    0,    0,  590,    0,
    0,  567,    0,  542,    0,  539,    0,  540,  565,    0,
  560,    0,    0,  534,    0,  700,  674,    0,    0,    0,
  504,    0,    0,    0,  574,    0,  571,    0,  179,    0,
    0,  123,  434,  166,  167,    0,  432,    0,    0,    0,
    0,  435,    0,  430,    0,    0,  381,  383,  382,    0,
  384,    0,  378,  212,    0,    0,  261,    0,    0,    0,
    0,  390,  391,    0,  419,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  438,    0,  143,    0,    0,  152,
    0,  151,    0,  158,  141,    0,  156,  159,  160,  148,
    0,    0,  472,  508,  475,    0,  509,    0,    0,  476,
    0,    0,    0,  499,  512,  471,  494,  473,  474,  457,
  350,  455,  456,  458,    0,    0,  467,  468,  469,  470,
    0,    0,    0,    0,    0,  118,    0,    0,  195,    0,
    0,  348,    0,  214,    0,    0,   81,    0,    0,  686,
    0,    0,    0,    0,    0,    0,    0,    0,  702,  706,
  707,  708,  709,  710,  711,  712,  713,  714,  715,  803,
  804,  805,  795,    0,    0,    0,  693,   26,    0,    0,
   42,   70,    0,    0,   24,    0,    0,  662,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  879,  294,    0,    0,    0,    0,    0,    0,    0,  622,
    0,    0,  625,    0,    0,    0,    0,  872,  593,  520,
    0,  826,  519,    0,  543,    0,  551,  547,  546,    0,
    0,    0,  562,  550,    0,    0,  672,  673,    0,    0,
    0,    0,    0,    0,    0,  581,    0,    0,  124,    0,
    0,    0,    0,    0,    0,  350,  380,    0,  350,  351,
  385,  465,    0,  263,    0,  257,  259,  348,  864,  233,
    0,    0,  350,    0,    0,  203,  348,    0,    0,    0,
    0,  238,  232,  235,  236,  237,  389,  424,  423,  388,
  387,    0,    0,    0,  363,  359,  361,  362,  358,  360,
    0,  350,    0,  149,  153,    0,  157,    0,    0,  495,
  496,  513,    0,  510,    0,    0,  502,  500,  501,    0,
    0,    0,    0,  466,    0,    0,    0,    0,  503,  348,
    0,  194,    0,  197,  199,  200,    0,    0,    0,    0,
    0,  214,   76,    0,    0,   75,  860,  483,  484,    0,
    0,    0,  705,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  327,  333,  334,  332,  695,    0,    0,
    0,    0,    0,    0,    0,    0,   51,   59,   61,    0,
    0,   68,    0,    0,    0,    0,  348,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  848,  849,  850,
  851,  852,  853,  854,  855,    0,    0,    0,  780,  781,
  847,    0,    0,  862,  776,    0,    0,    0,    0,    0,
    0,  785,  698,  697,    0,    0,    0,    0,  598,  599,
    0,    0,  591,  594,  521,  827,  552,  561,  556,  555,
    0,  566,  701,  675,  676,  209,  576,  577,  575,    0,
  175,  169,  176,    0,  172,    0,    0,  171,    0,  182,
  163,  162,  825,  165,  164,  436,    0,    0,    0,  379,
  262,    0,  205,  350,  207,    0,  351,  202,  208,    0,
    0,  239,    0,  392,  393,  350,  348,  351,  364,    0,
  190,  191,  150,    0,    0,    0,    0,    0,    0,  511,
    0,    0,  350,  351,    0,  461,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  192,    0,    0,
    0,    0,  337,    0,   80,    0,    0,    0,    0,   85,
   82,    0,    0,    0,  865,  669,    0,    0,  716,    0,
    0,    0,  742,  741,    0,    0,    0,  749,  759,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  704,
    0,   63,   55,   56,   62,   57,   58,    0,    0,   20,
    0,    0,    0,   40,    0,    0,    0,  680,  663,    0,
  679,    0,  193,    0,    0,    0,    0,    0,    0,  214,
    0,  829,    0,    0,  841,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  846,  791,    0,    0,    0,
    0,    0,    0,  613,    0,    0,    0,    0,    0,  558,
  559,  563,    0,    0,    0,    0,    0,    0,  183,    0,
    0,  375,  217,  218,  219,  220,  221,    0,    0,    0,
  266,    0,  215,    0,    0,  240,    0,  420,  421,  394,
  350,  440,  351,  861,  161,    0,    0,  478,    0,  477,
  514,    0,  506,    0,    0,    0,  459,    0,  486,    0,
    0,  488,  491,  493,    0,    0,  113,    0,  198,  350,
    0,    0,  349,    0,   95,    0,  111,    0,   91,    0,
    0,    0,    0,   84,    0,  757,  758,    0,    0,    0,
    0,  806,  808,  809,  807,    0,    0,  760,    0,    0,
    0,    0,    0,    0,    0,  750,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   54,   60,   52,   53,   21,  684,  685,    0,  682,
  689,  690,  687,    0,  661,    0,    0,    0,  835,  834,
    0,    0,  831,  830,    0,  839,  838,  837,  836,  833,
  832,    0,    0,    0,    0,  601,    0,  608,    0,  606,
  602,    0,  619,  615,  617,    0,    0,    0,    0,    0,
  177,  173,    0,    0,  188,  184,    0,  351,    0,    0,
  351,  267,    0,    0,    0,  224,    0,    0,    0,    0,
  437,  480,    0,  481,    0,  128,    0,    0,    0,  132,
  134,  135,  136,  462,  464,  460,  490,  351,    0,    0,
    0,    0,  335,    0,  338,  350,   86,    0,    0,   88,
    0,    0,    0,    0,    0,    0,  762,    0,  761,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   38,    0,  664,
  351,  213,  840,  842,  843,    0,  844,    0,    0,  604,
    0,    0,    0,  633,  636,    0,    0,  585,    0,  168,
  185,  351,  138,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  270,  273,
  269,    0,    0,  278,  279,  280,  283,  285,  256,    0,
  201,  225,    0,    0,    0,  230,  226,  229,    0,  351,
    0,  479,  507,  137,  125,  133,  254,  120,  351,    0,
  352,  339,    0,    0,   89,   90,   77,    0,  728,  736,
    0,  810,  812,  813,  811,  729,  737,  732,  740,    0,
    0,  730,  738,  731,  739,  725,  733,  726,  734,  727,
  735,  681,  255,    0,    0,  607,    0,    0,    0,  645,
  647,    0,  642,    0,  178,  376,    0,    0,    0,  287,
    0,    0,    0,  286,    0,  288,  276,  281,    0,  284,
  271,    0,  274,    0,  316,  275,  204,  227,  231,    0,
    0,  242,  366,  354,    0,    0,    0,   74,   92,    0,
  845,    0,    0,  637,  634,  646,    0,  268,  277,    0,
    0,    0,  282,    0,    0,  309,  310,  324,    0,    0,
    0,    0,  319,  272,  317,    0,    0,  241,    0,    0,
    0,    0,    0,  344,  345,    0,    0,    0,    0,    0,
  653,    0,    0,    0,    0,  302,  304,    0,  301,    0,
  303,    0,    0,    0,  293,    0,  323,  869,  322,  321,
    0,    0,  228,    0,    0,    0,  246,    0,  245,    0,
    0,    0,    0,    0,  112,    0,  764,  655,  644,    0,
    0,  656,    0,  652,    0,    0,    0,    0,    0,    0,
    0,    0,  312,  311,  318,  320,    0,    0,  250,  249,
  248,  347,    0,    0,    0,    0,  651,    0,  658,  296,
    0,    0,  289,  306,  308,  305,  307,    0,    0,    0,
  313,  253,  251,  252,    0,  340,    0,    0,    0,    0,
  314,  290,    0,    0,  763,    0,  657,  299,  291,    0,
  660,
};
static short yydgoto[] = {                                      18,
   19,   20,   21,   22,   23,   24, 1365,   26,   27, 1366,
   29,   30,   31,   32, 1367,   34, 1368,  570,   98,  365,
  815, 1040,   99,  600,  816,  100,  370,  605,  126,  101,
  102,  227,  876,  115,  817,  818,  169,  197,  103,  819,
  104,  372,   74,  208,  336,  409,  565,  978,  354,  775,
  540,  451,  754,  566,  567,  568,  980,  209, 1207,   66,
  159,   67,  203, 1608, 1155,  188,  193,  195,  198,  185,
  176,  179,  190,  200,  110,  239,  241,  362,  228,  702,
  476,  577,  920,  329,  557,  966, 1147,  508,  652,  943,
  461,  462,  491,  324,  541,  954, 1278,  671, 1102, 1279,
 1280, 1281, 1282, 1283,  578,  186,  177,  320,  515,  321,
  322,  516,  517,  518,  519, 1125,  914,  464,  465,  904,
  902,  466,  908,  903, 1093, 1251,  909,  910, 1098,  331,
  763,  764,  765,  766,  704,  927, 1264,  542,  706,  411,
  768,  865,  485, 1222, 1103,  412,  413,  426,  414, 1265,
 1266,  494, 1387, 1508,  712,  713,  700,  714,  715,  716,
 1509, 1510, 1580,  302,  489, 1109, 1369,  165,  486,  487,
 1110, 1111, 1370, 1371, 1372, 1464, 1373, 1374, 1375, 1376,
 1377, 1378, 1528, 1567, 1495, 1570,  415,  632, 1530,  416,
  986, 1465, 1502, 1503, 1539,  357,  358,  417,  971, 1153,
 1293,  972,  973,  119,  258,  427, 1476,  340, 1089, 1249,
 1348, 1512, 1513, 1514, 1515, 1087,  311,  505,  732, 1122,
  191,   52,  306,  170,  133,  289,  156,  296,  162,  690,
  687,  297,  307,  720,  308,  502,  938,  157,  290,  473,
  506, 1123,   88,  167,  212,  543,  544,  692,  955,  693,
  956,  957,  547,  548,  549,  550,  948,  779,  551,  552,
  553,  747,  554,  453,  744,   36,   37,   38,   54,  172,
  313,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  658,  440,  891, 1092,  441,  442,  663,   39,  132,  285,
   40,  454,  455,  676,  645,  259,  428,  429,  430,  649,
  877,  878,  879,  880, 1081,  418, 1239, 1240,  120,  121,
 1343, 1344,  419, 1521, 1444, 1522, 1523, 1524, 1564, 1609,
 1050,   41,   42,  341,   43,   44,  449,  450,  824, 1048,
 1209, 1213,  182,  579,  580,  581,  582,  583,  584,  585,
  586,  587,  588,  589, 1176,  996,  998, 1177,  630,  420,
  421,  422,  863,  361,  205,  856,
};
static short yysindex[] = {                                   4882,
  949, -180, 3839,   74, 1029,  -19, 3836,   24, 2133,  481,
  181,  715, 2438, -180,  915,  470,  -28,    0,  569,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  372,    0,
    0,    0,    0,    0,    0, 5883,  246,  361,  402,  -28,
  407,    0,    0,  327, -178,  422,  246,  509,  402,  441,
  -28,  407,    0,  641,  652,    0,  -49,    0,  501,    0,
    0,  763,  672,    0,  -28,  695,  246,  815,  672,  509,
  361,  402,  441,  -28,  407,  641,  652,    0,  402,  759,
    0,    0,    0, 1145,    0, 1145,    0,  808,  828,  138,
 1201,    0,    0,    0,  422,  -28,  422,  402,  -28,    0,
  878,  885,  923,  264,  -87,    0,   23,   41,  -25,  806,
    0,  509,  973, 1102,    0,    0,  921,  891,    0, 1109,
  -92, 1076,  -62,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  417,    0,    0, -178,    0,
  -29,    0,    0, 1375,    0,  543,    0,    0,  -23,    0,
 1004,    0,    0,  971,    0,    0, 1249,    0,    0, 1193,
    0,    0, -178,    0,    0,    0, 1375,    0,  -61,    0,
    0, 1154,    0, 1158,    0,    0, 1145,    0,    0,    0,
    0,    0, 1163,    0,    0, 1060,    0,    0, 1212, 1125,
    0,    0,    0, 1060,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1291,    0,  422,    0,    0,    0,  880,
 1127, -207,  652,  745, 1240, 1145, 1235, 1375,    0, 1154,
    0, 1269,  880, 1199, -207, 1225, 1230,    0, 6358,    0,
    0,    0, 6358,    0,    0,    0,    0, 5480,    0,    0,
 1165,  361, 1234, 1166,  532,  -28, 1187,    0,    0, 1102,
    0,    0,    0,    0,    0,    0,    0, 1170,    0,    0,
  161, 1214,    0, 1205,    0,  642, 1293,  708,  -62,    0,
 1373,  593,    0,  422,    0,  417,    0,    0,    0,    0,
  422, 1252, -114, 1200, -107, 1626,    0, 6113,    0,    0,
  524,    0,    0,    0, 1630, 1630, -178, 1314, -178, 2405,
 1249,    0,    0, 6682,    0, 1252,    0,    0, 1396, -150,
 1663,  -28, 1402,  361,    0,    0, 1670,  115, 3968,    0,
    0,    0, 1238,    0,    0,    0,    0, 1248, 1255,    0,
    0, 1219, 1388,    0,    0,    0,    0, 1682,    0,    0,
    0,  988,    0,  -28, 1297,    0,  402, 1275,    0,   71,
    0,    0,    0,    0,  -28,  461,  -28, 1252, 1705,    0,
 1432,  402, 1715,  880, 1357, 1709, 1724, 1729,    0, 1742,
 1749,    0, 1750, 1758, 1759,    0,    0, 1763,    0,    0,
    0,    0,    0, 1764, 6358, 6358, 5825, 1343, 1770, 1330,
    0,    0,    0,    0,    0, 1721,    0, 1767,    0,    0,
    0,    0, 1570,    0, 1176,    0, 1496, 1774,    0,  -98,
   15,    0, -111,    0,  369,    0,  369,    0,    0, 1775,
    0,   58, 1390,    0,    0,    0,    0, 1776,   40, 1760,
    0, 1545, 1545, 1782,    0, 1790,    0, 1445,    0,  148,
 1488,    0,    0,    0,    0, -178,    0, 1630, 1630, 1630,
 1630,    0, 1796,    0, 1564, 1566,    0,    0,    0, 1544,
    0, 6682,    0,    0, 6682, 1391,    0, 1375, 1596, 1400,
 6332,    0,    0,  285,    0, 1400,  996,  543,    0, 1466,
 1423, 1397,  438,  503,    0, 1470,    0, 1412,  441,    0,
 -178,    0, 1597,    0,    0, 2405,    0,    0,    0,    0,
  105, 1429,    0,    0,    0, 1430,    0, 1477, 1846,    0,
 1537, 1848,  -52,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1798,  145,    0,    0,    0,    0,
  103, 1850, 1852, 1848, 1629,    0, -178, -178,    0, -114,
  -23,    0, 1511,    0, 1483, 1854,    0, 6533,  111,    0,
 1509, 1519, 1864, 4489, 1865, 4025, 5830,  -11,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1399, 1388,  422,    0,    0,  690, 1468,
    0,    0, 1442, -207,    0, 1594, 1878,    0, 1594, 1655,
 -114,  690, 1604, 1607,  402,  505, 5950,  567,  509, 6358,
  757,  987, 1099, 1660, 6358,  597,  597,  915, 1605, 1889,
    0,    0, 6026, 1472, 6358, 6358, 6358, 6358, 6358,    0,
 6358,   84,    0,   45, 1478, 5950, 1476,    0,    0,    0,
 -202,    0,    0,  -91,    0, 1498,    0,    0,    0,  -28,
  208,  -28,    0,    0,  422, 1170,    0,    0, 5950, 1472,
  -49,  -49,  161,    7,  422,    0, -178, -178,    0,  305,
 1412, 1412, 1480,  441,  708,    0,    0, 1906,    0,    0,
    0,    0, 1672,    0,  422,    0,    0,    0,    0,    0,
 1677, 1917,    0, 1662, 1679,    0,    0, 1620, 1621, 1145,
 1690,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  441,  422, 6578,    0,    0,    0,    0,    0,    0,
  441,    0, 1118,    0,    0, 1549,    0,   26, 1555,    0,
    0,    0,  441,    0, 1846,  104,    0,    0,    0, 1676,
  104, 1558,  104,    0, 1944,  441,  441,  441,    0,    0,
 1633,    0, 1463,    0,    0,    0,  524, 1575,  -28, 1490,
   54,    0,    0, 1955, 1723,    0,    0,    0,    0,  115,
 1538, 1214,    0, 1214, 5423,   69, 6358, 6358, 4573, 1961,
 1035, 4642, 6358, 4821,  634, 4962, 5104, 6176, 5191, 5333,
 5434, 4489, 4489,    0,    0,    0,    0,    0, 1275,  402,
  407, 1275,  641,  652,   89, 1958,    0,    0,    0,  690,
 1627,    0, -120, 1635, 5950, 1635,    0, 1527, 1963, 1958,
  690, -125, 1687, 6358, 6358, 1748, 6358, 1974, 6358, 1972,
 1617, 6358, 6358, 6358, 6358, 6358, 6358,    0,    0,    0,
    0,    0,    0,    0,    0, 1696,  783,  -25,    0,    0,
    0, 1176, 1529,    0,    0, 1738,  597,  597,  894,  894,
  844,    0,    0,    0,   45, 1979, 1977,  691,    0,    0,
 4489, 1693,    0,    0,    0,    0,    0,    0,    0,    0,
  350,    0,    0,    0,    0,    0,    0,    0,    0, 1980,
    0,    0,    0, 1542,    0, 1630, 1761,    0,  305,    0,
    0,    0,    0,    0,    0,    0, 1985, 4489, 2703,    0,
    0, 1728,    0,    0,    0, 2703,    0,    0,    0, 1145,
 1145,    0, 1992,    0,    0,    0,    0,    0,    0, 1771,
    0,    0,    0, 1572,   74, 1548, 1612, 1672, 1999,    0,
 1412, 1584,    0,    0, 1023,    0, 1983, 1572, 1115,  441,
 2003, 2006, 2009, 1728, 1630, 1488, -114,    0, 1470,  915,
 1582, 1610,    0,    8,    0,  441, 1666, 1752, 6533,    0,
    0,  441, 1567, 1754,    0,    0, 2026, 2028,    0, 1279,
 1176, 2032,    0,    0, 1176, 2033, 2331,    0,    0, 1726,
 2034, 1176, 2037,  981, 2045, 1176, 2050, 6358, 6358, 1961,
 6358, 6286, 2052, 1176, 2056, 2064, 1176, 2068, 6358, 1176,
 2070, 1176, 2076, 2077, 1176, 2080, 2083, 1176, 2085,    0,
 1866,    0,    0,    0,    0,    0,    0, 1799,  690,    0,
  690,   89, 1958,    0,  124,  124,  109,    0,    0, 1590,
    0, 1728,    0, 1963, 1958, 2082, -125, 1701, 1725,    0,
 1868,    0, 2046, 6358,    0, 2128, 2368, 2583, 3000, 3024,
 3041, 6358,  441, 6358, 6358,    0,    0,  691, 2088, 5950,
  891,   45, 1753,    0, 1762, 1768, 1801, 1873, 1818,    0,
    0,    0, 1732, -178, 1769, 1412, 1785, 1412,    0, 4489,
  405,    0,    0,    0,    0,    0,    0, 1704, 1882, 1728,
    0, 6358,    0, 1871, 1772,    0, 4489,    0,    0,    0,
    0,    0,    0,    0,    0, 2120,   74,    0, 1480,    0,
    0,  104,    0, 2703, 1784,  104,    0,  104,    0, 1672,
 2126,    0,    0,    0, 1882, 1412,    0, 1488,    0,    0,
  -25, 1890,    0,  -74,    0, 1980,    0, 2138,    0, 2139,
 -178,  -99, 2141,    0, -178,    0,    0, 6358, 1766, 1766,
  915,    0,    0,    0,    0, 2142, 1648,    0, 1766, 1766,
 6358, 1766, 1766, 1450, 1176,    0, 1141, 6358, 1176, 1766,
 1766, 1766, 1766, 1176, 1766, 1766, 1766, 1766, 1766, 1766,
 1793,    0,    0,    0,    0,    0,    0,    0, 1746,    0,
    0,    0,    0, 5950,    0, 1882, -125, 2082,    0,    0,
 6682, 2146,    0,    0, 3223,    0,    0,    0,    0,    0,
    0, 3249,   87, 1017, 1176,    0, 1176,    0, 1656,    0,
    0,  691,    0,    0,    0,   45, 1730, 4489, 1794, 1630,
    0,    0, -178, 1118,    0,    0,  419,    0,  422, 5527,
    0,    0, 1176, 1545, 1871,    0,  851,  -28,  425, 1728,
    0,    0, 2152,    0, 2153,    0, 1842, 1545, 1784,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1118, 1771,
 5480, 1811,    0, 1575,    0,    0,    0, 1826, -135,    0,
 1672, 1828, 1176, 2160, 2162,  -25,    0, 1997,    0, 2166,
 2168, 1176, 2169, 2172, 6358, 6358, 1176, 2174, 2175, 2176,
 2177, 2179, 2182, 2183, 2185, 2187, 2189,    0,  124,    0,
    0,    0,    0,    0,    0,  441,    0, 1478, 5950,    0,
  822, 1953, 2191,    0,    0,  -11,  429,    0, 1412,    0,
    0,    0,    0, 6682,  246, 1834, 2180, 1214, 2198, 1904,
 6358, 2192, 2213, 2195, 2196, 2200, 1916, 2203,    0,    0,
    0, 4780, 2211,    0,    0,    0,    0,    0,    0, 2230,
    0,    0, 1920, 1929,  -28,    0,    0,    0, 1145,    0,
 1882,    0,    0,    0,    0,    0,    0,    0,    0, 1957,
    0,    0, 6358, -178,    0,    0,    0, -178,    0,    0,
 6358,    0,    0,    0,    0,    0,    0,    0,    0, 1176,
 1176,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2235, 1693,    0, 4489, 1472, 1730,    0,
    0, 1914,    0, 2245,    0,    0, 2227, 2233,  402,    0,
 1948, 4489, 2060,    0, 4489,    0,    0,    0,   20,    0,
    0,  591,    0, -106,    0,    0,    0,    0,    0, 1145,
 1910,    0,    0,    0,   59, 1478, 1176,    0,    0, 1017,
    0, 1818,  -11,    0,    0,    0,  517,    0,    0, 1213,
   20,  551,    0,  596,  722,    0,    0,    0,  246, 1833,
   74,  118,    0,    0,    0, 1910,  -76,    0, 1912, 1915,
   59, 2256,  691,    0,    0, 1693, 2261, 1478, 1794,  -28,
    0, 2263, 2262, 1152, 1371,    0,    0, 1895,    0, 2265,
    0,  123, 1875, 2005,    0,   20,    0,    0,    0,    0,
 5527,  591,    0,  348,  348, 2011,    0, 1870,    0,  691,
 2275,   59, 1973, 1818,    0, 1693,    0,    0,    0,  517,
 2279,    0,  361,    0, 1661,   35, 2264, 1371, 2030, 2015,
 5527, 5527,    0,    0,    0,    0, 1857,  578,    0,    0,
    0,    0,  691,   59, 1794, 1818,    0,  361,    0,    0,
   20, 2281,    0,    0,    0,    0,    0, 1538, 5527, 2021,
    0,    0,    0,    0, 1114,    0, 1794, 2290, 2295, 1739,
    0,    0, 5527, 4489,    0,  361,    0,    0,    0,  -11,
    0,
};
static short yyrindex[] = {                                      0,
    0,  152,  -56,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  242, 4254,    0,    0,    0, 2337,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  351,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  274,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2001,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1964,
    0,    0,    0,   56,    0,   56,    0,    0,    0,    0,
 1965,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 5683, 4308,
    0,    0,    0,  935,    0,    0,    0, 1387,    0,    0,
    0,  262,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -70,    0,    0,    0,    0,  198,    0,
  993,    0,    0,    0,    0,    0, 1175,    0,    0, 6773,
    0,    0,    0,    0,    0,    0,  -70,    0,  312,    0,
    0, 2301,    0,    0,    0,    0, 2091,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1012,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1033,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  676,    0,  -70,    0, 2301,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  554,    0,    0, 1041,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1070,    0,
 2074,    0,    0,    0,    0, 1073,    0,    0,    0,    0,
    0, 2093,  360, 6727,    0, 1081,    0,    0,    0,    0,
   80,    0,    0,    0, 1899, 1899,    0,    0,    0, 1089,
 1622,    0,    0,    0,    0, 2093,    0,    0, 1111,    0,
    0,    0,    0,    0,    0,    0, 4226, 1975,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1108,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1155,
    0,    0,    0,    0,    0,    0,    0, 2093,    0,    0,
    0,    0, 1191,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1595,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1734,    0,    0,    0,    0,
    0,    0,    0,    0,   77,    0,    0, 2042,    0,  265,
    0,    0,    0,    0,  790,    0,  790,    0,    0,  624,
    0,  784,  892,    0, 4582,    0,    0,    0, 1012,    0,
    0,  846,  846,  779,    0,    0,    0,  354,    0, 3298,
  130,    0,    0,    0,    0,    0,    0, 1899, 1899, 1899,
 1899,    0,  146,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2103,    0,    0,
    0,    0,    0, 2074,    0,    0,  237,    0,  527, 1898,
    0,    0,    0,    0,    0,  155,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1195,    0,    0,    0,    0,
  117,  704,    0,    0,    0,  730,    0,    0, 1112,    0,
    0, 1319,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  995, 2065,    0,    0,    0,    0,
 1320,  800,    0, 1319,    0,    0,    0,    0,    0,  360,
  693,    0,    0,    0,    0, 1959,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  269,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  229,    0,    0,  229,    0,
  360,    0,    0,    0,    0, 6511,    0, 6511,    0,    0,
 6511, 6511, 6511,    0,    0, 2344, 2510, 5768,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2424,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  518,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  330,  330,    0,    0,    0,    0,    0,    0,    0, 3808,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  319,    0,    0,    0,    0,    0,    0,    0,
 2334,    0,    0,  326, 1437,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 4108,    0,    0,    0,    0,    0, 1284,    0,
    0,    0,    0,    0, 1112,    0,    0,    0,    0,  380,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  213,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 6691,    0,    0,    0,   51,    0,    0,    0,    0, 2069,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1226, 1241,    0,    0,    0,    0,
    0,    0,    0, 1286,    0, 1286,    0,    0, 1310, 1332,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 6511,    0,    0,
    0, 1215,    0,    0,    0, 1900, 2649, 2815, 2039, 2205,
    0,    0,    0,    0,    0, 2598,  414, 1814,    0,    0,
    0, 1950,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  362,
    0,    0,    0,    0,    0, 1899, 1918,    0, 4053,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2111,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1339,
    0,    0,    0,    0,    0,    0,    0, 1181,    0,    0,
    0,    0,    0,    0,    0,    0, 1202,    0,    0,    0,
    0,    0,    0, 2111, 1899, 1365,  360,    0, 2127, 4254,
 1393,   57,    0,    0,    0,    0, 6691,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2675,    0,    0,    0, 2888,    0,    0,    0,    0,    0,
    0, 2918,    0, 3017,    0, 3051,    0,    0,    0,    0,
    0,    0,    0, 3101,    0,    0, 3124,    0,    0, 3201,
    0, 3282,    0,    0, 3288,    0,    0, 3369,    0,    0,
  488,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1226, 1405,    0, 1946,  232,    0,    0,    0,    0,
    0, 2111,    0, 1409, 1425, 1426,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2051, 1058,    0,
 2199,    0, 2053,    0, 2054, 2057,    0,    0, 2071,    0,
    0,    0, 3741,    0,    0,    0, 1936,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2136,
    0,    0,    0,  678,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  153,    0,    0,    0,    0, 1926,
    0,    0,    0,    0,    0,    0,    0, 1428,    0,    0,
 5683,    0,    0,    0,    0, 1441,    0,    0,    0,    0,
    0,  122,    0,    0,    0,    0,    0,    0,    0,    0,
 5768,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3390,    0, 3490,    0, 3532,    0,
    0,    0,    0, 3553,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1455,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1379,    0, 1756,    0,    0,    0,
    0, 1989,    0,    0,    0,    0,    0,    0,  276, 1899,
    0,    0,    0, 2504,    0,    0,    0,    0,    0,    0,
    0,    0, 2376, 1289, 1765,    0, 2074,    0,    0, 2111,
    0,    0,    0,    0,    0,    0,    0, 1460,  694,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  219,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   91,    0, 3595,    0,    0, 6511,    0,    0,    0,    0,
    0, 3637,    0,    0,    0,    0, 3714,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  232,    0,
    0,    0,    0,    0,    0,    0,    0,   83,    0,    0,
 2051,  499,  275,    0,    0,   88, 2381,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  224,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3799,
 3862,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  259,    0,    0,    0,    0,    0,
    0, 2382,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2231,
 1340,    0,    0,    0,    0,   61, 2376,    0,    0,    0,
    0,   46, 4204,    0,    0,    0, 2381,    0,    0,   32,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2840,    0,    0, 3776, 3842,
    0,  391,  834,    0,    0,   64,    0,   83, 2384, 1188,
    0,    0, 2387,    0,    0,    0,    0, 2370,    0,   39,
    0, 2125,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2051,
 1346,    0,    0,   66,    0,  259,    0,    0,    0, 2381,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  895,    0,   72,   46,    0,    0,    0,    0,
    0, 2373,    0,    0,    0,    0,    0,    0,    0, 4893,
    0,    0,    0,    0, 2051,    0, 2384, 2392,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1479,
    0,
};
static short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0, 2434,    0,    0, 2439,
    0,    0,    0,    0,   10,    0, 2440,    1,  310,  -13,
 -533, 1403,  606, -277, -186, 2425, 2201,    0,  -35,    0,
 2207,  -88,  -43,    0,  506, -357,  -31,  -41,  -32, -176,
 2215, 1845,    0,    0,    0,  888,    0,    0,  -46, 1471,
 -495,   -7, -699, 1887, 1680, -261, 1485, 2374, -255,    0,
  -50,    0,  865,  -45,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -574,  125, 1481,
 -251, -146, -816,    0,    0,    0,    0, -291, -100, -268,
 1497, -296,  -42,    0, -459,    0,    0, -425, -762,    0,
 1185,    0,    0, 2184, -539,  -40,    0,    0,    0,    0,
 2150,    0, 1960, 2202, -105, 1515, -494,    0,    0,    0,
 -635,    0,    0,    0,    0,    0,    0, 1569,    0, 2242,
 1876, 1522, 2193, 2194,    0,    0,    0, -444, 1781,  -55,
  439, -641,    0,    0, -211, -775, -686, -213, -735,    0,
 1247, -912,    0,  984, 1232,    0, 2018,    0,    0,    0,
 1005, 1007,  975,  -79,  675, -867, -975,    0,    0, 1827,
    0, 1413, -290,    0,    0,    0, -189,    0,    0,    0,
    0,    0,    0,    0, -901,    0,  463,    0, 1000, -262,
  931, 1068,    0,  991,    0,    0, 2197,  -97,    0,    0,
    0,    0, -948, -584, -790, 1245,    0, -427, -642, -646,
 -843,    0, -575, 1027,  250, -580, 1984, 1777, 1579, 1266,
   -2,    0,    0,    0,    0,    0, 2249,    0,    0,    0,
    0, 2266, 2062,    0,    0,    0,    0,    0, 2269,    0,
    0,    0,    0,  -17,    0,    0,    0, -301, 1808, -294,
 1431, -380,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2010,    0,    0, 1829,    0,    0,    0, 2559,    0,
    0,    0,    0, 2305,    0,    0,    0,    0, 2143,    0,
 2144,    0,    0,    0, 1919,    0,    0,    0,    0,    0,
  -72,    0, 1905,    0,-1128,  930,    0, 1934, -555, 1941,
    0, -779, 1716,    0,    0, -124,    0, 1251,    0, 2474,
    0, 1160,-1047, 1250,    0, 1040,    0, 1084,    0,  985,
    0,    0,    0, 2156,    0,    0,    0,    0, 1998, 1783,
 -956,    0,  841,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3630, 1706, 1601,    0,    0,    0,
    0, -212, 1971, 2267,    0,    0,
};
#define YYTABLESIZE 7256
static short yytable[] = {                                     128,
  181,   71,  161,  280,   70,  164,  183,  229,  175,   33,
  356,  360,  355,  180,  166,  187,  251,  254,  452,  252,
  255,  667,  545,  514,  509,  192,  213,  672,  896,  546,
  194,  703,  199,  482,  783,  217,  786,  691,  218,  216,
  694,  480,  905,  858,  222,  224,  705,  226,  873,  235,
  653,  237,  189,  221,  223,  371,  336,  128,  283,  651,
  641,  836,  249,  632,  238,  639,  220, 1074,  371,  945,
  236,  643,  776,  240, 1591,  219,  677,  408,  829,  439,
  253,  261,  571,  666,  875,  250,  639,  638,  447, 1210,
  297,   83,  408,  977,   83, 1078, 1145,  295, 1511,  692,
  900,  662,  410,  250,  613, 1338,  423,  326,  333,  989,
 1114,  425,  298,  895,  604,  336,  485,  677,   69,  641,
  677, 1120,  632,  641,  639,  873,  359, 1337,  638,  431,
  643,  487, 1039, 1261,  487,  677,  325, 1135,  439,  356,
  360,  355,  756, 1104,  738,  433,  638,  376,  951,   69,
 1104,  525,  130,  448,  365,   69,  456,  485,  378,   69,
  485, 1542,   87, 1113,  679,  647, 1536,  282,   69, 1288,
  363,  250,   90,  490, 1299,  485,  681,  682,  683,  684,
  496,  233,  472, 1107, 1216, 1294,  250,  678,  431,  545,
 1107,  602,  435,  258,  366,  286,  546,  357,  558, 1345,
 1045, 1267, 1504,  809,  433, 1295,  327,  366,  109,  457,
  525,  130,  119,  365,   91,  201,  432,  882,  189,  514,
 1405, 1173,  446,  692,  748, 1544,   92,  299,  683,  381,
  439,  485, 1105,  309,  256,  753,  425,  368,  481, 1105,
 1331,  525,  711,  946,  287,  484,  109,  181, 1130,  497,
  802,   93,  500,  202,  369,  359,  357,  248,  626,  627,
  629,  582, 1030, 1031,  692,  739,  127,  692,  640, 1049,
  510,  119,  512,  527,  631,  643,   53,  189,  257,  936,
  425,  109,  692,  559,  173,  174, 1042,  683,  563,  750,
  485,  885,  701,  749,  654,  425,  561, 1054, 1056,  632,
  525,   75, 1242,  608,  328,  300, 1271,  233,  592,  640,
 1174,  310,  173,  174,  267,  631,  643, 1046,  487,  812,
  582,   94,  112,  601,  210,  216,   15,  640,  598,  580,
  802,   95,  527,  631,  643,   71,  369,  833,  601,  606,
  677,  609,  258,  439,  970, 1402, 1462,  178,  366,  437,
  573, 1518, 1267,  584,  178, 1406,   96,  288, 1104,  487,
 1291,  583,  487,  648,  487,  952,  216, 1545, 1300,  216,
  614, 1276, 1432,  580,  485,  803,  661,  487, 1101,  129,
  872,  806,  360,  805,  216, 1151, 1569,  431,  580,  641,
  341, 1345,  641,  485,  485,  632,  485,  677, 1107, 1156,
  487,  485, 1391,  433,  485, 1336,  638,  733,  697,  573,
  452,  641,  584,  595,  641, 1473,  677,  485,  365,  680,
  583,  752, 1541,  485,  246,  830,   89,  371,  638,  785,
  350,   87,  130,  125,  917,  707,  431,  919,  129,  692,
 1286, 1353,  639,  297, 1379, 1258, 1380, 1105,  976,  341,
  295,  925,  433,  107,  595,  803,  357,  641, 1252, 1352,
  632,  357,  639,   83,  735, 1390, 1341,  357,  178,  178,
  425, 1397,  595,  841,  248,  638,  894,  439,  857,  641,
  940,  445,  248,  776,  638,  913,  862,  703,  866,  867,
  868,  869,  870,  339,  862,  485,  445,  807,  635,  425,
  248,  734,  641,  487,  181,  632,  163,  639,  650,  979,
  761,  762,  336,  643, 1433, 1411,  641,  485,   71,  632,
  125,  639,  425, 1218,  984,  485,  603,  643,  703,  638,
  677,  703, 1413,   68,  485, 1446,  485,  569,  677,  635,
  808,  448,  635,  638, 1038,  178,  703,  569,  456,  431,
  886,  755, 1211,  548,  485,  181,  569,  635,  487,  485,
 1257,  119,  525,  248,   68,  433,   71,  189,  913,  778,
   68,  601,  777, 1472,   68,  232,  487, 1269,  840,  916,
  911,  912, 1474,   68,  245,  592, 1306,  640,  485, 1532,
  632, 1533,  487,  631,  643,  357,  683,  640,  116,  485,
  640, 1407,  582,  216,  708,  216,  631,  692,  838,  640,
  446,  889,  548,  216, 1096,  631,  643, 1350,  113,  363,
   68, 1414,  445,  554,  439,  487,  892,  129,  487,  890,
  901,  901, 1032, 1043, 1274, 1035, 1534,  234,  638,  484,
  990,  991,  995,  639, 1055, 1002, 1004, 1006,  580, 1014,
 1017, 1020, 1022, 1025, 1028,  632,  640,  129, 1330,  129,
 1517,  906,  631,  643, 1592,  640,  802,  935,  937,  573,
  580,  631, 1112, 1146,  291, 1557,  915,  222,  425,  234,
  802, 1203,  554, 1205, 1118,  709,  802, 1058, 1059, 1610,
 1061,  573, 1063,  131,  584, 1066, 1067, 1068, 1069, 1070,
 1071, 1134,  583,  497,  216, 1106,  360,  158, 1346,  987,
  640,  988, 1106,  360,  934,  979,  631,  643,  222,  341,
  247,  222,  341,  292,  640, 1577,  216,  710,  939,  498,
  631,  487,  595,  974,  216,  907,  222,  171,  487,  725,
  949, 1606,  595,  497,  497,  595,  656,  497,  961,  962,
  963, 1275,  131,  105,  595, 1090,  487, 1285,  129,  130,
  234, 1332,  497, 1615,  256, 1536, 1033, 1578,  216,  498,
  498, 1036, 1440,  498,  116,  116,  726,   71,  572, 1034,
 1535, 1037,  503,  564,  360, 1172,  487,  341,  498,  553,
  487,  803, 1482,  504,  497,  122, 1484, 1441, 1221,  492,
  303,  595,  234,  304,  728,  803,  703, 1091,  834,  703,
  595,  803,  802,  131, 1579,  435,  703,  635,  657,  703,
  498,  106,  160,  703,  638,  636,  256,  637,  703,  639,
  635,  703,  341,  342,  932, 1519,  293,  572, 1381,  635,
  492,  729,  564,  492,  341,  210,  341,  703,  553,  305,
  886,  679, 1395, 1498,  294,  595, 1442,  802,  492, 1203,
 1440, 1184, 1185,  163, 1187, 1189, 1238,  595,  168, 1270,
  837,  703, 1194, 1554,  703,  703,  634,  342, 1603,   15,
  478,  727,  635,  178,  703, 1441,  635, 1075,  295,  210,
  492,  549,  342,  479,  343,  635,  548, 1483, 1290, 1175,
   68,  123,  703, 1499,  210, 1008,  607, 1585,  124, 1447,
 1435,  181, 1492, 1586, 1500, 1494,  436, 1225,  363,  545,
 1106,  360, 1009,  557,  863, 1232,  546, 1234, 1235,  703,
 1604,  548, 1553, 1237,  532, 1550, 1077,  803,  343, 1607,
  635,  703,   71,  703, 1442, 1126,  730, 1208, 1208, 1212,
  549,  357, 1141,  343,  635,  234, 1241,  222, 1349,  548,
  204,  497,  357,  548,  414, 1263,  554, 1010, 1159, 1553,
  184,  350,  437,  131, 1163,  557, 1583,  497,  125,  548,
  497,  497,  803,  497, 1342, 1351,  468,  498,  497,  438,
  459,  497,  529,  532,  465, 1254, 1011, 1256,  863,  460,
  555,  554, 1553,  498,  497,  548,  498,  498, 1605,  498,
  497,  641, 1083,  497,  498,  711,  256,  498,  809, 1501,
 1398, 1303,  638,  636, 1553,  637, 1084,  639,  597,  554,
  498,  596,  328,  554, 1312,  465,  498,  469,  465,  498,
  531, 1317,   71,   71, 1403, 1289,   91,  901, 1516,  554,
 1085,  529,  610,  465, 1115, 1116,  234,  492,  638,  636,
  842,  637,  634,  639, 1012, 1233, 1136,  425,  635,  372,
  641,  470,  373,  492, 1620,  554,  492,  492,  234,  492,
  369, 1463,  497,   93,  492,  206,  234,  492,  154,  471,
 1556,  328,  810,  337,  692,  360, 1412,  572, 1157,  531,
  492,  342,  196, 1073,  497, 1086,  492,  326,  498,  492,
  210,  515,  497,   97, 1298, 1137,  497,  108, 1302,  572,
  234,  692,  456,  497,   71, 1238,  564, 1273,  372,  811,
  498,  373,  553,  207,  812,  448,  922,  214,  498,  369,
  813,  497,  498, 1083,  425,  929,  497,  154,  210,  498,
  109,  369,  515,   94,   41,  515,  211, 1084, 1136,  814,
  225,  564,  342,   95,  210,  342,  326,  498, 1420, 1421,
  515,  497,  498,  634,  145,  497, 1342,  620,  492,  635,
  487, 1085,  638,  636,  226,  637,  210,  639,   96,  564,
   49,  230, 1237,  564,  155,  553, 1497,  498,  964,  553,
  492,  498,  515,  181,  446, 1437,  901, 1140,  492,  564,
 1415,  231,  492,   41, 1453,  553, 1354,  638,  636,  492,
  637,  487,  639,  343,  487,   39,  343, 1531, 1497, 1383,
  342, 1208, 1389,  145,  549,  564, 1086,  492,  620,  487,
   22,  553,  492,   45,  234,  463,  256,  448, 1445,   49,
 1575, 1384, 1525,  155,   46,  792, 1477,  352,  792, 1385,
  634,   47, 1531,  242, 1480, 1052,  635,  492,  243,  549,
  408,  492,  465, 1574,  465,  342, 1527,  360, 1526,  465,
 1600, 1601,  465,  482,   39,  688,   48,  342,  210,  342,
  844,  343, 1181, 1386,  463,  465,  634,  549,  118,   22,
 1471,  549,  635, 1497, 1448, 1597,  244,  792, 1612,   45,
  262, 1527,  360, 1526,  456,  364,  446,  549,  505,  489,
  638,  636, 1619,  637,  482,  639,   71,  482, 1497,  210,
  353,   47,  210, 1434,  456,  352,  343,  644,  441,  247,
  278,  125,  482,  549,  688,   72,   73,  210,  343, 1470,
  343,   49,  279,  250, 1595,  360, 1594, 1478,  256,  505,
  489, 1479,  505,  489,  121,  456,  456, 1451,   45,  515,
  640,  638,  636,  465,  637, 1119,  639,  505,  489,  598,
  247, 1506,  281,  247,   50,  515,  612,  999,   51,  515,
   47,  515,  353,  598,  284,  465,  515,  441,  247,  515,
  456,  598,  846,  465,   23, 1490,  117,  118,   46,  505,
  489,  456,  515, 1000,  301,  352,  448,  598,  515,  793,
  634,  515,  793,  121,   48,   43,  635,  122,  408,  312,
  612,  696,  352,  314,  695, 1083,  455,  465,  487,  804,
  110,  456,  595,  456,  263,  612,  448,  448, 1537, 1084,
  250,  353, 1316,  145,   44,  634,  323,  128,  487,  210,
  487,  635,  718,   23,  719,  487,  456,   46,  487, 1520,
  330,  793,  598, 1085,  448,  145,  332,  455,  346,  264,
  455,  487,  874,   48,   43,  446,  122,  487,  448, 1561,
  515,  638,  636,  128,  637,  455,  639, 1614,   71,  110,
  334, 1540, 1520,  968,  145,  893,  967,  265,  343,  941,
  942,  266,  515,   44,  874,  446,  446, 1589,  210,  346,
  515,  335,  346,  145,  515,  654, 1562,  267, 1086,  367,
  975,  515,  145,  772,  128,  897,  898,  346,  145, 1563,
 1168,  482, 1520,  446, 1202,  835, 1204,  839,  338,  515,
  843,  845,  847,  268,  515,  377,  145,  446,  634,  487,
  482,  482,  654,  482,  635,  344,  128, 1053,  482, 1076,
  967,  482, 1075,  117,  117,  654,  505,  489,  339,  515,
  375,  487, 1095,  515,  482, 1094,  343,  380, 1128,  487,
  482, 1127,  505,  489,  863,  433,  505,  489,  505,  489,
  487,  382,  431,  505,  489,  315,  505,  489,  384,  634,
  643,  638,  636,  385,  637,  635,  639,  434,  487,  505,
  489,  146,  443,  487, 1133,  505,  489, 1132,  505,  489,
 1215,  445,   15, 1214,  859,  863,  863,  863,  863,  863,
  875,  863,  316,  344,  317,  859,  638,  636,  458,  637,
  467,  639,  487,  863,  863,  863,  863, 1065,  638,  636,
  475,  637,  482,  639,  488,  562,  343,  344,  318,  498,
  495,  345,  346,  347,  445,  173,  174,  345,  346,  347,
  146,  344,  556,  343,  482,  863,  511,  863, 1309,  344,
  507, 1308,  482,  319,  348,  349, 1340,  505,  489, 1339,
  590, 1590,  560,  482, 1568,  344,  350,  351,  612,  564,
  591, 1315,  350,  351,  455,  612,  455,  592,  612,  505,
  489,  482,  612,  344,  455,  595,  482,  505,  489,  634,
  612,  505,  489,  765,  599,  635,  369,  455,  505,  489,
  344, 1219,  638,  636,  611,  637,  612,  639,  616,  345,
  346,  347,  612,  173,  174,  482,  505,  489,  604,  615,
  344,  505,  489,  617,  223, 1220,  638,  636,  618,  637,
  612,  639,  348,  349,  765,  765,  765,  765,  765, 1618,
  765,  619, 1536,  612,  350,  351,  505,  489,  620,  621,
  505,  489,  765,  765,  765,  765,  609,  622,  623,  609,
  346,  612,  624,  625,  631,  223,  612,  346,  223,  633,
  346,  641,  642,  596,  346,  455,  644,  646,  660,  664,
  669,  665,  346,  223,  670,  673,  765,  675,  612,  345,
  346,  347,  445,  173,  174,  674,  459,  455,  346,  685,
  612,  686,  612,  688,  689,  455,  345,  346,  347,  634,
  173,  174,  348,  349,  596,  635,  863,  596,  863,  698,
  723,  699,  346,  722,  350,  351,  863,  731,  724,  348,
  349,  248,  596,  736,  863,  346,  742,  740,  741,  455,
  863,  350,  351,  863,  634,  743,  745,  746,  751,  757,
  635,  758,  760,  346,  769,  771,  634,  772,  780,  775,
  146,  781,  635,  782,  784,  820,  863,  821, 1223,  638,
  636,  823,  637,  863,  639,  863,  863,  825,  827,  863,
  346, 1496,  146,  863,  831,  487,  863,  832,  863,  860,
  863,  881,  346,  864,  346,  863,  863,  648,  863,  913,
  775,  775,  775,  775,  775,  918,  775,  887,  752,  632,
  923,  146, 1529, 1496,  863,  863,  924,  863,  775,  775,
  775,  775,  926,  701,  930,  931,  487,  933,  944,  487,
  146,  863,  947,  863,  863,  863,  953,  958,  863,  146,
  634,  863,  863,  960,  487,  146,  635, 1529,  597,  965,
  632,  863,  775,  970,  982,  765,  983,  765, 1573,  985,
  997, 1041, 1047,  146,  634,  765, 1039, 1057,  632,  863,
  635, 1060, 1044,  765, 1062, 1064, 1072,  634, 1080,  765,
 1082, 1088,  765,  596, 1100,  863, 1097, 1108, 1496,  597,
 1596, 1117,  597, 1124, 1121, 1129,  863, 1152,  778, 1131,
 1138,  352,  234, 1142,  223,  765, 1143,  597,  863, 1144,
  863, 1154,  765, 1496,  765,  765,  863, 1164,  765,  250,
  976, 1161,  765, 1165,  487,  765, 1166,  765, 1167,  765,
  639, 1169, 1170, 1179,  765,  765, 1180,  765, 1178,  778,
  778,  778,  778,  778, 1182,  778, 1224,  638,  636, 1183,
  637, 1190,  639,  765,  765, 1191,  765,  778,  778,  778,
  778,  638,  636, 1192,  637,  487,  639, 1193,  487, 1195,
  765,  639,  765,  765,  765, 1196, 1197,  765, 1493, 1198,
  765,  765, 1199,  487, 1200, 1217, 1201,  802, 1236,  639,
  765,  778,  596,  848,  849,  850,  851,  852,  853,  854,
  855, 1243,  596,  234, 1246,  596, 1247,  634,  765, 1248,
 1244, 1259, 1260,  635,  596, 1250, 1245,  620,  490, 1253,
 1272,  775, 1277,  775,  765,  234, 1287, 1292, 1226,  638,
  636,  775,  637,  234,  639,  765, 1255, 1296, 1328, 1297,
 1268, 1301, 1307, 1329, 1171,  775, 1333,  765,  775,  765,
 1347,  397, 1392, 1393, 1394,  765, 1401, 1404,  603, 1408,
 1409,  596, 1410,  487,  779,  487, 1416,  234, 1417, 1418,
  596,  775, 1419,  487, 1422, 1423, 1424, 1425,  775, 1426,
  775,  775, 1427, 1428,  775, 1429,  487, 1430,  775, 1431,
  692,  775, 1438,  775, 1439,  775, 1449, 1452, 1450,  603,
  775,  775,  603,  775,  106,  779,  779,  779,  779,  779,
 1454,  779, 1455, 1456, 1457,  596, 1459,  603, 1458,  775,
  775, 1460,  775,  779,  779,  779,  779,  596,  632, 1466,
 1467,  692, 1468, 1469,  692, 1481,  775, 1475,  775,  775,
  775,  632, 1486,  775, 1487, 1488,  775,  775, 1491,  692,
  632, 1489,  343, 1507, 1538, 1546,  775,  779, 1548, 1552,
  778, 1555,  778, 1559,  487, 1560, 1566,  597, 1568, 1572,
  778, 1571, 1544, 1545,  775, 1582, 1584,  597, 1588, 1599,
  597, 1602, 1593, 1598, 1536,  634,  487,  778, 1613,  597,
  775,  635,  620, 1616,  487, 1617,    1,  632,  580,  634,
  196,  775,  487,  773,  487,  635,  632,   27,   29,  487,
  778,  350,  487,  775,  692,  775,  260,  778,  142,  778,
  778,  775,  588,  778,  485,  487,  258,  778,  487,  422,
  778,   79,  778,  206,  778,  352,  597,  186,  485,  778,
  778,  265,  778,  485,  773,  597,  773,  773,  773,  639,
  365,  632,   90,  250,  620,  187,  618,  614,  778,  778,
  616,  778,  773,  773,  773,  773,  264,  634, 1227,  638,
  636,  639,  637,  635,  639,  778,  351,  778,  778,  778,
  649,  648,  778,  641,  643,  778,  778,  650,  300,  315,
  597,  298,  659,   25,   91,  778,  773,  114,   28,   35,
  374,  396,  597,  487, 1206,  383,   92,  373,  822, 1162,
  770,  981,  215,  778, 1158,  345,  346,  347,  639,  173,
  174, 1160, 1148, 1396,  641,  487,  779,  639,  779,  778,
  520,   93, 1139,  487,  477,  737,  779, 1099,  348,  349,
  778,  379,  641,  402,  403,  928,  828,  463, 1149, 1543,
  350,  351,  778,  779,  778,  492,  493, 1003, 1388, 1007,
  778, 1015, 1018,  189, 1023, 1026, 1029,  487,  692,  772,
  692, 1382,  639,  717, 1549, 1547,  779,  603,  692, 1581,
  603,  921, 1262,  779, 1565,  779,  779,  603, 1611,  779,
  603, 1505, 1576,  779,  603, 1400,  779, 1551,  779,  603,
  779,   94,  603,  969,  767,  779,  779, 1150,  779,  594,
  772,   95,  772,  772,  772, 1399,  501,  474,  603,  721,
  959,  483,  189,  759,  779,  779, 1284,  779,  772,  772,
  772,  772,  116,  950,  444,  655,   96,  899,  888,  883,
  659,  779,  603,  779,  779,  779,  603,  884,  779, 1436,
 1079,  779,  779,  260,   97,  603, 1443,  605, 1485, 1587,
 1621,  779,  772, 1558,  668,  773,  826,  773, 1051,  692,
 1186,  871,    0,  603,  692,  773,    0,    0,  593,  779,
    0,    0,    0, 1228,  638,  636,  343,  637,    0,  639,
    0,  692,  773,    0,    0,  779,    0,    0,  605,  692,
  603,  605,    0,    0,    0,    0,  779,  634,  774,    0,
    0,    0,  603,  635,    0,  773,  605,    0,  779,    0,
  779,    0,  773,    0,  773,  773,  779,    0,  773,    0,
    0,    0,  773,  692,  751,  773,    0,  773,    0,  773,
    0,    0,    0,  468,  773,  773,    0,  773,    0,  774,
    0,  774,  774,  774,    0,    0,    0,   90,    0,    0,
    0,    0,    0,  773,  773,  513,  773,  774,  774,  774,
  774,    0,    0,    0,    0,  751,    0,    0,  751,    0,
  773,    0,  773,  773,  773,    0,    0,  773,    0,    0,
  773,  773,    0,  751,  469,    0,    0,    0,    0,   91,
  773,  774,  641,    0,    0,    0,    0,  352,    0, 1171,
    0,   92,  641,  459,    0,  641,    0,    0,  773,    0,
    0,  189,  460,    0,  641,  111,    0,    0,  470,    0,
    0,  772,    0,  772,  773,  396,   93,    0,    0,    0,
    0,  772,  189,    0,    0,  773,  471,    0,    0,  345,
  346,  347,    0,  173,  174,    0,    0,  773,  772,  773,
    0,    0,    0,    0,  189,  773,    0,    0,    0,    0,
  189,  641,  348,  349,  777,    0,    0,  402,  403,    0,
  641,  772,    0,    0,  350,  351,    0,    0,  772,    0,
  772,  772,    0,  189,  772,    0,    0,    0,  772,  247,
    0,  772,    0,  772,    0,  772,   94,    0,    0,    0,
  772,  772,  189,  772,    0,  777,   95,  777,  777,  777,
  189,  189,  634,    0,    0,  641,    0,  189,  635,  772,
  772,    0,  772,  777,  777,  777,  777,    0,    0,    0,
  247,   96,    0,  247,    0,  189,  772,  720,  772,  772,
  772,    0,    0,  772,    0,    0,  772,  772,  247,   97,
    0,    0,    0,    0,    0,    0,  772,  777,    0,    0,
  774,    0,  774,    0,    0,    0,  605,  721,    0,  605,
  774,    0,    0,  189,  772,    0,  605,    0,  720,  605,
    0,  720,    0,  605,  189,    0,  751,  774,  605,    0,
  772,  605,    0,    0,    0,    0,  720,    0,    0,    0,
    0,  772,    0,    0,    0,    0,    0,  605,  721,    0,
  774,  721,    0,  772,    0,  772,    0,  774,    0,  774,
  774,  772,    0,  774,    0,    0,  721,  774,    0,    0,
  774,  605,  774,    0,  774,  605,    0,    0,    0,  774,
  774,    0,  774,  751,  605,    0,  751,    0,  343,    0,
    0,    0,    0,  751,    0,    0,  751,    0,  774,  774,
  751,  774,  605,    0,    0,  751,  745,    0,  751,    0,
    0,    0,    0,    0,    0,  774,    0,  774,  774,  774,
    0,    0,  774,    0,  751,  774,  774,    0,    0,  605,
 1229,  638,  636,    0,  637,  774,  639,    0,    0,    0,
  724,  605,    0,    0,    0,  344,    0,  745,  751,  605,
  745,  751,  751,  774, 1230,  638,  636,    0,  637,    0,
  639,  751,    0,    0,    0,  745,  777,    0,  777,  774,
    0, 1231,  638,  636,    0,  637,  777,  639,    0,  751,
  774,  724,    0,    0,  724,    0,    0,    0,    0,    0,
  722,    0,  774,  777,  774,    0,    0,    0,    0,  724,
  774,    0,    0,    0,    0,    0,  751,  247,    0,  247,
    0,    0,    0,  723,    0,    0,  777,  247,  751,    0,
  751,    0,    0,  777,    0,  777,  777,    0,    0,  777,
    0,  722,    0,  777,  722,    0,  777,  396,  777,  720,
  777,    0,    0,    0,    0,  777,  777,    0,  777,  722,
    0,  345,  346,  347,  723,  173,  174,  723,    0,    0,
    0,    0,    0,    0,  777,  777,    0,  777,    0,  721,
    0,    0,  723,    0,  348,  349,  399,  400,  401,  402,
  403,  777,    0,  777,  777,  777,  350,  351,  777,    0,
  753,  777,  777,    0,    0,    0,  720,    0,    0,  720,
    0,  777,    0,    0,    0,    0,  720,    0,  247,  720,
    0,    0,    0,  720,    0,    0,    0,    0,  720,  777,
    0,  720,    0,    0,    0,    0,  721,    0,    0,  721,
  247,  753,    0,    0,  753,  777,  721,  720,  247,  721,
    0,    0,    0,  721,    0,    0,  777,    0,  721,  753,
    0,  721,    0, 1334,  638,  636,    0,  637,  777,  639,
  777,  720,    0,    0,  720,  720,  777,  721,  745,  634,
    0,  717,  247,    0,  720,  635,    0,  718,    0, 1335,
  638,  636,    0,  637,    0,  639,    0,  170,    0,    0,
    0,  721,  720,  634,  721,  721,    0,    0,    0,  635,
    0,    0,  724,    0,  721,    0,    0,    0,    0,    0,
  634,    0,  717,    0,    0,  717,  635,    0,  718,  720,
    0,  718,  721,    0,    0,  745,    0,    0,  745,    0,
  717,  720,    0,  720,    0,  745,  718,    0,  745,    0,
    0,    0,  745,    0,    0,    0,  170,  745,    0,  721,
  745,    0,  722,    0,    0,    0,    0,    0,  719,  724,
    0,  721,  724,  721,    0,    0,  745,    0,    0,  724,
    0,    0,  724,    0,    0,  723,  724,    0,    0,  752,
    0,  724,    0,    0,  724,    0,    0,    0,    0,    0,
  745,    0,    0,  745,  745,    0,    0,    0,    0,  719,
  724,    0,  719,  745,    0,    0,    0,    0,    0,  722,
    0,    0,  722,    0,    0,    0,    0,  719,    0,  722,
  752,  745,  722,  752,  724,    0,  722,  724,  724,    0,
    0,  722,  723,    0,  722,  723,    0,  724,  752,    0,
    0,    0,  723,    0,    0,  723,    0,    0,  745,  723,
  722,    0,  753,    0,  723,  724,    0,  723,    0,    0,
  745,    0,  745,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  723,  722,    0,    0,  722,  722,  746,
    0,    0,  724,    0,    0,    0,    0,  722,    0,    0,
    0,    0,  634,    0,  724,    0,  724,  723,  635,    0,
  723,  723,    0,    0,    0,  722,    0,    0,    0,  753,
  723,    0,  753,    0,    0,    0,    0,    0,  634,  753,
  746,  754,  753,  746,  635,    0,  753,    0,  723,    0,
    0,  753,  722,  717,  753,    0,    0,    0,  746,  718,
    0,    0,  755,    0,  722,  170,  722,    0,    0,    0,
  753,    0,    0,    0,    0,  723,    0,    0,    0,    0,
    0,    0,  754,    0,    0,  754,  170,  723,    0,  723,
    0,    0,    0,    0,  753,    0,    0,  753,  753,    0,
  754,    0,    0,  755,  743,    0,  755,  753,  170,    0,
  717,    0,    0,  717,  170,    0,  718,    0,    0,  718,
  717,  755,    0,  717,    0,  753,  718,  717,    0,  718,
    0,    0,  717,  718,    0,  717,    0,  170,  718,    0,
  719,  718,    0,    0,    0,  743,  747,    0,  743,    0,
    0,  717,  753,    0,    0,    0,  170,  718,    0,    0,
    0,  752,    0,  743,  753,  170,  753,    0,    0,    0,
    0,  170,    0,    0,    0,  717,    0,    0,  717,  717,
    0,  718,    0,    0,  718,  718,    0,  747,  717,  170,
  747,    0,    0,    0,  718,    0,    0,  719,    0,    0,
  719,    0,    0,    0,    0,  747,  717,  719,    0,    0,
  719,    0,  718,    0,  719,    0,    0,    0,  752,  719,
    0,  752,  719,  756,    0,    0,    0,  170,  752,    0,
    0,  752,    0,  717,    0,  752,    0,    0,  719,  718,
  752,    0,    0,  752,    0,  717,    0,  717,    0,    0,
  174,  718,    0,  718,    0,    0,    0,    0,    0,  752,
    0,  746,  719,    0,  756,  719,  719,  756,    0,    0,
    0,    0,    0,    0,    0,  719,    0,    0,    0,    0,
    0,    0,  756,  752,    0,  243,  752,  752,    0,    0,
    0,  174,    0,  719,  174,    0,  752,    0,    0,    0,
    0,    0,    0,  754,    0,    0,    0,    0,  744,  174,
    0,    0,    0,    0,  752,    0,    0,  180,  746,    0,
  719,  746,    0,    0,  755,    0,  243,    0,  746,  243,
    0,  746,  719,    0,  719,  746,    0,    0,    0,    0,
  746,  752,    0,  746,  243,    0,    0,    0,    0,  744,
    0,  244,  744,  752,    0,  752,    0,    0,    0,  746,
  754,    0,    0,  754,    0,    0,  743,  744,    0,    0,
  754,  748,    0,  754,    0,    0,  180,  754,    0,    0,
    0,  755,  754,  746,  755,  754,  746,  746,    0,    0,
    0,  755,  244,    0,  755,  244,  746,    0,  755,    0,
    0,  754,    0,  755,    0,    0,  755,    0,  747,    0,
  244,    0,  748,    0,  746,  748,    0,    0,    0,    0,
    0,    0,  755,  743,    0,  754,  743,    0,  754,  754,
  748,    0,    0,  743,    0,    0,  743,    0,  754,    0,
  743,  746,    0,    0,    0,  743,  755,    0,  743,  755,
  755,    0,    0,  746,    0,  746,  754,    0,    0,  755,
    0,    0,    0,    0,  743,  747,    0,    0,  747,    0,
    0,    0,    0,    0,    0,  747,    0,  755,  747,    0,
    0,    0,  747,  754,    0,  756,    0,  747,  743,    0,
  747,  743,  743,    0,    0,  754,    0,  754,    0,    0,
    0,  743,    0,    0,  755,    0,  747,    0,  174,    0,
    0,    0,    0,    0,    0,    0,  755,  576,  755,  743,
  405,    0,  406,    0,    0,    0,    0,    0,    0,  174,
  747,    0,    0,  747,  747,  408,    0,    0,    0,    0,
  250,    0,  756,  747,    0,  756,  743,    0,    0,    0,
    0,  174,  756,    0,    0,  756,    0,  174,  743,  756,
  743,  747,  181,  243,  756,  243,    0,  756,    0,    0,
  744,    0,    0,  243,  576,  180,    0,  405,    0,  406,
  174,    0,    0,  756,    0,    0,    0,    0,  747,    0,
    0,    0,  408,    0,    0,    0,  180,  250,    0,  174,
  747,    0,  747,    0,    0,    0,    0,  756,  174,    0,
  756,  756,    0,    0,  174,    0,    0,  189,  180,    0,
  756,  181,    0,    0,  180,    0,    0,  744,    0,  244,
  744,  244,  174,  748,    0,    0,    0,  744,  756,  244,
  744,    0,    0,   55,  744,    0,    0,  180,    0,  744,
    0,   76,  744,    0,   56,    0,    0,    0,   77,    0,
    0,   57,   78,   79,  243,  756,  180,    0,  744,    0,
  174,   80,    0,    0,   58,  180,  189,  756,    0,  756,
    0,  180,    0,   81,    0,    0,  243,    0,    0,    0,
  748,    0,  744,  748,  243,  744,  744,    0,    0,  180,
  748,    0,    0,  748,    0,  744,    0,  748,    0,    0,
    0,    0,  748,  600,    0,  748,    0,    0,    0,    0,
    0,    0,    0,  744,    0,    0,    0,    0,  243,    0,
  244,  748,    0,    0,    0,    0,    0,  180,    0,    0,
    0,    0,    0,    0,  386,    0,    0,    0,   82,    0,
  744,   59,  244,  387,  600,  748,    0,  600,  748,  748,
  244,    0,  744,    0,  744,    0,   83,  388,  748,   60,
  572,    0,  600,  343,  389,    0,    0,    0,    0,    0,
    0,   84,    0,    0,   61,   85,  748,    0,   62,    0,
    0,   63,  573,    0,  244,    0,   86,    0,    0,   64,
    0,  386,    0,  630,  390,  630,  630,    0,  630,    0,
  387,    0,    0,  748,    0,   87,    0,    0,   65,    0,
  181,  630,    0,    0,  388,  748,  630,  748,    0,    0,
  343,  389,  391,  392,    0,    0,    0,    0,    0,    0,
    0,  181,    0,    0,  393,    0,    0,    0,  394,  573,
    0,    0,    0,    0,    0,    0,  574,  628,    0,  628,
  628,  390,  628,  181,    0,    0,    0,    0,    0,  181,
    0,    0,    0,    0,    0,  628,    0,    0,    0,    0,
  628,    0,    0,    0,    0,    0,    0,    0,    0,  391,
  392,    0,  181,    0,    0,    0,  189,    0,    0,    0,
  575,  393,    0,    0,    0,  394,    0,    0,    0,    0,
    0,  181,  395,  574,    0,    0,    0,    0,  189,    0,
  181,    0,  396,    0,    0,    0,  181,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  345,  346,  347,  397,
  173,  174,    0,    0,  181,    0,    0,  189,    0,    0,
  398,    0,    0,  628,    0,    0,    0,  575,    0,  348,
  349,  399,  400,  401,  402,  403,  189,  404,    0,  395,
    0,  350,  351,    0,  189,  189,    0,    0,    0,  396,
    0,  189,  181,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  345,  346,  347,  397,  173,  174,  189,
    0,    0,    0,    0,    0,    0,    0,  398,  214,    0,
    0,  189,  214,  189,    0,    0,  348,  349,  399,  400,
  401,  402,  403,  630,  404,    0,    0,  214,  350,  351,
  630,  214,  600,    0,  214,  600,    0,  189,  576,  630,
    0,  405,  600,  406,    0,  600,    0,    0,    0,  600,
    0,    0,    0,  630,  600,    0,  408,  600,    0,  630,
  630,  250,  189,    0,    0,    0,    0,  630,    0,    0,
    0,    0,    0,  600,    0,  214,    0,  628,    0,    0,
    0,  214,  214,  214,  628,  214,  214,  214,    0,  214,
  630,  863,    0,  628,    0,    0,    0,  600,    0,    0,
    0,  600,    0,    0,    0,    0,    0,  628,    0,  214,
  600,  214,    0,  628,  628,    0,  630,    0,  630,  630,
    0,  628,  407,    0,    0,  405,    0,  406,  600,    0,
  630,    0,  863,    0,  630,  863,    0,  875,    0,    0,
  408,    0,  214,    0,  628,  250,    0,    0,   78,    0,
  863,    0,  863,    0,    0,  600,    0,    0,    0,    0,
  214,    0,    0,    0,    0,    0,    0,  600,    0,    0,
  628,    0,  628,  628,    0,    0,    0,    0,    0,    0,
    0,    0,  214,    0,  628,    0,    0,    0,  628,    0,
    0,  407,    0,    0,  405,    0,  406,    0,  630,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  630,  408,
    0,    0,    0,    0,  250,    0,    0,  214,  214,    0,
    0,    0,  630,  630,  630,  630,  630,  630,    0,    0,
    0,    0,    0,    0,    0,    0,  630,    0,    0,    0,
    0,    0,    0,    0,    0,  630,  630,  630,  630,  630,
  630,  630,  628,  630,    0,    0,    0,  630,  630,    0,
    0,    0,  628,    0,    0,  386,    0,    0,    0,    0,
    0,    0,    0,    0,  387,    0,  628,  628,  628,  628,
  628,  628,    0,    0,    0,    0,    0,    0,  388,    0,
  628,    0,    0,    0,  343,  389,    0,    0,    0,  628,
  628,  628,  628,  628,  628,  628,    0,  628, 1304, 1305,
    0,  628,  628,  573,    0,    0,    0,    0, 1310, 1311,
    0, 1313, 1314,    0,    0,  390,    0,    0,    0, 1318,
 1319, 1320, 1321,    0, 1322, 1323, 1324, 1325, 1326, 1327,
    0,    0,  992,    0,    0,  993,    0,    0,    0,  386,
    0,    0,    0,  391,  392,  863,  863,    0,  387,    0,
    0,    0,    0,    0,    0,  393,    0,    0,    0,  394,
  407,  863,  388,  405,    0,  406,    0,  574,  343,  389,
    0,    0,    0,    0,    0,    0,    0,    0,  408,    0,
    0,    0,    0,  250,  863,    0,  863,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  390,
  863, 1001,    0,    0,  993,    0,    0,    0,  386,    0,
    0,  575,    0,    0,    0,    0,    0,  387,    0,    0,
    0,    0,  863,  395,    0,    0,    0,  391,  392,    0,
    0,  388,    0,  396,    0,    0,    0,  343,  389,  393,
    0,    0,    0,  394,    0,    0,    0,  345,  346,  347,
  397,  173,  174,    0,    0,    0,    0,    0,    0,    0,
    0,  398,    0,    0,    0,    0,    0,    0,  390,    0,
  348,  349,  399,  400,  401,  402,  403,    0,  404,    0,
    0,    0,  350,  351,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  863,    0,    0,  391,  392,    0,  994,
    0,  407,    0,    0,  405,    0,  406,  395,  393,    0,
    0,    0,  394,    0,    0,    0,    0,  396,    0,  408,
    0,    0,    0,    0,  250,    0,    0,    0,    0,    0,
    0,  345,  346,  347,  397,  173,  174,    0,    0,    0,
    0,    0,    0,    0,    0,  398,    0,    0,    0,    0,
 1260,    0,    0,    0,  348,  349,  399,  400,  401,  402,
  403,    0,  404,    0,    0,    0,  350,  351,  994,    0,
    0,    0,    0,    0,    0,    0,  395,    0,    0,    0,
 1005,    6,    0,  993,    0,    0,  396,  386, 1461,    0,
    0,    0, 1355, 1356,    0, 1357,  387,    0, 1358,    0,
  345,  346,  347,  397,  173,  174,    0,    0,    0,    0,
  388,    0, 1359,    0,  398,    0,  343,  389, 1360,    0,
    0,    0,    0,  348,  349,  399,  400,  401,  402,  403,
    0,  404,    0,    0,    0,  350,  351,    0,    0,    0,
    0,    0,    1,  407,    0,    0,  405,  390,  406,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  408,    0,  292,    2,    0,  250,    0,    0,    0,
    0,    0,    3,    0,    0,  391,  392,    0, 1361,    4,
    0,    5,    0,    6,    0,    0,    0,  393,    7,    0,
    0,  394,    0,    0,  292,    8,    0,    0,   15,    0,
    0,  292,    0,    0,    0,  292,  292,    0,  292,    9,
    0,  292,    0, 1362,    0,    0,    0,    0,    0,    0,
   10, 1013,    0,   17,  993,  292,    0,    0,  386,    0,
  407,  292, 1462,  405, 1363,  406,    0,  387,    0,    0,
    0,  445,    0,    0,    0,    0,    0,  994,  408,    0,
    0,  388,    0,  250,    0,  395,    0,  343,  389,    0,
    0,    0,    0,    0,    0,  396,    0,    0, 1364,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  345,
  346,  347,  397,  173,  174,    0,    0,   11,  390,   12,
    0,  292,    0,  398,    0,   13,    0,    0,   14,    0,
   15,   16,  348,  349,  399,  400,  401,  402,  403,    0,
  404,  292,    0,    0,  350,  351,  391,  392,    0,    0,
    0,    0,    0,    0,    0,   17,  292,    0,  393,    0,
    0,    0,  394,    0,    0,    0,  292,    0,    0,    0,
    0,    0,    0,    0,    0,  292,    0,  292,    0,    0,
    0,    0,    0,    0,  292,    0,    0,    0,    0,    0,
    0,    0,    0, 1016,    0,    0,  993,    0,    0,    0,
  386,    0,  407,    0,    0,  405,    0,  406,    0,  387,
    0,  292,    0,    0,    0,    0,    0,    0,  994,    0,
  408,    0,    0,  388,    0,  250,  395,    0,    0,  343,
  389,    0,    0,    0,    0,    0,  396,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  345,  346,  347,  397,  173,  174,    0,    0,    0,    0,
  390,    0,    0,    0,  398,    0,    0,    0,    0,    0,
    0,    0,    0,  348,  349,  399,  400,  401,  402,  403,
 1021,  404,    0,  993,    0,  350,  351,  386,  391,  392,
    0,    0,    0,  859,  638,  636,  387,  637,    0,  639,
  393,    0,    0,  407,  394,    0,  405,    0,  406,    0,
  388,    0,  800,  799,  801,    0,  343,  389,    0,    0,
    0,  408,    0,    0,    0,    0,  250,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  390,    0,  407,
    0,  424,  405,    0,  406,    0,    0,    0,    0,    0,
  994,    0,    0,    0,    0,    0,    0,  408,  395,    0,
    0,    0,  250,    0,    0,  391,  392,    0,  396,    0,
    0,    0,    0,    0,    0,    0,    0,  393,    0,    0,
    0,  394,  345,  346,  347,  397,  173,  174,    0,    0,
    0,    0,    0,    0,    0,    0,  398,    0,    0,    0,
    0,    0,    0,    0,    0,  348,  349,  399,  400,  401,
  402,  403, 1024,  404,    0,  993,    0,  350,  351,  386,
    0,    0,    0,    0,    0,    0,    0,    0,  387,    0,
    0,    0,    0,    0,    0,    0,    0,  994,    0,    0,
    0,    0,  388,    0,    0,  395,    0,    0,  343,  389,
    0,    0,    0,    0,    0,  396,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  345,
  346,  347,  397,  173,  174,    0,    0,    0,    0,  390,
    0,    0,    0,  398,    0,    0,    0,    0,    0,    0,
    0,    0,  348,  349,  399,  400,  401,  402,  403,    0,
  404,    0,    0,    0,  350,  351,    0,  391,  392,    0,
    0,    0,    0, 1027,  787,    0,  993,    0,    0,  393,
  386,    0,  634,  394,    0,    0,    0,    0,  635,  387,
    0,  788,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  857,  388,  857,  857,    0,  857,    0,  343,
  389,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  857,    0,    0,    0,    0,  857,  386,  789,    0,    0,
    0,    0,    0,    0,    0,  387,  790,    0,    0,  994,
  390,    0,    0,    0,  791,    0,    0,  395,    0,  388,
    0,    0,    0,    0,    0,  343,  389,  396,    0,    0,
    0,    0,    0,  792,    0,  793,    0,    0,  391,  392,
    0,  345,  346,  347,  397,  173,  174, 1260,    0,  794,
  393,  795,  796,  797,  394,  398,  390,  630,    0,    0,
  630,    0,  630,    0,  348,  349,  399,  400,  401,  402,
  403,    0,  404,    0,    0,  630,  350,  351,    6,    0,
  630,    0,  344,    0,  391,  392,    0,    0,    0, 1355,
 1356,    0, 1357,    0,    0, 1358,  393,    0,    0,    0,
  394,    0,    0,  798,    0,    0,    0,    0,    0, 1359,
  994,    0,    0,    0,  407, 1360,    0,  405,  395,  406,
    0,  638,  636,    0,  637,    0,  639,    0,  396,    0,
    0,    0,  408,    0,    0,    0,    0,  250,    0,  800,
  799,  801,  345,  346,  347,  397,  173,  174,    0,    0,
    0,    0,    0,    0,    0,    0,  398,    0,    0,    0,
    0,    0,    0,    0,  395,  348,  349,  399,  400,  401,
  402,  403,    0,  404,  396, 1361,    0,  350,  351,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  345,  346,
  347,  397,  173,  174,    0,   15,    0,    0,    0,  857,
    0,    0,  398,    0,    0,    0,    0,    0,  857,    0,
 1362,  348,  349,  399,  400,  401,  402,  403,    0,  404,
   17,    0,  857,  350,  351,    0,    0,    0,  857,  857,
    0, 1363,    0,    0,    0,    0,    0,    0,  445,  407,
    0,    0,  405,    0,  406,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  408,    0,  857,
    0,    0,  250,    0,    0, 1364,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  630,    0,    0,
    0,    0,    0,    0,  630,  857,    0,  857,  857,    0,
    0,    0,    0,  630,    0,    0,    0,    0,    0,  857,
    0,    0,    0,  857,    0,    0,    0,  630,    0,    0,
    0,    0,    0,  630,  630,  407,  861,    0,  405,    0,
  406,  630,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  408,    0,    0,    0,    0,  250,    0,
    0,  386,    0,    0,  630,    0,    0,    0,    0,    0,
  387,  787,    0,    0,    0,    0,    0,    0,    0,  634,
    0,    0,    0,    0,  388,  635,    0,  857,  788,    0,
  343,  389,  630,  630,    0,    0,    0,  857,    0,    0,
    0,    0,    0,    0,  630,    0,    0,    0,  630,    0,
    0,  857,  857,  857,  857,  857,  857,    0,    0,    0,
    0,  390,    0,    0,  789,  857,    0,    0,    0,    0,
    0,    0,    0,  790,  857,  857,  857,  857,  857,  857,
  857,  791,  857,    0,    0,    0,  857,  857,    0,  391,
  392,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  792,  393,  793,    0,    0,  394,    0,    0,    0,    0,
    0,    0,  630,    0,    0,    0,  794,    0,  795,  796,
  797,    0,  630,    0,    0,  407,  386,    0,  405,    0,
  406,    0,    0,    0,    0,  387,  630,  630,  630,  630,
  630,  630,    0,  408,    0,    0,    0,    0,  250,  388,
  630,    0,    0,  628,    0,  343,  389,    0,    0,  630,
  630,  630,  630,  630,  630,  630,    0,  630,    0,  395,
  798,  630,  630,    0,    0,    0,    0,    0,    0,  396,
    0,    0,    0,    0,    0,    0,  390,    0,    0,    0,
    0,    0,    0,  345,  346,  347,  397,  173,  174,    0,
    0,    0,  386,    0,    0,    0,    0,  398,    0,    0,
    0,  387,  344,    0,  391,  392,  348,  349,  399,  400,
  401,  402,  403,    0,  404,  388,  393,    0,  350,  351,
  394,  343,  389,    0,    0,  407,    0,    0,  405,    0,
  406,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  408,  134,    0,    0,    0,  250,    0,
    0,    0,  390,  135,  136,  137,  138,  139,  140,  141,
  142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
  152,  153,  154,  155,    0,    0,    0,    0,    0,    0,
  391,  392,    0,    0,  395,    0,    0,    0,    0,    0,
    0,    0,  393,    0,  396,    0,  394,  407,    0,    0,
  405,    0,  406,    0,    0,    0,    0,    0,  345,  346,
  347,  397,  173,  174,    0,  408,    0,    0,    0,    0,
  250,    0,  398,    0,    0,    0,    0,    0,    0,    0,
    0,  348,  349,  399,  400,  401,  402,  403,    0,  404,
    0,    0,  386,  350,  351,    0,    0,    0,    0,    0,
    0,  387,    0,    0,    0,    0,    0,    0,    0,    0,
  395,    0,    0,    0,    0,  388,    0,    0,    0,    0,
  396,  343,  389,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  345,  346,  347,  397,  173,  174,
    0,    0,    0,    0,    0,    0,    0,    0,  398,    0,
    0,    0,  390,    0,    0,    0,    0,  348,  349,  399,
  400,  401,  402,  403,    0,  404,    0,    0,    0,  350,
  351,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  391,  392,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  393,    0,    0,    0,  394,    0,    0,    0,
  857,    0,  386,  857,    0,  857,    0,    0,    0,    0,
    0,  387,    0,    0,    0,    0,    0,    0,  857,    0,
    0,    0,    0,  857,  499,  388,    0,    0,    0,    0,
    0,  343,  389,  135,  136,  137,  138,  139,  140,  141,
  142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
  152,  153,  154,  155,  521,    0,    0,    0,  522,    0,
  395,    0,  390,    0,    0,    0,  701,    0,    0,    0,
  396,    0,    0,    0,  386,    0,    0,  523,    0,    0,
  524, 1019,    0,  387,  345,  346,  347,  397,  173,  174,
  391,  392,    0,    0,    0,    0,    0,  388,  398,    0,
    0,    0,  393,  343,  389,    0,  394,  348,  349,  399,
  400,  401,  402,  403,    0,  404,    0,    0,    0,  350,
  351,  525,    0,    0,    0,    0,    0,  526,  527,  528,
    0,  529,  530,  531,  390,  532,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  533,    0,  534,    0,    0,
    0,    0,  391,  392,    0,    0,    0,    0,    0,    0,
  395,    0,    0,    0,  393,    0,    0,    0,  394,    0,
  396,    0,    0,    0,    0,    0,    0,    0,  535,    0,
    0, 1188,    0,    0,  345,  346,  347,  397,  173,  174,
    0,    0,    0,    0,    0,    0,  536,    0,  398,    0,
    0,    0,    0,    0,    0,    0,    0,  348,  349,  399,
  400,  401,  402,  403,    0,  404,    0,  857,  537,  350,
  351,    0,    0,    0,    0,    0,  857,    0,    0,    0,
    0,    0,  395,  178,    0,    0,    0,    0,    0,    0,
  857,    0,  396,    0,    0,  773,  857,  857,    0,  522,
    0,    0,    0,  538,  539,    0,  345,  346,  347,  397,
  173,  174,    0,    0,  774,    0,    0,    0,  523,    0,
  398,  524,    0,    0,    0,    0,    0,  857,    0,  348,
  349,  399,  400,  401,  402,  403,    0,  404,    0,    0,
  521,  350,  351,    0,  522,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  857,  857,    0,    0,    0,
    0,    0,  525,  523,    0,    0,  524,  857,  526,  527,
  528,  857,  529,  530,  531,    0,  532,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  533,    0,  534,    0,
    0,    0,    0,    0,    0,    0,    0,  525,    0,    0,
    0,    0,    0,  526,  527,  528,    0,  529,  530,  531,
    0,  532,    0,    0,    0,    0,    0,    0,    0,  535,
    0,    0,    0,    0,    0,  857,    0,    0,    0,    0,
    0,  533,    0,  534,  521,  857,    0,  536,  522,    0,
    0,    0,    0,  214,    0,    0,    0,  214,    0,  857,
  857,  857,  857,  857,  857,    0,    0,  523,    0,  537,
  524,    0,  214,  857,  535,    0,  214,    0,    0,  214,
    0,    0,  857,  857,  857,  857,  857,  857,  857,    0,
  857,    0,  536,    0,  857,  857,    0,    0,    0,    0,
    0,    0,    0,    0,  538,  539,    0,    0,    0,    0,
    0,  525,    0,    0,  537,    0,    0,  526,  527,  528,
  214,  529,  530,  531,    0,  532,  214,  214,  214,  178,
  214,  214,  214,    0,  214,  127,    0,    0,    0,  127,
    0,    0,    0,    0,    0,  533,    0,  534,    0,  538,
  539,    0,    0,    0,  214,    0,  214,    0,  127,    0,
    0,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  535,    0,
    0,    0,    0,    0,    0,    0,    0,  214,    0,    0,
    0,    0,    0,    0,    0,    0,  536,    0,    0,    0,
    0,    0,  127,    0,    0,  214,    0,    0,  127,  127,
  127,    0,  127,  127,  127,    0,  127,    0,  537,    0,
    0,    0,    0,    0,    0,    0,    0,  214,    0,    0,
    0,    0,    0,    0,    0,    0,  127,    0,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  538,  539,    0,    0,    0,    0,    0,
    0,    0,  214,  214,    0,    0,    0,    0,    0,  127,
    0,    0,    0,    0,    0,    0,    0,    0,  418,    0,
    0,    0,    0,    0,    0,    0,    0,  127,  418,  418,
  418,  418,  418,  418,  418,  418,  418,  418,  418,  418,
  418,  418,  418,  418,  418,  418,  418,  418,    0,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  127,  127,
};
static short yycheck[] = {                                      17,
   56,    4,   48,  128,    4,   49,   57,   96,   55,    0,
  224,  224,  224,   56,   50,   59,  117,  118,  281,  117,
  118,  449,  324,  320,  316,   61,   77,  453,  670,  324,
   62,  491,   65,  295,  574,   81,  576,  482,   82,   80,
  485,  293,  678,  628,   86,   89,  491,   40,   42,  105,
  431,  107,   60,   85,   87,  232,    0,   75,  131,   45,
    0,  617,   40,    0,  108,    0,   84,  858,  245,   44,
  106,    0,  568,  109,   40,   83,    0,   58,  612,    0,
   40,  122,  338,   44,   40,   63,   41,    0,  278, 1046,
   59,   41,   58,   40,   44,  875,  964,   59,   40,   44,
  675,   44,  249,   63,  382, 1234,  253,  187,  197,   41,
  927,  258,  159,  669,   44,   59,    0,   41,   45,   59,
   44,  938,   59,   41,   59,   42,  224,   41,   41,    0,
   59,   41,   44, 1109,   44,   59,  183,  954,   59,  353,
  353,  353,   40,  919,   40,    0,   59,  236,   45,   45,
  926,    0,    0,  278,    0,   45,  281,   41,  238,   45,
   44,   44,   41,  926,  461,  264,   44,  260,   45, 1145,
  226,   63,  260,  288,  274,   59,  468,  469,  470,  471,
  288,   44,  288,  919, 1052,  260,   63,   40,   59,  491,
  926,  368,  284,  264,  230,  258,  491,    0,  349, 1247,
  321, 1114,  309,  329,   59, 1154,  268,  243,  265,  282,
   59,   59,    0,   59,  302,  265,  262,  645,    0,  516,
  356,  997,  278,    0,  277,  302,  314,  257,    0,  243,
  266,    0,  919,  257,  260,   91,    0,  445,  294,  926,
 1216,    0,  494,  738,  307,  301,  303,  303,  948,  305,
  262,  339,  308,  303,  462,  353,   59,  460,  405,  406,
  407,    0,  802,  803,   41,  521,   17,   44,    0,  825,
  317,   59,  319,    0,    0,    0,  457,   59,  304,  724,
   44,  338,   59,  330,  463,  464,  820,   59,  334,  541,
   59,  494,  285,  346,  406,   59,  332,  831,  832,   41,
   59,  321, 1082,  376,  366,  335, 1123,   44,   44,   41,
  997,  335,  463,  464,  426,   41,   41,  438,    0,  445,
   59,  409,   13,  367,   75,    0,  419,   59,  364,    0,
  262,  419,   59,   59,   59,  338,  462,  615,  382,  375,
  264,  377,  413,  264,  419, 1294,  453,  462,  384,  441,
    0, 1480, 1265,    0,  462,  491,  444,  420, 1134,   41,
 1151,    0,   44,  462,  274,  746,   41,  444,  468,   44,
  384, 1134, 1329,   44,  258,  387,  319,   59,  918,    0,
  297,  595,  595,  595,   59,  970,  264,  258,   59,  329,
    0, 1439,  332,  277,  278,  332,  280,  321, 1134,  974,
  310,  285, 1270,  258,  288,  319,  319,  508,  488,   59,
  673,  329,   59,    0,  332, 1391,  269,  301,  264,  466,
   59,  277,  305,  307,  115,  612,  403,  604,  341,  576,
  278,  310,  280,  462,  686,  491,  307,  689,   59,  384,
 1140, 1258,  397,  412, 1261,   41, 1263, 1134,  395,   59,
  412,  703,  307,  273,   41,  387,  259,  397, 1094,   41,
  397,  264,  397,  413,  511,   41, 1246,  270,  462,  462,
  617, 1288,   59,  620,  460,  388,  666,  398,  625,  397,
  732,  462,  460,  979,  397,  460,  633,    0,  635,  636,
  637,  638,  639,  454,  641,  379,  462,  595,    0,  646,
  460,  509,  442,  413,  560,  442,  462,  442,  494,  771,
  557,  558,  456,  442, 1331, 1306,  456,  401,  521,  456,
  462,  456,  669, 1057,  780,  409,  456,  456,   41,  442,
  454,   44, 1308,  460,  418, 1352,  420,  433,  462,   41,
  596,  666,   44,  456,  456,  462,   59,  433,  673,  420,
  651,  449, 1047,    0,  438,  611,  433,   59,  468,  443,
 1100,  349,  411,  460,  460,  420,  569,  349,  460,  569,
  460,  615,  462, 1390,  460,  438,  258, 1117,  619,  685,
  681,  682, 1399,  460,  321,  321, 1171,  319,  472, 1491,
  332,   41,  274,  319,  319,  398,  368,  329,  287,  368,
  332, 1301,  341,  278,  320,  280,  332,  384,   42,  341,
  666,  404,   59,  288,  906,  341,  341, 1253,   13,  675,
  460, 1308,  462,    0,  660,  307,  662,   59,  310,  422,
  677,  678,  809,  820, 1129,  812,   41,  278,   42,  695,
  787,  788,  789,   47,  831,  792,  793,  794,  319,  796,
  797,  798,  799,  800,  801,  397,  388,  278, 1214,  280,
 1477,  357,  388,  388, 1566,  397,  262,  723,  724,  319,
  341,  397,  924,  965,  258, 1519,  684,    0,  825,  320,
  262, 1039,   59, 1041,  936,  401,  262,  834,  835, 1591,
  837,  341,  839,    0,  341,  842,  843,  844,  845,  846,
  847,  953,  341,    0,  379,  919,  919,  462, 1248,  782,
  442,  784,  926,  926,  722,  977,  442,  442,   41,  329,
  115,   44,  332,  307,  456,  378,  401,  443,  731,    0,
  456,  413,  319,  769,  409,  431,   59,  411,  420,  302,
  743, 1585,  329,   40,   41,  332,  378,   44,  756,  757,
  758, 1132,   59,  273,  341,  406,  438, 1138,  379,  388,
  401, 1221,   59, 1607,  260,   44,  810,  420,  443,   40,
   41,  813,  344,   44,  463,  464,  339,  780,    0,  811,
   59,  814,  259,    0,  997,  997,  468,  397,   59,    0,
  472,  387, 1435,  270,   91,  326, 1438,  369, 1060,    0,
  258,  388,  443,  261,  302,  387,  319,  458,  304,  322,
  397,  387,  262,  442,  467,  284,  329,  319,  450,  332,
   91,  341,  462,  336,   42,   43,  260,   45,  341,   47,
  332,  344,  442,    0,  710, 1482,  420,   59, 1264,  341,
   41,  339,   59,   44,  454,    0,  456,  360,   59,  307,
  951, 1148, 1278,  263,  438,  442,  428,  262,   59, 1217,
  344, 1008, 1009,  462, 1011, 1012, 1080,  454,  462, 1121,
  304,  384, 1019, 1516,  387,  388,  280,   44,  301,  419,
  288,  444,  286,  462,  397,  369,  388,   44,  472,   44,
   91,    0,   59,  301,    0,  397,  343, 1437, 1150,  997,
  460,  432,  415,  313,   59,  272,  446, 1554,  439, 1354,
 1338,  967, 1452, 1556,  324, 1455,  385, 1064,  974, 1221,
 1134, 1134,  289,  406,  398, 1072, 1221, 1074, 1075,  442,
  353,  378, 1513, 1080,    0, 1511,   93,  387,   44, 1586,
  442,  454,  945,  456,  428,  945,  444, 1045, 1046, 1047,
   59,  259,  960,   59,  456,  278, 1081,  280, 1250,  406,
  460,  258,  270,  410,  438, 1112,  343,  334,  976, 1550,
  462,  278,  441,  280,  982,  458, 1552,  274,  462,  426,
  277,  278,  387,  280, 1247, 1254,  279,  258,  285,  458,
  349,  288,    0,   59,    0, 1096,  363, 1098,  472,  358,
  326,  378, 1583,  274,  301,  452,  277,  278, 1584,  280,
  307,    0,  322,  310,  285, 1267,  260,  288,  329,  429,
 1289, 1168,   42,   43, 1605,   45,  336,   47,   41,  406,
  301,   44,    0,  410, 1181,   41,  307,  330,   44,  310,
    0, 1188, 1045, 1046, 1296, 1146,  302, 1094, 1476,  426,
  360,   59,  378,   59,  930,  931,  379,  258,   42,   43,
  304,   45,  280,   47,  431, 1073,   44, 1214,  286,    0,
   59,  364,    0,  274, 1614,  452,  277,  278,  401,  280,
    0, 1372,  379,  339,  285,  323,  409,  288,    0,  382,
 1518,   59,  403,  206,  419, 1308, 1308,  319,  974,   59,
  301,  214,  462,  321,  401,  415,  307,    0,  379,  310,
  265,    0,  409,  462, 1161,   93,  413,  403, 1165,  341,
  443,  446, 1247,  420, 1127, 1339,  343, 1127,   59,  440,
  401,   59,  343,  462,  445, 1260,  698,  323,  409,   59,
  451,  438,  413,  322, 1291,  707,  443,   59,  303,  420,
  436,  462,   41,  409,    0,   44,  462,  336,   44,  470,
  402,  378,  329,  419,  319,  332,   59,  438, 1315, 1316,
   59,  468,  443,  280,    0,  472, 1439,  344,  379,  286,
    0,  360,   42,   43,   40,   45,  341,   47,  444,  406,
    0,  384, 1339,  410,    0,  406, 1459,  468,  760,  410,
  401,  472,   91, 1259, 1260,  384, 1253,   93,  409,  426,
 1308,  384,  413,   59, 1361,  426, 1259,   42,   43,  420,
   45,   41,   47,  329,   44,    0,  332, 1490, 1491,  379,
  397, 1329, 1268,   59,  343,  452,  415,  438,  344,   59,
    0,  452,  443,  295,   44,   44,  260, 1372, 1349,   59,
 1541,  401,   40,   59,  306,   41, 1403,   45,   44,  409,
  280,  313, 1525,  386, 1411,  827,  286,  468,  384,  378,
   58,  472,  278, 1536,  280,  442, 1490, 1490, 1490,  285,
 1571, 1572,  288,    0,   59,    0,  338,  454,    0,  456,
  304,  397,  312,  443,   93,  301,  280,  406,  493,   59,
 1389,  410,  286, 1566, 1355, 1568,  384,   93, 1599,    0,
  338, 1525, 1525, 1525, 1439,  436, 1372,  426,    0,    0,
   42,   43, 1613,   45,   41,   47, 1329,   44, 1591,   41,
   40,    0,   44, 1336, 1459,   45,  442,  321,    0,    0,
  420,  462,   59,  452,   59,  317,  318,   59,  454, 1385,
  456,  403,  462,   63, 1568, 1568, 1568, 1404,  260,   41,
   41, 1408,   44,   44,    0, 1490, 1491, 1358,   59,  258,
   41,   42,   43,  379,   45,  937,   47,   59,   59,  322,
   41, 1470,  274,   44,  436,  274,    0,  353,  440,  278,
   59,  280,    0,  336,  319,  401,  285,   59,   59,  288,
 1525,  344,  304,  409,    0, 1449,  492,  493,    0,   91,
   91, 1536,  301,  379,   40,   45, 1541,  360,  307,   41,
  280,  310,   44,   59,    0,    0,  286,    0,   58,  426,
   44,   41,   45,  463,   44,  322,    0,  443,  258,   41,
    0, 1566,   44, 1568,  343,   59, 1571, 1572, 1499,  336,
   63,   59,  312,  279,    0,  280,  264, 1475,  278,    0,
  280,  286,  467,   59,  469,  285, 1591,   59,  288, 1487,
  317,   93,  415,  360, 1599,  301,  319,   41,    0,  378,
   44,  301,  642,   59,   59, 1541,   59,  307, 1613,  338,
  379,   42,   43, 1511,   45,   59,   47,  384, 1501,   59,
  338, 1501, 1520,   41,  330,  665,   44,  406,  296,  392,
  393,  410,  401,   59,  674, 1571, 1572, 1563,   59,   41,
  409,  462,   44,  349,  413,  338,  375,  426,  415,  403,
   41,  420,  358,   44, 1552,  671,  672,   59,  364,  388,
  262,  258, 1560, 1599, 1039,  616, 1041,  618,  337,  438,
  621,  622,  623,  452,  443,  321,  382, 1613,  280,  379,
  277,  278,  375,  280,  286,  353, 1584,   41,  285,   41,
   44,  288,   44,  463,  464,  388,  258,  258,  454,  468,
  341,  401,   41,  472,  301,   44,  296,  319,   41,  409,
  307,   44,  274,  274,    0,  362,  278,  278,  280,  280,
  420,  403,  438,  285,  285,  357,  288,  288,  384,  280,
   41,   42,   43,  384,   45,  286,   47,  452,  438,  301,
  301,    0,  436,  443,   41,  307,  307,   44,  310,  310,
   41,  462,  419,   44,   40,   41,   42,   43,   44,   45,
   46,   47,  394,  353,  396,   41,   42,   43,  444,   45,
  358,   47,  472,   59,   60,   61,   62,   41,   42,   43,
  288,   45,  379,   47,  413,  264,  296,  322,  420,   44,
  471,  459,  460,  461,  462,  463,  464,  459,  460,  461,
   59,  336,  287,  296,  401,   91,  373,   93,   41,  344,
   61,   44,  409,  445,  482,  483,   41,  379,  379,   44,
  463,   41,   40,  420,   44,  360,  494,  495,  322,   40,
  463,  262,  494,  495,  278,  329,  280,  463,  332,  401,
  401,  438,  336,  353,  288,   44,  443,  409,  409,  280,
  344,  413,  413,    0,  438,  286,  462,  301,  420,  420,
  353,   41,   42,   43,   40,   45,  360,   47,   40,  459,
  460,  461,  321,  463,  464,  472,  438,  438,   44,  403,
  415,  443,  443,   40,    0,   41,   42,   43,   40,   45,
  384,   47,  482,  483,   41,   42,   43,   44,   45,   41,
   47,   40,   44,  397,  494,  495,  468,  468,   40,   40,
  472,  472,   59,   60,   61,   62,   41,   40,   40,   44,
  322,  415,   40,   40,  462,   41,  420,  329,   44,   40,
  332,   91,   46,    0,  336,  379,  321,   44,   44,  430,
   61,   46,  344,   59,  280,   44,   93,  383,  442,  459,
  460,  461,  462,  463,  464,   46,  349,  401,  360,   44,
  454,  278,  456,  278,  301,  409,  459,  460,  461,  280,
  463,  464,  482,  483,   41,  286,  262,   44,  264,  264,
  438,  462,  384,  398,  494,  495,  272,  398,  472,  482,
  483,  460,   59,  277,  280,  397,  400,  449,  449,  443,
  286,  494,  495,  289,  280,   40,  350,   40,   91,   40,
  286,   40,  264,  415,  384,  413,  280,   44,  390,    0,
  279,  383,  286,   40,   40,  438,  312,  466,   41,   42,
   43,  318,   45,  319,   47,  321,  322,   40,  264,  325,
  442, 1459,  301,  329,  321,    0,  332,  321,  334,   41,
  336,  454,  454,  462,  456,  341,  342,  462,  344,  460,
   41,   42,   43,   44,   45,   40,   47,  450,  277,    0,
  274,  330, 1490, 1491,  360,  361,   40,  363,   59,   60,
   61,   62,  301,  285,  345,  345,   41,  278,  420,   44,
  349,  377,  418,  379,  380,  381,  301,  420,  384,  358,
  280,  387,  388,   40,   59,  364,  286, 1525,    0,  357,
   41,  397,   93,  419,   40,  262,  274,  264, 1536,  462,
   40,   44,  368,  382,  280,  272,   44,  321,   59,  415,
  286,  264,  386,  280,   41,   44,  321,  280,   40,  286,
   44,  329,  289,   44,   40,  431,  266,  300, 1566,   41,
 1568,   40,   44,  462,  264,  424,  442,  456,    0,   41,
   58,   45,  278,   41,  280,  312,   41,   59,  454,   41,
  456,  442,  319, 1591,  321,  322,  462,  491,  325,   63,
  395,  310,  329,  310,    0,  332,   41,  334,   41,  336,
    0,   40,   40,   40,  341,  342,   40,  344,  353,   41,
   42,   43,   44,   45,   40,   47,   41,   42,   43,   40,
   45,   40,   47,  360,  361,   40,  363,   59,   60,   61,
   62,   42,   43,   40,   45,   41,   47,   40,   44,   40,
  377,   41,  379,  380,  381,   40,   40,  384,   59,   40,
  387,  388,   40,   59,   40,   44,  328,  262,   41,   59,
  397,   93,  319,  474,  475,  476,  477,  478,  479,  480,
  481,  389,  329,  379,  344,  332,  274,  280,  415,  332,
  389,  448,  271,  286,  341,  424,  389,  344,  288,  391,
   41,  262,  379,  264,  431,  401,   41,  278,   41,   42,
   43,  272,   45,  409,   47,  442,  392,   40,  386,   41,
  409,   41,   41,  438,  419,  286,   41,  454,  289,  456,
  397,  462,   41,   41,  353,  462,  386,  372,    0,  372,
   41,  388,   41,  278,    0,  280,   41,  443,   41,   41,
  397,  312,   41,  288,   41,   41,   41,   41,  319,   41,
  321,  322,   41,   41,  325,   41,  301,   41,  329,   41,
    0,  332,  280,  334,   44,  336,  403,   40,   59,   41,
  341,  342,   44,  344,  341,   41,   42,   43,   44,   45,
   59,   47,   40,   59,   59,  442,  341,   59,   59,  360,
  361,   59,  363,   59,   60,   61,   62,  454,  319,   59,
   41,   41,  353,  345,   44,   41,  377,  321,  379,  380,
  381,  332,  369,  384,   40,   59,  387,  388,  341,   59,
  341,   59,  296,  384,  462,  384,  397,   93,  384,   44,
  262,   41,  264,   41,  379,   44,  412,  319,   44,  305,
  272,  437,  302,  444,  415,   41,  344,  329,   40,  305,
  332,  465,   59,  294,   44,  280,  401,  289,  308,  341,
  431,  286,  344,   44,  409,   41,    0,  388,  338,  280,
   40,  442,  278,    0,  280,  286,  397,  384,  384,  285,
  312,  278,  288,  454,  264,  456,  264,  319,  460,  321,
  322,  462,  321,  325,  390,  301,  264,  329,  443,  472,
  332,  413,  334,   40,  336,   45,  388,  460,  310,  341,
  342,  271,  344,  438,   41,  397,   43,   44,   45,  319,
  264,  442,  260,   63,  344,  460,  344,  344,  360,  361,
  344,  363,   59,   60,   61,   62,  271,  280,   41,   42,
   43,  341,   45,  286,   47,  377,   41,  379,  380,  381,
   40,   40,  384,    0,   41,  387,  388,   41,   59,  305,
  442,   59,   41,    0,  302,  397,   93,   13,    0,    0,
  234,  445,  454,  379, 1042,  245,  314,  233,  604,  979,
  564,  772,   79,  415,  974,  459,  460,  461,  388,  463,
  464,  977,  966, 1279,   41,  401,  262,  397,  264,  431,
  321,  339,  958,  409,  291,  516,  272,  909,  482,  483,
  442,  240,   59,  487,  488,  705,  611,  286,  967, 1506,
  494,  495,  454,  289,  456,  303,  303,  792, 1267,  794,
  462,  796,  797,    0,  799,  800,  801,  443,  278,    0,
  280, 1265,  442,  496, 1510, 1509,  312,  319,  288, 1545,
  322,  695, 1110,  319, 1525,  321,  322,  329, 1598,  325,
  332, 1464, 1542,  329,  336, 1291,  332, 1511,  334,  341,
  336,  409,  344,  767,  561,  341,  342,  969,  344,  353,
   41,  419,   43,   44,   45, 1290,  308,  289,  360,  498,
  753,  296,   59,  554,  360,  361, 1136,  363,   59,   60,
   61,   62,   14,  745,  270,  433,  444,  673,  660,  646,
  437,  377,  384,  379,  380,  381,  388,  647,  384, 1339,
  875,  387,  388,  120,  462,  397, 1347,    0, 1439, 1560,
 1616,  397,   93, 1520,  449,  262,  609,  264,  826,  379,
 1010,  641,   -1,  415,  384,  272,   -1,   -1,  352,  415,
   -1,   -1,   -1,   41,   42,   43,  296,   45,   -1,   47,
   -1,  401,  289,   -1,   -1,  431,   -1,   -1,   41,  409,
  442,   44,   -1,   -1,   -1,   -1,  442,  280,    0,   -1,
   -1,   -1,  454,  286,   -1,  312,   59,   -1,  454,   -1,
  456,   -1,  319,   -1,  321,  322,  462,   -1,  325,   -1,
   -1,   -1,  329,  443,    0,  332,   -1,  334,   -1,  336,
   -1,   -1,   -1,  279,  341,  342,   -1,  344,   -1,   41,
   -1,   43,   44,   45,   -1,   -1,   -1,  260,   -1,   -1,
   -1,   -1,   -1,  360,  361,  301,  363,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,
  377,   -1,  379,  380,  381,   -1,   -1,  384,   -1,   -1,
  387,  388,   -1,   59,  330,   -1,   -1,   -1,   -1,  302,
  397,   93,  319,   -1,   -1,   -1,   -1,   45,   -1,  419,
   -1,  314,  329,  349,   -1,  332,   -1,   -1,  415,   -1,
   -1,  258,  358,   -1,  341,  328,   -1,   -1,  364,   -1,
   -1,  262,   -1,  264,  431,  445,  339,   -1,   -1,   -1,
   -1,  272,  279,   -1,   -1,  442,  382,   -1,   -1,  459,
  460,  461,   -1,  463,  464,   -1,   -1,  454,  289,  456,
   -1,   -1,   -1,   -1,  301,  462,   -1,   -1,   -1,   -1,
  307,  388,  482,  483,    0,   -1,   -1,  487,  488,   -1,
  397,  312,   -1,   -1,  494,  495,   -1,   -1,  319,   -1,
  321,  322,   -1,  330,  325,   -1,   -1,   -1,  329,    0,
   -1,  332,   -1,  334,   -1,  336,  409,   -1,   -1,   -1,
  341,  342,  349,  344,   -1,   41,  419,   43,   44,   45,
  357,  358,  280,   -1,   -1,  442,   -1,  364,  286,  360,
  361,   -1,  363,   59,   60,   61,   62,   -1,   -1,   -1,
   41,  444,   -1,   44,   -1,  382,  377,    0,  379,  380,
  381,   -1,   -1,  384,   -1,   -1,  387,  388,   59,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  397,   93,   -1,   -1,
  262,   -1,  264,   -1,   -1,   -1,  319,    0,   -1,  322,
  272,   -1,   -1,  420,  415,   -1,  329,   -1,   41,  332,
   -1,   44,   -1,  336,  431,   -1,  262,  289,  341,   -1,
  431,  344,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,  442,   -1,   -1,   -1,   -1,   -1,  360,   41,   -1,
  312,   44,   -1,  454,   -1,  456,   -1,  319,   -1,  321,
  322,  462,   -1,  325,   -1,   -1,   59,  329,   -1,   -1,
  332,  384,  334,   -1,  336,  388,   -1,   -1,   -1,  341,
  342,   -1,  344,  319,  397,   -1,  322,   -1,  296,   -1,
   -1,   -1,   -1,  329,   -1,   -1,  332,   -1,  360,  361,
  336,  363,  415,   -1,   -1,  341,    0,   -1,  344,   -1,
   -1,   -1,   -1,   -1,   -1,  377,   -1,  379,  380,  381,
   -1,   -1,  384,   -1,  360,  387,  388,   -1,   -1,  442,
   41,   42,   43,   -1,   45,  397,   47,   -1,   -1,   -1,
    0,  454,   -1,   -1,   -1,  353,   -1,   41,  384,  462,
   44,  387,  388,  415,   41,   42,   43,   -1,   45,   -1,
   47,  397,   -1,   -1,   -1,   59,  262,   -1,  264,  431,
   -1,   41,   42,   43,   -1,   45,  272,   47,   -1,  415,
  442,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
    0,   -1,  454,  289,  456,   -1,   -1,   -1,   -1,   59,
  462,   -1,   -1,   -1,   -1,   -1,  442,  278,   -1,  280,
   -1,   -1,   -1,    0,   -1,   -1,  312,  288,  454,   -1,
  456,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,  325,
   -1,   41,   -1,  329,   44,   -1,  332,  445,  334,  262,
  336,   -1,   -1,   -1,   -1,  341,  342,   -1,  344,   59,
   -1,  459,  460,  461,   41,  463,  464,   44,   -1,   -1,
   -1,   -1,   -1,   -1,  360,  361,   -1,  363,   -1,  262,
   -1,   -1,   59,   -1,  482,  483,  484,  485,  486,  487,
  488,  377,   -1,  379,  380,  381,  494,  495,  384,   -1,
    0,  387,  388,   -1,   -1,   -1,  319,   -1,   -1,  322,
   -1,  397,   -1,   -1,   -1,   -1,  329,   -1,  379,  332,
   -1,   -1,   -1,  336,   -1,   -1,   -1,   -1,  341,  415,
   -1,  344,   -1,   -1,   -1,   -1,  319,   -1,   -1,  322,
  401,   41,   -1,   -1,   44,  431,  329,  360,  409,  332,
   -1,   -1,   -1,  336,   -1,   -1,  442,   -1,  341,   59,
   -1,  344,   -1,   41,   42,   43,   -1,   45,  454,   47,
  456,  384,   -1,   -1,  387,  388,  462,  360,  262,  280,
   -1,    0,  443,   -1,  397,  286,   -1,    0,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,    0,   -1,   -1,
   -1,  384,  415,  280,  387,  388,   -1,   -1,   -1,  286,
   -1,   -1,  262,   -1,  397,   -1,   -1,   -1,   -1,   -1,
  280,   -1,   41,   -1,   -1,   44,  286,   -1,   41,  442,
   -1,   44,  415,   -1,   -1,  319,   -1,   -1,  322,   -1,
   59,  454,   -1,  456,   -1,  329,   59,   -1,  332,   -1,
   -1,   -1,  336,   -1,   -1,   -1,   59,  341,   -1,  442,
  344,   -1,  262,   -1,   -1,   -1,   -1,   -1,    0,  319,
   -1,  454,  322,  456,   -1,   -1,  360,   -1,   -1,  329,
   -1,   -1,  332,   -1,   -1,  262,  336,   -1,   -1,    0,
   -1,  341,   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,
  384,   -1,   -1,  387,  388,   -1,   -1,   -1,   -1,   41,
  360,   -1,   44,  397,   -1,   -1,   -1,   -1,   -1,  319,
   -1,   -1,  322,   -1,   -1,   -1,   -1,   59,   -1,  329,
   41,  415,  332,   44,  384,   -1,  336,  387,  388,   -1,
   -1,  341,  319,   -1,  344,  322,   -1,  397,   59,   -1,
   -1,   -1,  329,   -1,   -1,  332,   -1,   -1,  442,  336,
  360,   -1,  262,   -1,  341,  415,   -1,  344,   -1,   -1,
  454,   -1,  456,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  360,  384,   -1,   -1,  387,  388,    0,
   -1,   -1,  442,   -1,   -1,   -1,   -1,  397,   -1,   -1,
   -1,   -1,  280,   -1,  454,   -1,  456,  384,  286,   -1,
  387,  388,   -1,   -1,   -1,  415,   -1,   -1,   -1,  319,
  397,   -1,  322,   -1,   -1,   -1,   -1,   -1,  280,  329,
   41,    0,  332,   44,  286,   -1,  336,   -1,  415,   -1,
   -1,  341,  442,  262,  344,   -1,   -1,   -1,   59,  262,
   -1,   -1,    0,   -1,  454,  258,  456,   -1,   -1,   -1,
  360,   -1,   -1,   -1,   -1,  442,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   -1,   -1,   44,  279,  454,   -1,  456,
   -1,   -1,   -1,   -1,  384,   -1,   -1,  387,  388,   -1,
   59,   -1,   -1,   41,    0,   -1,   44,  397,  301,   -1,
  319,   -1,   -1,  322,  307,   -1,  319,   -1,   -1,  322,
  329,   59,   -1,  332,   -1,  415,  329,  336,   -1,  332,
   -1,   -1,  341,  336,   -1,  344,   -1,  330,  341,   -1,
  262,  344,   -1,   -1,   -1,   41,    0,   -1,   44,   -1,
   -1,  360,  442,   -1,   -1,   -1,  349,  360,   -1,   -1,
   -1,  262,   -1,   59,  454,  358,  456,   -1,   -1,   -1,
   -1,  364,   -1,   -1,   -1,  384,   -1,   -1,  387,  388,
   -1,  384,   -1,   -1,  387,  388,   -1,   41,  397,  382,
   44,   -1,   -1,   -1,  397,   -1,   -1,  319,   -1,   -1,
  322,   -1,   -1,   -1,   -1,   59,  415,  329,   -1,   -1,
  332,   -1,  415,   -1,  336,   -1,   -1,   -1,  319,  341,
   -1,  322,  344,    0,   -1,   -1,   -1,  420,  329,   -1,
   -1,  332,   -1,  442,   -1,  336,   -1,   -1,  360,  442,
  341,   -1,   -1,  344,   -1,  454,   -1,  456,   -1,   -1,
    0,  454,   -1,  456,   -1,   -1,   -1,   -1,   -1,  360,
   -1,  262,  384,   -1,   41,  387,  388,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,
   -1,   -1,   59,  384,   -1,    0,  387,  388,   -1,   -1,
   -1,   41,   -1,  415,   44,   -1,  397,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,   -1,   -1,   -1,    0,   59,
   -1,   -1,   -1,   -1,  415,   -1,   -1,    0,  319,   -1,
  442,  322,   -1,   -1,  262,   -1,   41,   -1,  329,   44,
   -1,  332,  454,   -1,  456,  336,   -1,   -1,   -1,   -1,
  341,  442,   -1,  344,   59,   -1,   -1,   -1,   -1,   41,
   -1,    0,   44,  454,   -1,  456,   -1,   -1,   -1,  360,
  319,   -1,   -1,  322,   -1,   -1,  262,   59,   -1,   -1,
  329,    0,   -1,  332,   -1,   -1,   59,  336,   -1,   -1,
   -1,  319,  341,  384,  322,  344,  387,  388,   -1,   -1,
   -1,  329,   41,   -1,  332,   44,  397,   -1,  336,   -1,
   -1,  360,   -1,  341,   -1,   -1,  344,   -1,  262,   -1,
   59,   -1,   41,   -1,  415,   44,   -1,   -1,   -1,   -1,
   -1,   -1,  360,  319,   -1,  384,  322,   -1,  387,  388,
   59,   -1,   -1,  329,   -1,   -1,  332,   -1,  397,   -1,
  336,  442,   -1,   -1,   -1,  341,  384,   -1,  344,  387,
  388,   -1,   -1,  454,   -1,  456,  415,   -1,   -1,  397,
   -1,   -1,   -1,   -1,  360,  319,   -1,   -1,  322,   -1,
   -1,   -1,   -1,   -1,   -1,  329,   -1,  415,  332,   -1,
   -1,   -1,  336,  442,   -1,  262,   -1,  341,  384,   -1,
  344,  387,  388,   -1,   -1,  454,   -1,  456,   -1,   -1,
   -1,  397,   -1,   -1,  442,   -1,  360,   -1,  258,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  454,   40,  456,  415,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,  279,
  384,   -1,   -1,  387,  388,   58,   -1,   -1,   -1,   -1,
   63,   -1,  319,  397,   -1,  322,  442,   -1,   -1,   -1,
   -1,  301,  329,   -1,   -1,  332,   -1,  307,  454,  336,
  456,  415,    0,  278,  341,  280,   -1,  344,   -1,   -1,
  262,   -1,   -1,  288,   40,  258,   -1,   43,   -1,   45,
  330,   -1,   -1,  360,   -1,   -1,   -1,   -1,  442,   -1,
   -1,   -1,   58,   -1,   -1,   -1,  279,   63,   -1,  349,
  454,   -1,  456,   -1,   -1,   -1,   -1,  384,  358,   -1,
  387,  388,   -1,   -1,  364,   -1,   -1,    0,  301,   -1,
  397,   59,   -1,   -1,  307,   -1,   -1,  319,   -1,  278,
  322,  280,  382,  262,   -1,   -1,   -1,  329,  415,  288,
  332,   -1,   -1,  295,  336,   -1,   -1,  330,   -1,  341,
   -1,  306,  344,   -1,  306,   -1,   -1,   -1,  313,   -1,
   -1,  313,  317,  318,  379,  442,  349,   -1,  360,   -1,
  420,  326,   -1,   -1,  326,  358,   59,  454,   -1,  456,
   -1,  364,   -1,  338,   -1,   -1,  401,   -1,   -1,   -1,
  319,   -1,  384,  322,  409,  387,  388,   -1,   -1,  382,
  329,   -1,   -1,  332,   -1,  397,   -1,  336,   -1,   -1,
   -1,   -1,  341,    0,   -1,  344,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  415,   -1,   -1,   -1,   -1,  443,   -1,
  379,  360,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,   -1,  267,   -1,   -1,   -1,  403,   -1,
  442,  403,  401,  276,   41,  384,   -1,   44,  387,  388,
  409,   -1,  454,   -1,  456,   -1,  421,  290,  397,  421,
  293,   -1,   59,  296,  297,   -1,   -1,   -1,   -1,   -1,
   -1,  436,   -1,   -1,  436,  440,  415,   -1,  440,   -1,
   -1,  443,  315,   -1,  443,   -1,  451,   -1,   -1,  451,
   -1,  267,   -1,   40,  327,   42,   43,   -1,   45,   -1,
  276,   -1,   -1,  442,   -1,  470,   -1,   -1,  470,   -1,
  258,   58,   -1,   -1,  290,  454,   63,  456,   -1,   -1,
  296,  297,  355,  356,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  279,   -1,   -1,  367,   -1,   -1,   -1,  371,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  379,   40,   -1,   42,
   43,  327,   45,  301,   -1,   -1,   -1,   -1,   -1,  307,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,
  356,   -1,  330,   -1,   -1,   -1,  279,   -1,   -1,   -1,
  423,  367,   -1,   -1,   -1,  371,   -1,   -1,   -1,   -1,
   -1,  349,  435,  379,   -1,   -1,   -1,   -1,  301,   -1,
  358,   -1,  445,   -1,   -1,   -1,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  459,  460,  461,  462,
  463,  464,   -1,   -1,  382,   -1,   -1,  330,   -1,   -1,
  473,   -1,   -1,  419,   -1,   -1,   -1,  423,   -1,  482,
  483,  484,  485,  486,  487,  488,  349,  490,   -1,  435,
   -1,  494,  495,   -1,  357,  358,   -1,   -1,   -1,  445,
   -1,  364,  420,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  459,  460,  461,  462,  463,  464,  382,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  473,  273,   -1,
   -1,  394,  277,  396,   -1,   -1,  482,  483,  484,  485,
  486,  487,  488,  260,  490,   -1,   -1,  292,  494,  495,
  267,  296,  319,   -1,  299,  322,   -1,  420,   40,  276,
   -1,   43,  329,   45,   -1,  332,   -1,   -1,   -1,  336,
   -1,   -1,   -1,  290,  341,   -1,   58,  344,   -1,  296,
  297,   63,  445,   -1,   -1,   -1,   -1,  304,   -1,   -1,
   -1,   -1,   -1,  360,   -1,  340,   -1,  260,   -1,   -1,
   -1,  346,  347,  348,  267,  350,  351,  352,   -1,  354,
  327,    0,   -1,  276,   -1,   -1,   -1,  384,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,  290,   -1,  374,
  397,  376,   -1,  296,  297,   -1,  353,   -1,  355,  356,
   -1,  304,   40,   -1,   -1,   43,   -1,   45,  415,   -1,
  367,   -1,   41,   -1,  371,   44,   -1,   46,   -1,   -1,
   58,   -1,  407,   -1,  327,   63,   -1,   -1,  413,   -1,
   59,   -1,   61,   -1,   -1,  442,   -1,   -1,   -1,   -1,
  425,   -1,   -1,   -1,   -1,   -1,   -1,  454,   -1,   -1,
  353,   -1,  355,  356,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  447,   -1,  367,   -1,   -1,   -1,  371,   -1,
   -1,   40,   -1,   -1,   43,   -1,   45,   -1,  435,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,  482,  483,   -1,
   -1,   -1,  459,  460,  461,  462,  463,  464,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  473,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  482,  483,  484,  485,  486,
  487,  488,  435,  490,   -1,   -1,   -1,  494,  495,   -1,
   -1,   -1,  445,   -1,   -1,  267,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  276,   -1,  459,  460,  461,  462,
  463,  464,   -1,   -1,   -1,   -1,   -1,   -1,  290,   -1,
  473,   -1,   -1,   -1,  296,  297,   -1,   -1,   -1,  482,
  483,  484,  485,  486,  487,  488,   -1,  490, 1169, 1170,
   -1,  494,  495,  315,   -1,   -1,   -1,   -1, 1179, 1180,
   -1, 1182, 1183,   -1,   -1,  327,   -1,   -1,   -1, 1190,
 1191, 1192, 1193,   -1, 1195, 1196, 1197, 1198, 1199, 1200,
   -1,   -1,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,
   -1,   -1,   -1,  355,  356,  264,  265,   -1,  276,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,  371,
   40,  280,  290,   43,   -1,   45,   -1,  379,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,
   -1,   -1,   -1,   63,  303,   -1,  305,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  327,
  319,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,
   -1,  423,   -1,   -1,   -1,   -1,   -1,  276,   -1,   -1,
   -1,   -1,  341,  435,   -1,   -1,   -1,  355,  356,   -1,
   -1,  290,   -1,  445,   -1,   -1,   -1,  296,  297,  367,
   -1,   -1,   -1,  371,   -1,   -1,   -1,  459,  460,  461,
  462,  463,  464,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  473,   -1,   -1,   -1,   -1,   -1,   -1,  327,   -1,
  482,  483,  484,  485,  486,  487,  488,   -1,  490,   -1,
   -1,   -1,  494,  495,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  412,   -1,   -1,  355,  356,   -1,  427,
   -1,   40,   -1,   -1,   43,   -1,   45,  435,  367,   -1,
   -1,   -1,  371,   -1,   -1,   -1,   -1,  445,   -1,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,  459,  460,  461,  462,  463,  464,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  473,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,  482,  483,  484,  485,  486,  487,
  488,   -1,  490,   -1,   -1,   -1,  494,  495,  427,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  435,   -1,   -1,   -1,
  260,  302,   -1,  263,   -1,   -1,  445,  267,  309,   -1,
   -1,   -1,  313,  314,   -1,  316,  276,   -1,  319,   -1,
  459,  460,  461,  462,  463,  464,   -1,   -1,   -1,   -1,
  290,   -1,  333,   -1,  473,   -1,  296,  297,  339,   -1,
   -1,   -1,   -1,  482,  483,  484,  485,  486,  487,  488,
   -1,  490,   -1,   -1,   -1,  494,  495,   -1,   -1,   -1,
   -1,   -1,  261,   40,   -1,   -1,   43,  327,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   -1,  271,  283,   -1,   63,   -1,   -1,   -1,
   -1,   -1,  291,   -1,   -1,  355,  356,   -1,  399,  298,
   -1,  300,   -1,  302,   -1,   -1,   -1,  367,  307,   -1,
   -1,  371,   -1,   -1,  302,  314,   -1,   -1,  419,   -1,
   -1,  309,   -1,   -1,   -1,  313,  314,   -1,  316,  328,
   -1,  319,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
  339,  260,   -1,  444,  263,  333,   -1,   -1,  267,   -1,
   40,  339,  453,   43,  455,   45,   -1,  276,   -1,   -1,
   -1,  462,   -1,   -1,   -1,   -1,   -1,  427,   58,   -1,
   -1,  290,   -1,   63,   -1,  435,   -1,  296,  297,   -1,
   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,  489,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  459,
  460,  461,  462,  463,  464,   -1,   -1,  406,  327,  408,
   -1,  399,   -1,  473,   -1,  414,   -1,   -1,  417,   -1,
  419,  420,  482,  483,  484,  485,  486,  487,  488,   -1,
  490,  419,   -1,   -1,  494,  495,  355,  356,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  444,  434,   -1,  367,   -1,
   -1,   -1,  371,   -1,   -1,   -1,  444,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  453,   -1,  455,   -1,   -1,
   -1,   -1,   -1,   -1,  462,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,   -1,   -1,  263,   -1,   -1,   -1,
  267,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,  276,
   -1,  489,   -1,   -1,   -1,   -1,   -1,   -1,  427,   -1,
   58,   -1,   -1,  290,   -1,   63,  435,   -1,   -1,  296,
  297,   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  459,  460,  461,  462,  463,  464,   -1,   -1,   -1,   -1,
  327,   -1,   -1,   -1,  473,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  482,  483,  484,  485,  486,  487,  488,
  260,  490,   -1,  263,   -1,  494,  495,  267,  355,  356,
   -1,   -1,   -1,   41,   42,   43,  276,   45,   -1,   47,
  367,   -1,   -1,   40,  371,   -1,   43,   -1,   45,   -1,
  290,   -1,   60,   61,   62,   -1,  296,  297,   -1,   -1,
   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  327,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
  427,   -1,   -1,   -1,   -1,   -1,   -1,   58,  435,   -1,
   -1,   -1,   63,   -1,   -1,  355,  356,   -1,  445,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,
   -1,  371,  459,  460,  461,  462,  463,  464,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  473,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  482,  483,  484,  485,  486,
  487,  488,  260,  490,   -1,  263,   -1,  494,  495,  267,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  427,   -1,   -1,
   -1,   -1,  290,   -1,   -1,  435,   -1,   -1,  296,  297,
   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  459,
  460,  461,  462,  463,  464,   -1,   -1,   -1,   -1,  327,
   -1,   -1,   -1,  473,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  482,  483,  484,  485,  486,  487,  488,   -1,
  490,   -1,   -1,   -1,  494,  495,   -1,  355,  356,   -1,
   -1,   -1,   -1,  260,  272,   -1,  263,   -1,   -1,  367,
  267,   -1,  280,  371,   -1,   -1,   -1,   -1,  286,  276,
   -1,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,  290,   42,   43,   -1,   45,   -1,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,   -1,   63,  267,  325,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  334,   -1,   -1,  427,
  327,   -1,   -1,   -1,  342,   -1,   -1,  435,   -1,  290,
   -1,   -1,   -1,   -1,   -1,  296,  297,  445,   -1,   -1,
   -1,   -1,   -1,  361,   -1,  363,   -1,   -1,  355,  356,
   -1,  459,  460,  461,  462,  463,  464,  271,   -1,  377,
  367,  379,  380,  381,  371,  473,  327,   40,   -1,   -1,
   43,   -1,   45,   -1,  482,  483,  484,  485,  486,  487,
  488,   -1,  490,   -1,   -1,   58,  494,  495,  302,   -1,
   63,   -1,  353,   -1,  355,  356,   -1,   -1,   -1,  313,
  314,   -1,  316,   -1,   -1,  319,  367,   -1,   -1,   -1,
  371,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,  333,
  427,   -1,   -1,   -1,   40,  339,   -1,   43,  435,   45,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,  445,   -1,
   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,   60,
   61,   62,  459,  460,  461,  462,  463,  464,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  473,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  435,  482,  483,  484,  485,  486,
  487,  488,   -1,  490,  445,  399,   -1,  494,  495,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  459,  460,
  461,  462,  463,  464,   -1,  419,   -1,   -1,   -1,  267,
   -1,   -1,  473,   -1,   -1,   -1,   -1,   -1,  276,   -1,
  434,  482,  483,  484,  485,  486,  487,  488,   -1,  490,
  444,   -1,  290,  494,  495,   -1,   -1,   -1,  296,  297,
   -1,  455,   -1,   -1,   -1,   -1,   -1,   -1,  462,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,  327,
   -1,   -1,   63,   -1,   -1,  489,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,   -1,   -1,
   -1,   -1,   -1,   -1,  267,  353,   -1,  355,  356,   -1,
   -1,   -1,   -1,  276,   -1,   -1,   -1,   -1,   -1,  367,
   -1,   -1,   -1,  371,   -1,   -1,   -1,  290,   -1,   -1,
   -1,   -1,   -1,  296,  297,   40,   41,   -1,   43,   -1,
   45,  304,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,
   -1,  267,   -1,   -1,  327,   -1,   -1,   -1,   -1,   -1,
  276,  272,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
   -1,   -1,   -1,   -1,  290,  286,   -1,  435,  289,   -1,
  296,  297,  355,  356,   -1,   -1,   -1,  445,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,  371,   -1,
   -1,  459,  460,  461,  462,  463,  464,   -1,   -1,   -1,
   -1,  327,   -1,   -1,  325,  473,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  334,  482,  483,  484,  485,  486,  487,
  488,  342,  490,   -1,   -1,   -1,  494,  495,   -1,  355,
  356,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  361,  367,  363,   -1,   -1,  371,   -1,   -1,   -1,   -1,
   -1,   -1,  435,   -1,   -1,   -1,  377,   -1,  379,  380,
  381,   -1,  445,   -1,   -1,   40,  267,   -1,   43,   -1,
   45,   -1,   -1,   -1,   -1,  276,  459,  460,  461,  462,
  463,  464,   -1,   58,   -1,   -1,   -1,   -1,   63,  290,
  473,   -1,   -1,  419,   -1,  296,  297,   -1,   -1,  482,
  483,  484,  485,  486,  487,  488,   -1,  490,   -1,  435,
  431,  494,  495,   -1,   -1,   -1,   -1,   -1,   -1,  445,
   -1,   -1,   -1,   -1,   -1,   -1,  327,   -1,   -1,   -1,
   -1,   -1,   -1,  459,  460,  461,  462,  463,  464,   -1,
   -1,   -1,  267,   -1,   -1,   -1,   -1,  473,   -1,   -1,
   -1,  276,  353,   -1,  355,  356,  482,  483,  484,  485,
  486,  487,  488,   -1,  490,  290,  367,   -1,  494,  495,
  371,  296,  297,   -1,   -1,   40,   -1,   -1,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,  462,   -1,   -1,   -1,   63,   -1,
   -1,   -1,  327,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
  488,  489,  490,  491,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  356,   -1,   -1,  435,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  445,   -1,  371,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,  459,  460,
  461,  462,  463,  464,   -1,   58,   -1,   -1,   -1,   -1,
   63,   -1,  473,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  482,  483,  484,  485,  486,  487,  488,   -1,  490,
   -1,   -1,  267,  494,  495,   -1,   -1,   -1,   -1,   -1,
   -1,  276,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  435,   -1,   -1,   -1,   -1,  290,   -1,   -1,   -1,   -1,
  445,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  459,  460,  461,  462,  463,  464,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  473,   -1,
   -1,   -1,  327,   -1,   -1,   -1,   -1,  482,  483,  484,
  485,  486,  487,  488,   -1,  490,   -1,   -1,   -1,  494,
  495,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  356,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,   -1,   -1,  371,   -1,   -1,   -1,
   40,   -1,  267,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,  276,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,
   -1,   -1,   -1,   63,  462,  290,   -1,   -1,   -1,   -1,
   -1,  296,  297,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
  488,  489,  490,  491,  273,   -1,   -1,   -1,  277,   -1,
  435,   -1,  327,   -1,   -1,   -1,  285,   -1,   -1,   -1,
  445,   -1,   -1,   -1,  267,   -1,   -1,  296,   -1,   -1,
  299,  456,   -1,  276,  459,  460,  461,  462,  463,  464,
  355,  356,   -1,   -1,   -1,   -1,   -1,  290,  473,   -1,
   -1,   -1,  367,  296,  297,   -1,  371,  482,  483,  484,
  485,  486,  487,  488,   -1,  490,   -1,   -1,   -1,  494,
  495,  340,   -1,   -1,   -1,   -1,   -1,  346,  347,  348,
   -1,  350,  351,  352,  327,  354,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,   -1,
   -1,   -1,  355,  356,   -1,   -1,   -1,   -1,   -1,   -1,
  435,   -1,   -1,   -1,  367,   -1,   -1,   -1,  371,   -1,
  445,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,
   -1,  456,   -1,   -1,  459,  460,  461,  462,  463,  464,
   -1,   -1,   -1,   -1,   -1,   -1,  425,   -1,  473,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  482,  483,  484,
  485,  486,  487,  488,   -1,  490,   -1,  267,  447,  494,
  495,   -1,   -1,   -1,   -1,   -1,  276,   -1,   -1,   -1,
   -1,   -1,  435,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  290,   -1,  445,   -1,   -1,  273,  296,  297,   -1,  277,
   -1,   -1,   -1,  482,  483,   -1,  459,  460,  461,  462,
  463,  464,   -1,   -1,  292,   -1,   -1,   -1,  296,   -1,
  473,  299,   -1,   -1,   -1,   -1,   -1,  327,   -1,  482,
  483,  484,  485,  486,  487,  488,   -1,  490,   -1,   -1,
  273,  494,  495,   -1,  277,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  355,  356,   -1,   -1,   -1,
   -1,   -1,  340,  296,   -1,   -1,  299,  367,  346,  347,
  348,  371,  350,  351,  352,   -1,  354,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  340,   -1,   -1,
   -1,   -1,   -1,  346,  347,  348,   -1,  350,  351,  352,
   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,
   -1,   -1,   -1,   -1,   -1,  435,   -1,   -1,   -1,   -1,
   -1,  374,   -1,  376,  273,  445,   -1,  425,  277,   -1,
   -1,   -1,   -1,  273,   -1,   -1,   -1,  277,   -1,  459,
  460,  461,  462,  463,  464,   -1,   -1,  296,   -1,  447,
  299,   -1,  292,  473,  407,   -1,  296,   -1,   -1,  299,
   -1,   -1,  482,  483,  484,  485,  486,  487,  488,   -1,
  490,   -1,  425,   -1,  494,  495,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  482,  483,   -1,   -1,   -1,   -1,
   -1,  340,   -1,   -1,  447,   -1,   -1,  346,  347,  348,
  340,  350,  351,  352,   -1,  354,  346,  347,  348,  462,
  350,  351,  352,   -1,  354,  273,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,  482,
  483,   -1,   -1,   -1,  374,   -1,  376,   -1,  296,   -1,
   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  425,   -1,   -1,   -1,
   -1,   -1,  340,   -1,   -1,  425,   -1,   -1,  346,  347,
  348,   -1,  350,  351,  352,   -1,  354,   -1,  447,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  447,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  482,  483,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  482,  483,   -1,   -1,   -1,   -1,   -1,  407,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  462,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  425,  472,  473,
  474,  475,  476,  477,  478,  479,  480,  481,  482,  483,
  484,  485,  486,  487,  488,  489,  490,  491,   -1,  447,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  482,  483,
};
#define YYFINAL 18
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 495
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,
"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ACTIVE","ADD","AFTER","ALL","ALTER","AND","ANY",
"AS","ASC","AT","AVG","AUTO","BASENAME","BEFORE","BEGIN","BETWEEN","BLOB","BY",
"CACHE","CAST","CHARACTER","CHECK","CHECK_POINT_LEN","COLLATE","COLLATION",
"COMMA","COMMIT","COMMITTED","COMPUTED","CONCATENATE","CONDITIONAL",
"CONSTRAINT","CONTAINING","COUNT","CREATE","CSTRING","CURRENT","CURSOR",
"DATABASE","DATE","DB_KEY","DEBUG","DECIMAL","DECLARE","DEFAULT","DELETE",
"DESC","DISTINCT","DO","DOMAIN","DROP","ELSE","END","ENTRY_POINT","EQL",
"ESCAPE","EXCEPTION","EXECUTE","EXISTS","EXIT","EXTERNAL","FILTER","FOR",
"FOREIGN","FROM","FULL","FUNCTION","GDSCODE","GEQ","GENERATOR","GEN_ID","GRANT",
"GROUP","GROUP_COMMIT_WAIT","GTR","HAVING","IF","IN","INACTIVE","INNER",
"INPUT_TYPE","INDEX","INSERT","INTEGER","INTO","IS","ISOLATION","JOIN","KEY",
"KW_CHAR","KW_DEC","KW_DOUBLE","KW_FILE","KW_FLOAT","KW_INT","KW_LONG",
"KW_NULL","KW_NUMERIC","KW_UPPER","KW_VALUE","LENGTH","LOGFILE","LPAREN","LEFT",
"LEQ","LEVEL","LIKE","LOG_BUF_SIZE","LSS","MANUAL","MAXIMUM","MAX_SEGMENT",
"MERGE","MESSAGE","MINIMUM","MODULE_NAME","NAMES","NATIONAL","NATURAL","NCHAR",
"NEQ","NO","NOT","NOT_GTR","NOT_LSS","NUM_LOG_BUFS","OF","ON","ONLY","OPTION",
"OR","ORDER","OUTER","OUTPUT_TYPE","OVERFLOW","PAGE","PAGES","PAGE_SIZE",
"PARAMETER","PASSWORD","PLAN","POSITION","POST_EVENT","PRECISION","PRIMARY",
"PRIVILEGES","PROCEDURE","PROTECTED","RAW_PARTITIONS","READ","REAL","RECREATE",
"REFERENCES","RESERVING","RETAIN","RETURNING_VALUES","RETURNS","REVOKE","RIGHT",
"RPAREN","ROLLBACK","SEGMENT","SELECT","SET","SHADOW","SHARED","SINGULAR",
"SIZE","SMALLINT","SNAPSHOT","SOME","SORT","SQLCODE","STABILITY","STARTING",
"STATISTICS","SUB_TYPE","SUSPEND","SUM","TABLE","THEN","TO","TRANSACTION",
"TRIGGER","UNCOMMITTED","UNION","UNIQUE","UPDATE","USER","VALUES","VARCHAR",
"VARIABLE","VARYING","VERSION","VIEW","WAIT","WHEN","WHERE","WHILE","WITH",
"WORK","WRITE","FLOAT","NUMBER","NUMERIC","SYMBOL","STRING","INTRODUCER",
"ACTION","ADMIN","CASCADE","FREE_IT","RESTRICT","ROLE","COLUMN","TYPE",
"EXTRACT","YEAR","MONTH","DAY","HOUR","MINUTE","SECOND","WEEKDAY","YEARDAY",
"TIME","TIMESTAMP","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP",
"CURRENT_USER","CURRENT_ROLE","KW_BREAK","SUBSTRING","KW_DESCRIPTOR","FIRST",
"SKIP","NUMBER64BIT","SCALEDINT",
};
char *yyrule[] = {
"$accept : top",
"top : statement",
"top : statement ';'",
"statement : alter",
"statement : blob",
"statement : commit",
"statement : create",
"statement : declare",
"statement : delete",
"statement : drop",
"statement : grant",
"statement : insert",
"statement : invoke_procedure",
"statement : recreate",
"statement : revoke",
"statement : rollback",
"statement : select",
"statement : set",
"statement : update",
"statement : DEBUG signed_short_integer",
"grant : GRANT privileges ON prot_table_name TO user_grantee_list grant_option",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO user_grantee_list grant_option",
"grant : GRANT privileges ON prot_table_name TO grantee_list",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO grantee_list",
"grant : GRANT role_name_list TO role_grantee_list role_admin_option",
"prot_table_name : simple_table_name",
"prot_table_name : TABLE simple_table_name",
"privileges : ALL",
"privileges : ALL PRIVILEGES",
"privileges : privilege_list",
"privilege_list : privilege",
"privilege_list : privilege_list ',' privilege",
"proc_privileges : EXECUTE",
"privilege : SELECT",
"privilege : INSERT",
"privilege : DELETE",
"privilege : UPDATE column_parens_opt",
"privilege : REFERENCES column_parens_opt",
"grant_option : WITH GRANT OPTION",
"grant_option :",
"role_admin_option : WITH ADMIN OPTION",
"role_admin_option :",
"simple_proc_name : symbol_procedure_name",
"revoke : REVOKE rev_grant_option privileges ON prot_table_name FROM user_grantee_list",
"revoke : REVOKE rev_grant_option proc_privileges ON PROCEDURE simple_proc_name FROM user_grantee_list",
"revoke : REVOKE privileges ON prot_table_name FROM user_grantee_list",
"revoke : REVOKE proc_privileges ON PROCEDURE simple_proc_name FROM user_grantee_list",
"revoke : REVOKE privileges ON prot_table_name FROM grantee_list",
"revoke : REVOKE proc_privileges ON PROCEDURE simple_proc_name FROM grantee_list",
"revoke : REVOKE role_name_list FROM role_grantee_list",
"rev_grant_option : GRANT OPTION FOR",
"grantee_list : grantee",
"grantee_list : grantee_list ',' grantee",
"grantee_list : grantee_list ',' user_grantee",
"grantee_list : user_grantee_list ',' grantee",
"grantee : PROCEDURE symbol_procedure_name",
"grantee : TRIGGER symbol_trigger_name",
"grantee : VIEW symbol_view_name",
"grantee : ROLE symbol_role_name",
"user_grantee_list : user_grantee",
"user_grantee_list : user_grantee_list ',' user_grantee",
"user_grantee : symbol_user_name",
"user_grantee : USER symbol_user_name",
"user_grantee : GROUP symbol_user_name",
"role_name_list : role_name",
"role_name_list : role_name_list ',' role_name",
"role_name : symbol_role_name",
"role_grantee_list : role_grantee",
"role_grantee_list : role_grantee_list ',' role_grantee",
"role_grantee : symbol_user_name",
"role_grantee : USER symbol_user_name",
"declare : DECLARE declare_clause",
"declare_clause : FILTER filter_decl_clause",
"declare_clause : EXTERNAL FUNCTION udf_decl_clause",
"udf_decl_clause : symbol_UDF_name arg_desc_list1 RETURNS return_value1 ENTRY_POINT sql_string MODULE_NAME sql_string",
"udf_data_type : simple_type",
"udf_data_type : BLOB",
"udf_data_type : CSTRING '(' pos_short_integer ')' charset_clause",
"arg_desc_list1 :",
"arg_desc_list1 : arg_desc_list",
"arg_desc_list1 : '(' arg_desc_list ')'",
"arg_desc_list : arg_desc",
"arg_desc_list : arg_desc_list ',' arg_desc",
"arg_desc : init_data_type udf_data_type",
"arg_desc : init_data_type udf_data_type BY KW_DESCRIPTOR",
"return_value1 : return_value",
"return_value1 : '(' return_value ')'",
"return_value : init_data_type udf_data_type",
"return_value : init_data_type udf_data_type FREE_IT",
"return_value : init_data_type udf_data_type BY KW_VALUE",
"return_value : init_data_type udf_data_type BY KW_DESCRIPTOR",
"return_value : PARAMETER pos_short_integer",
"filter_decl_clause : symbol_filter_name INPUT_TYPE blob_subtype OUTPUT_TYPE blob_subtype ENTRY_POINT sql_string MODULE_NAME sql_string",
"create : CREATE create_clause",
"create_clause : EXCEPTION symbol_exception_name sql_string",
"create_clause : unique_opt order_direction INDEX symbol_index_name ON simple_table_name index_definition",
"create_clause : PROCEDURE procedure_clause",
"create_clause : TABLE table_clause",
"create_clause : TRIGGER def_trigger_clause",
"create_clause : VIEW view_clause",
"create_clause : GENERATOR generator_clause",
"create_clause : DATABASE db_clause",
"create_clause : DOMAIN domain_clause",
"create_clause : SHADOW shadow_clause",
"create_clause : ROLE role_clause",
"recreate : RECREATE recreate_clause",
"recreate_clause : PROCEDURE rprocedure_clause",
"recreate_clause : TABLE rtable_clause",
"unique_opt : UNIQUE",
"unique_opt :",
"index_definition : column_list",
"index_definition : column_parens",
"index_definition : computed_by '(' begin_trigger value end_trigger ')'",
"shadow_clause : pos_short_integer manual_auto conditional sql_string first_file_length sec_shadow_files",
"manual_auto : MANUAL",
"manual_auto : AUTO",
"manual_auto :",
"conditional :",
"conditional : CONDITIONAL",
"first_file_length :",
"first_file_length : LENGTH equals long_integer page_noise",
"sec_shadow_files :",
"sec_shadow_files : db_file_list",
"db_file_list : db_file",
"db_file_list : db_file_list db_file",
"domain_clause : column_def_name as_opt data_type begin_trigger domain_default_opt end_trigger domain_constraint_clause collate_clause",
"as_opt : AS",
"as_opt :",
"domain_default_opt : DEFAULT begin_trigger default_value",
"domain_default_opt :",
"domain_constraint_clause :",
"domain_constraint_clause : domain_constraint_list",
"domain_constraint_list : domain_constraint_def",
"domain_constraint_list : domain_constraint_list domain_constraint_def",
"domain_constraint_def : domain_constraint",
"domain_constraint : null_constraint",
"domain_constraint : domain_check_constraint",
"null_constraint : NOT KW_NULL",
"domain_check_constraint : begin_trigger CHECK '(' search_condition ')' end_trigger",
"generator_clause : symbol_generator_name",
"role_clause : symbol_role_name",
"db_clause : db_name db_initial_desc1 db_rem_desc1",
"equals :",
"equals : '='",
"db_name : sql_string",
"db_initial_desc1 :",
"db_initial_desc1 : db_initial_desc",
"db_initial_desc : db_initial_option",
"db_initial_desc : db_initial_desc db_initial_option",
"db_initial_option : PAGE_SIZE equals pos_short_integer",
"db_initial_option : LENGTH equals long_integer page_noise",
"db_initial_option : USER sql_string",
"db_initial_option : PASSWORD sql_string",
"db_initial_option : SET NAMES sql_string",
"db_rem_desc1 :",
"db_rem_desc1 : db_rem_desc",
"db_rem_desc : db_rem_option",
"db_rem_desc : db_rem_desc db_rem_option",
"db_rem_option : db_file",
"db_rem_option : db_log",
"db_rem_option : db_log_option",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name",
"db_log_option : GROUP_COMMIT_WAIT equals long_integer",
"db_log_option : CHECK_POINT_LEN equals long_integer",
"db_log_option : NUM_LOG_BUFS equals pos_short_integer",
"db_log_option : LOG_BUF_SIZE equals unsigned_short_integer",
"db_log : db_default_log_spec",
"db_log : db_rem_log_spec",
"db_rem_log_spec : LOGFILE '(' logfiles ')' OVERFLOW logfile_desc",
"db_rem_log_spec : LOGFILE BASENAME logfile_desc",
"db_default_log_spec : LOGFILE",
"db_file : file1 sql_string file_desc1",
"logfiles : logfile_desc",
"logfiles : logfiles ',' logfile_desc",
"logfile_desc : logfile_name logfile_attrs",
"logfile_name : sql_string",
"logfile_attrs :",
"logfile_attrs : logfile_attrs logfile_attr",
"logfile_attr : SIZE equals long_integer",
"file1 : KW_FILE",
"file_desc1 :",
"file_desc1 : file_desc",
"file_desc : file_clause",
"file_desc : file_desc file_clause",
"file_clause : STARTING file_clause_noise long_integer",
"file_clause : LENGTH equals long_integer page_noise",
"file_clause_noise :",
"file_clause_noise : AT",
"file_clause_noise : AT PAGE",
"page_noise :",
"page_noise : PAGE",
"page_noise : PAGES",
"table_clause : simple_table_name external_file '(' table_elements ')'",
"rtable_clause : simple_table_name external_file '(' table_elements ')'",
"external_file : EXTERNAL KW_FILE sql_string",
"external_file : EXTERNAL sql_string",
"external_file :",
"table_elements : table_element",
"table_elements : table_elements ',' table_element",
"table_element : column_def",
"table_element : table_constraint_definition",
"column_def : column_def_name data_type_or_domain default_opt end_trigger column_constraint_clause collate_clause",
"column_def : column_def_name non_array_type def_computed",
"column_def : column_def_name def_computed",
"def_computed : computed_by '(' begin_trigger value end_trigger ')'",
"computed_by : COMPUTED BY",
"computed_by : COMPUTED",
"data_type_or_domain : data_type begin_trigger",
"data_type_or_domain : simple_column_name begin_string",
"collate_clause : COLLATE symbol_collation_name",
"collate_clause :",
"column_def_name : simple_column_name",
"simple_column_def_name : simple_column_name",
"data_type_descriptor : init_data_type data_type",
"init_data_type :",
"default_opt : DEFAULT default_value",
"default_opt :",
"default_value : constant",
"default_value : current_user",
"default_value : current_role",
"default_value : null_value",
"default_value : datetime_value_expression",
"column_constraint_clause :",
"column_constraint_clause : column_constraint_list",
"column_constraint_list : column_constraint_def",
"column_constraint_list : column_constraint_list column_constraint_def",
"column_constraint_def : constraint_name_opt column_constraint",
"column_constraint : NOT KW_NULL",
"column_constraint : REFERENCES simple_table_name column_parens_opt referential_trigger_action",
"column_constraint : check_constraint",
"column_constraint : UNIQUE",
"column_constraint : PRIMARY KEY",
"table_constraint_definition : constraint_name_opt table_constraint",
"constraint_name_opt : CONSTRAINT symbol_constraint_name",
"constraint_name_opt :",
"table_constraint : unique_constraint",
"table_constraint : primary_constraint",
"table_constraint : referential_constraint",
"table_constraint : check_constraint",
"unique_constraint : UNIQUE column_parens",
"primary_constraint : PRIMARY KEY column_parens",
"referential_constraint : FOREIGN KEY column_parens REFERENCES simple_table_name column_parens_opt referential_trigger_action",
"check_constraint : begin_trigger CHECK '(' search_condition ')' end_trigger",
"referential_trigger_action : update_rule",
"referential_trigger_action : delete_rule",
"referential_trigger_action : delete_rule update_rule",
"referential_trigger_action : update_rule delete_rule",
"referential_trigger_action :",
"update_rule : ON UPDATE referential_action",
"delete_rule : ON DELETE referential_action",
"referential_action : CASCADE",
"referential_action : SET DEFAULT",
"referential_action : SET KW_NULL",
"referential_action : NO ACTION",
"procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string var_declaration_list full_proc_block end_trigger",
"rprocedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string var_declaration_list full_proc_block end_trigger",
"alter_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string var_declaration_list full_proc_block end_trigger",
"input_parameters : '(' proc_parameters ')'",
"input_parameters :",
"output_parameters : RETURNS input_parameters",
"output_parameters :",
"proc_parameters : proc_parameter",
"proc_parameters : proc_parameters ',' proc_parameter",
"proc_parameter : simple_column_def_name non_array_type",
"var_declaration_list : var_declarations",
"var_declaration_list :",
"var_declarations : var_declaration",
"var_declarations : var_declarations var_declaration",
"var_declaration : DECLARE VARIABLE column_def_name non_array_type ';'",
"proc_block : proc_statement",
"proc_block : full_proc_block",
"full_proc_block : BEGIN proc_statements END",
"full_proc_block : BEGIN proc_statements excp_statements END",
"proc_statements : proc_block",
"proc_statements : proc_statements proc_block",
"proc_statement : assignment ';'",
"proc_statement : delete ';'",
"proc_statement : EXCEPTION symbol_exception_name ';'",
"proc_statement : exec_procedure",
"proc_statement : for_select",
"proc_statement : if_then_else",
"proc_statement : insert ';'",
"proc_statement : POST_EVENT value ';'",
"proc_statement : singleton_select",
"proc_statement : update ';'",
"proc_statement : while",
"proc_statement : SUSPEND ';'",
"proc_statement : EXIT ';'",
"proc_statement : KW_BREAK ';'",
"exec_procedure : EXECUTE PROCEDURE symbol_procedure_name proc_inputs proc_outputs ';'",
"for_select : FOR select INTO variable_list cursor_def DO proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block ELSE proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block",
"singleton_select : select INTO variable_list ';'",
"variable : ':' symbol_variable_name",
"proc_inputs : var_const_list",
"proc_inputs : '(' var_const_list ')'",
"proc_inputs :",
"proc_outputs : RETURNING_VALUES variable_list",
"proc_outputs : RETURNING_VALUES '(' variable_list ')'",
"proc_outputs :",
"var_const_list : variable",
"var_const_list : constant",
"var_const_list : column_name",
"var_const_list : null_value",
"var_const_list : var_const_list ',' variable",
"var_const_list : var_const_list ',' constant",
"var_const_list : var_const_list ',' column_name",
"var_const_list : var_const_list ',' null_value",
"variable_list : variable",
"variable_list : column_name",
"variable_list : variable_list ',' column_name",
"variable_list : variable_list ',' variable",
"while : WHILE '(' search_condition ')' DO proc_block",
"cursor_def : AS CURSOR symbol_cursor_name",
"cursor_def :",
"excp_statements : excp_statement",
"excp_statements : excp_statements excp_statement",
"excp_statement : WHEN errors DO proc_block",
"errors : err",
"errors : errors ',' err",
"err : SQLCODE signed_short_integer",
"err : GDSCODE symbol_gdscode_name",
"err : EXCEPTION symbol_exception_name",
"err : ANY",
"invoke_procedure : EXECUTE PROCEDURE symbol_procedure_name prc_inputs",
"prc_inputs : prm_const_list",
"prc_inputs : '(' prm_const_list ')'",
"prc_inputs :",
"prm_const_list : parameter",
"prm_const_list : constant",
"prm_const_list : null_value",
"prm_const_list : prm_const_list ',' parameter",
"prm_const_list : prm_const_list ',' constant",
"prm_const_list : prm_const_list ',' null_value",
"view_clause : symbol_view_name column_parens_opt AS begin_string union_view check_opt end_string",
"union_view : union_view_expr",
"union_view_expr : select_view_expr",
"union_view_expr : union_view_expr UNION select_view_expr",
"union_view_expr : union_view_expr UNION ALL select_view_expr",
"select_view_expr : SELECT limit_clause distinct_clause select_list from_view_clause where_clause group_clause having_clause plan_clause",
"from_view_clause : FROM from_view_list",
"from_view_list : view_table",
"from_view_list : from_view_list ',' view_table",
"view_table : joined_view_table",
"view_table : table_name",
"joined_view_table : view_table join_type JOIN view_table ON search_condition",
"joined_view_table : '(' joined_view_table ')'",
"begin_string :",
"end_string :",
"begin_trigger :",
"end_trigger :",
"check_opt : WITH CHECK OPTION",
"check_opt :",
"def_trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position begin_trigger trigger_action end_trigger",
"trigger_active : ACTIVE",
"trigger_active : INACTIVE",
"trigger_active :",
"trigger_type : BEFORE INSERT",
"trigger_type : AFTER INSERT",
"trigger_type : BEFORE UPDATE",
"trigger_type : AFTER UPDATE",
"trigger_type : BEFORE DELETE",
"trigger_type : AFTER DELETE",
"trigger_position : POSITION nonneg_short_integer",
"trigger_position :",
"trigger_action : AS begin_trigger var_declaration_list full_proc_block",
"alter : ALTER alter_clause",
"alter_clause : EXCEPTION symbol_exception_name sql_string",
"alter_clause : TABLE simple_table_name alter_ops",
"alter_clause : TRIGGER alter_trigger_clause",
"alter_clause : PROCEDURE alter_procedure_clause",
"alter_clause : DATABASE init_alter_db alter_db",
"alter_clause : DOMAIN alter_column_name alter_domain_ops",
"alter_clause : INDEX alter_index_clause",
"domain_default_opt2 : DEFAULT begin_trigger default_value",
"domain_check_constraint2 : CHECK begin_trigger '(' search_condition ')' end_trigger",
"alter_domain_ops : alter_domain_op",
"alter_domain_ops : alter_domain_ops alter_domain_op",
"alter_domain_op : SET begin_trigger domain_default_opt2 end_trigger",
"alter_domain_op : ADD CONSTRAINT domain_check_constraint2",
"alter_domain_op : ADD domain_check_constraint",
"alter_domain_op : DROP DEFAULT",
"alter_domain_op : DROP CONSTRAINT",
"alter_domain_op : TO simple_column_name",
"alter_domain_op : TYPE init_data_type non_array_type",
"alter_ops : alter_op",
"alter_ops : alter_ops ',' alter_op",
"alter_op : DROP simple_column_name drop_behaviour",
"alter_op : DROP CONSTRAINT symbol_constraint_name",
"alter_op : ADD column_def",
"alter_op : ADD table_constraint_definition",
"alter_op : col_opt simple_column_name POSITION pos_short_integer",
"alter_op : col_opt alter_column_name TO simple_column_name",
"alter_op : col_opt alter_col_name TYPE alter_data_type_or_domain end_trigger",
"alter_column_name : keyword_or_column",
"keyword_or_column : COLUMN",
"keyword_or_column : TYPE",
"keyword_or_column : EXTRACT",
"keyword_or_column : YEAR",
"keyword_or_column : MONTH",
"keyword_or_column : DAY",
"keyword_or_column : HOUR",
"keyword_or_column : MINUTE",
"keyword_or_column : SECOND",
"keyword_or_column : WEEKDAY",
"keyword_or_column : YEARDAY",
"keyword_or_column : TIME",
"keyword_or_column : TIMESTAMP",
"keyword_or_column : CURRENT_DATE",
"keyword_or_column : CURRENT_TIME",
"keyword_or_column : CURRENT_TIMESTAMP",
"keyword_or_column : CURRENT_USER",
"keyword_or_column : CURRENT_ROLE",
"keyword_or_column : SYMBOL",
"keyword_or_column : KW_BREAK",
"keyword_or_column : SUBSTRING",
"keyword_or_column : KW_DESCRIPTOR",
"col_opt : ALTER",
"col_opt : ALTER COLUMN",
"alter_data_type_or_domain : non_array_type begin_trigger",
"alter_data_type_or_domain : simple_column_name begin_string",
"alter_col_name : simple_column_name",
"drop_behaviour : RESTRICT",
"drop_behaviour : CASCADE",
"drop_behaviour :",
"alter_index_clause : symbol_index_name ACTIVE",
"alter_index_clause : symbol_index_name INACTIVE",
"init_alter_db :",
"alter_db : db_alter_clause",
"alter_db : alter_db db_alter_clause",
"db_alter_clause : ADD db_file_list",
"db_alter_clause : DROP LOGFILE",
"db_alter_clause : SET db_log_option_list",
"db_alter_clause : ADD db_log",
"db_log_option_list : db_log_option",
"db_log_option_list : db_log_option_list ',' db_log_option",
"alter_trigger_clause : symbol_trigger_name trigger_active new_trigger_type trigger_position begin_trigger new_trigger_action end_trigger",
"new_trigger_type : trigger_type",
"new_trigger_type :",
"new_trigger_action : trigger_action",
"new_trigger_action :",
"drop : DROP drop_clause",
"drop_clause : EXCEPTION symbol_exception_name",
"drop_clause : INDEX symbol_index_name",
"drop_clause : PROCEDURE symbol_procedure_name",
"drop_clause : TABLE symbol_table_name",
"drop_clause : TRIGGER symbol_trigger_name",
"drop_clause : VIEW symbol_view_name",
"drop_clause : FILTER symbol_filter_name",
"drop_clause : DOMAIN symbol_domain_name",
"drop_clause : EXTERNAL FUNCTION symbol_UDF_name",
"drop_clause : SHADOW pos_short_integer",
"drop_clause : ROLE symbol_role_name",
"drop_clause : GENERATOR symbol_generator_name",
"data_type : non_array_type",
"data_type : array_type",
"non_array_type : simple_type",
"non_array_type : blob_type",
"array_type : non_charset_simple_type '[' array_spec ']'",
"array_type : character_type '[' array_spec ']' charset_clause",
"array_spec : array_range",
"array_spec : array_spec ',' array_range",
"array_range : signed_long_integer",
"array_range : signed_long_integer ':' signed_long_integer",
"simple_type : non_charset_simple_type",
"simple_type : character_type charset_clause",
"non_charset_simple_type : national_character_type",
"non_charset_simple_type : numeric_type",
"non_charset_simple_type : float_type",
"non_charset_simple_type : integer_keyword",
"non_charset_simple_type : SMALLINT",
"non_charset_simple_type : DATE",
"non_charset_simple_type : TIME",
"non_charset_simple_type : TIMESTAMP",
"integer_keyword : INTEGER",
"integer_keyword : KW_INT",
"blob_type : BLOB blob_subtype blob_segsize charset_clause",
"blob_type : BLOB '(' unsigned_short_integer ')'",
"blob_type : BLOB '(' unsigned_short_integer ',' signed_short_integer ')'",
"blob_type : BLOB '(' ',' signed_short_integer ')'",
"blob_segsize : SEGMENT SIZE unsigned_short_integer",
"blob_segsize :",
"blob_subtype : SUB_TYPE signed_short_integer",
"blob_subtype : SUB_TYPE symbol_blob_subtype_name",
"blob_subtype :",
"charset_clause : CHARACTER SET symbol_character_set_name",
"charset_clause :",
"national_character_type : national_character_keyword '(' pos_short_integer ')'",
"national_character_type : national_character_keyword",
"national_character_type : national_character_keyword VARYING '(' pos_short_integer ')'",
"character_type : character_keyword '(' pos_short_integer ')'",
"character_type : character_keyword",
"character_type : varying_keyword '(' pos_short_integer ')'",
"varying_keyword : VARCHAR",
"varying_keyword : CHARACTER VARYING",
"varying_keyword : KW_CHAR VARYING",
"character_keyword : CHARACTER",
"character_keyword : KW_CHAR",
"national_character_keyword : NCHAR",
"national_character_keyword : NATIONAL CHARACTER",
"national_character_keyword : NATIONAL KW_CHAR",
"numeric_type : KW_NUMERIC prec_scale",
"numeric_type : decimal_keyword prec_scale",
"ordinal : pos_short_integer",
"prec_scale :",
"prec_scale : '(' signed_long_integer ')'",
"prec_scale : '(' signed_long_integer ',' signed_long_integer ')'",
"decimal_keyword : DECIMAL",
"decimal_keyword : KW_DEC",
"float_type : KW_FLOAT precision_opt",
"float_type : KW_LONG KW_FLOAT precision_opt",
"float_type : REAL",
"float_type : KW_DOUBLE PRECISION",
"precision_opt : '(' nonneg_short_integer ')'",
"precision_opt :",
"set : set_transaction",
"set : set_generator",
"set : set_statistics",
"set_generator : SET GENERATOR symbol_generator_name TO signed_long_integer",
"set_generator : SET GENERATOR symbol_generator_name TO NUMBER64BIT",
"set_generator : SET GENERATOR symbol_generator_name TO '-' NUMBER64BIT",
"commit : COMMIT optional_work optional_retain",
"rollback : ROLLBACK optional_work",
"optional_work : WORK",
"optional_work :",
"optional_retain : RETAIN opt_snapshot",
"optional_retain :",
"opt_snapshot : SNAPSHOT",
"opt_snapshot :",
"set_transaction : SET TRANSACTION tran_opt_list_m",
"tran_opt_list_m : tran_opt_list",
"tran_opt_list_m :",
"tran_opt_list : tran_opt",
"tran_opt_list : tran_opt_list tran_opt",
"tran_opt : access_mode",
"tran_opt : lock_wait",
"tran_opt : isolation_mode",
"tran_opt : tbl_reserve_options",
"access_mode : READ ONLY",
"access_mode : READ WRITE",
"lock_wait : WAIT",
"lock_wait : NO WAIT",
"isolation_mode : ISOLATION LEVEL iso_mode",
"isolation_mode : iso_mode",
"iso_mode : snap_shot",
"iso_mode : READ UNCOMMITTED version_mode",
"iso_mode : READ COMMITTED version_mode",
"snap_shot : SNAPSHOT",
"snap_shot : SNAPSHOT TABLE",
"snap_shot : SNAPSHOT TABLE STABILITY",
"version_mode : VERSION",
"version_mode : NO VERSION",
"version_mode :",
"tbl_reserve_options : RESERVING restr_list",
"lock_type : SHARED",
"lock_type : PROTECTED",
"lock_type :",
"lock_mode : READ",
"lock_mode : WRITE",
"restr_list : restr_option",
"restr_list : restr_list ',' restr_option",
"restr_option : table_list table_lock",
"table_lock : FOR lock_type lock_mode",
"table_lock :",
"table_list : simple_table_name",
"table_list : table_list ',' simple_table_name",
"set_statistics : SET STATISTICS INDEX symbol_index_name",
"select : union_expr order_clause for_update_clause",
"union_expr : select_expr",
"union_expr : union_expr UNION select_expr",
"union_expr : union_expr UNION ALL select_expr",
"order_clause : ORDER BY order_list",
"order_clause :",
"order_list : order_item",
"order_list : order_list ',' order_item",
"order_item : column_name collate_clause order_direction",
"order_item : ordinal collate_clause order_direction",
"order_direction : ASC",
"order_direction : DESC",
"order_direction :",
"for_update_clause : FOR UPDATE for_update_list",
"for_update_clause :",
"for_update_list : OF column_list",
"for_update_list :",
"select_expr : SELECT limit_clause distinct_clause select_list from_clause where_clause group_clause having_clause plan_clause",
"distinct_clause : DISTINCT",
"distinct_clause : all_noise",
"select_list : select_items",
"select_list : '*'",
"select_items : select_item",
"select_items : select_items ',' select_item",
"select_item : rhs",
"select_item : rhs symbol_item_alias_name",
"select_item : rhs AS symbol_item_alias_name",
"from_clause : FROM from_list",
"from_list : table_reference",
"from_list : from_list ',' table_reference",
"table_reference : joined_table",
"table_reference : table_proc",
"joined_table : table_reference join_type JOIN table_reference ON search_condition",
"joined_table : '(' joined_table ')'",
"table_proc : symbol_procedure_name proc_table_inputs symbol_table_alias_name",
"table_proc : symbol_procedure_name proc_table_inputs",
"proc_table_inputs : '(' null_or_value_list ')'",
"proc_table_inputs :",
"null_or_value_list : null_or_value",
"null_or_value_list : null_or_value_list ',' null_or_value",
"null_or_value : null_value",
"null_or_value : value",
"table_name : simple_table_name",
"table_name : symbol_table_name symbol_table_alias_name",
"simple_table_name : symbol_table_name",
"join_type : INNER",
"join_type : LEFT",
"join_type : LEFT OUTER",
"join_type : RIGHT",
"join_type : RIGHT OUTER",
"join_type : FULL",
"join_type : FULL OUTER",
"join_type :",
"first_clause : FIRST long_integer",
"first_clause : FIRST '(' value ')'",
"first_clause : FIRST parameter",
"skip_clause : SKIP long_integer",
"skip_clause : SKIP '(' value ')'",
"skip_clause : SKIP parameter",
"limit_clause : first_clause skip_clause",
"limit_clause : first_clause",
"limit_clause : skip_clause",
"limit_clause :",
"group_clause : GROUP BY grp_column_list",
"group_clause :",
"grp_column_list : grp_column_elem",
"grp_column_list : grp_column_list ',' grp_column_elem",
"grp_column_elem : column_name",
"grp_column_elem : udf",
"grp_column_elem : column_name COLLATE symbol_collation_name",
"having_clause : HAVING search_condition",
"having_clause :",
"where_clause : WHERE search_condition",
"where_clause :",
"plan_clause : PLAN plan_expression",
"plan_clause :",
"plan_expression : plan_type '(' plan_item_list ')'",
"plan_type : JOIN",
"plan_type : SORT MERGE",
"plan_type : MERGE",
"plan_type : SORT",
"plan_type :",
"plan_item_list : plan_item",
"plan_item_list : plan_item ',' plan_item_list",
"plan_item : table_or_alias_list access_type",
"plan_item : plan_expression",
"table_or_alias_list : symbol_table_name",
"table_or_alias_list : symbol_table_name table_or_alias_list",
"access_type : NATURAL",
"access_type : INDEX '(' index_list ')'",
"access_type : ORDER symbol_index_name",
"index_list : symbol_index_name",
"index_list : symbol_index_name ',' index_list",
"insert : INSERT INTO simple_table_name column_parens_opt VALUES '(' insert_value_list ')'",
"insert : INSERT INTO simple_table_name column_parens_opt select_expr",
"insert_value_list : rhs",
"insert_value_list : insert_value_list ',' rhs",
"delete : delete_searched",
"delete : delete_positioned",
"delete_searched : DELETE FROM table_name where_clause",
"delete_positioned : DELETE FROM table_name cursor_clause",
"cursor_clause : WHERE CURRENT OF symbol_cursor_name",
"update : update_searched",
"update : update_positioned",
"update_searched : UPDATE table_name SET assignments where_clause",
"update_positioned : UPDATE table_name SET assignments cursor_clause",
"assignments : assignment",
"assignments : assignments ',' assignment",
"assignment : update_column_name '=' rhs",
"rhs : value",
"rhs : null_value",
"blob : READ BLOB simple_column_name FROM simple_table_name filter_clause segment_clause",
"blob : INSERT BLOB simple_column_name INTO simple_table_name filter_clause segment_clause",
"filter_clause : FILTER FROM blob_subtype_value TO blob_subtype_value",
"filter_clause : FILTER TO blob_subtype_value",
"filter_clause :",
"blob_subtype_value : blob_subtype",
"blob_subtype_value : parameter",
"blob_subtype : signed_short_integer",
"segment_clause : MAX_SEGMENT segment_length",
"segment_clause :",
"segment_length : unsigned_short_integer",
"segment_length : parameter",
"column_parens_opt : column_parens",
"column_parens_opt :",
"column_parens : '(' column_list ')'",
"column_list : simple_column_name",
"column_list : column_list ',' simple_column_name",
"column_name : simple_column_name",
"column_name : symbol_table_alias_name '.' symbol_column_name",
"column_name : symbol_table_alias_name '.' '*'",
"simple_column_name : symbol_column_name",
"update_column_name : simple_column_name",
"update_column_name : symbol_table_alias_name '.' symbol_column_name",
"search_condition : predicate",
"search_condition : search_condition OR search_condition",
"search_condition : search_condition AND search_condition",
"search_condition : NOT search_condition",
"predicate : comparison_predicate",
"predicate : between_predicate",
"predicate : like_predicate",
"predicate : in_predicate",
"predicate : null_predicate",
"predicate : quantified_predicate",
"predicate : exists_predicate",
"predicate : containing_predicate",
"predicate : starting_predicate",
"predicate : unique_predicate",
"predicate : '(' search_condition ')'",
"comparison_predicate : value '=' value",
"comparison_predicate : value '<' value",
"comparison_predicate : value '>' value",
"comparison_predicate : value GEQ value",
"comparison_predicate : value LEQ value",
"comparison_predicate : value NOT_GTR value",
"comparison_predicate : value NOT_LSS value",
"comparison_predicate : value NEQ value",
"quantified_predicate : value '=' ALL '(' column_select ')'",
"quantified_predicate : value '<' ALL '(' column_select ')'",
"quantified_predicate : value '>' ALL '(' column_select ')'",
"quantified_predicate : value GEQ ALL '(' column_select ')'",
"quantified_predicate : value LEQ ALL '(' column_select ')'",
"quantified_predicate : value NOT_GTR ALL '(' column_select ')'",
"quantified_predicate : value NOT_LSS ALL '(' column_select ')'",
"quantified_predicate : value NEQ ALL '(' column_select ')'",
"quantified_predicate : value '=' some '(' column_select ')'",
"quantified_predicate : value '<' some '(' column_select ')'",
"quantified_predicate : value '>' some '(' column_select ')'",
"quantified_predicate : value GEQ some '(' column_select ')'",
"quantified_predicate : value LEQ some '(' column_select ')'",
"quantified_predicate : value NOT_GTR some '(' column_select ')'",
"quantified_predicate : value NOT_LSS some '(' column_select ')'",
"quantified_predicate : value NEQ some '(' column_select ')'",
"some : SOME",
"some : ANY",
"between_predicate : value BETWEEN value AND value",
"between_predicate : value NOT BETWEEN value AND value",
"like_predicate : value LIKE value",
"like_predicate : value NOT LIKE value",
"like_predicate : value LIKE value ESCAPE value",
"like_predicate : value NOT LIKE value ESCAPE value",
"in_predicate : value IN scalar_set",
"in_predicate : value NOT IN scalar_set",
"containing_predicate : value CONTAINING value",
"containing_predicate : value NOT CONTAINING value",
"starting_predicate : value STARTING value",
"starting_predicate : value NOT STARTING value",
"starting_predicate : value STARTING WITH value",
"starting_predicate : value NOT STARTING WITH value",
"exists_predicate : EXISTS '(' select_expr ')'",
"unique_predicate : SINGULAR '(' select_expr ')'",
"null_predicate : value IS KW_NULL",
"null_predicate : value IS NOT KW_NULL",
"scalar_set : '(' constant_list ')'",
"scalar_set : '(' column_select ')'",
"column_select : SELECT limit_clause distinct_clause value from_clause where_clause group_clause having_clause plan_clause",
"column_singleton : SELECT limit_clause distinct_clause value from_clause where_clause group_clause having_clause plan_clause",
"value : column_name",
"value : array_element",
"value : function",
"value : u_constant",
"value : parameter",
"value : variable",
"value : udf",
"value : '-' value",
"value : '+' value",
"value : value '+' value",
"value : value CONCATENATE value",
"value : value COLLATE symbol_collation_name",
"value : value '-' value",
"value : value '*' value",
"value : value '/' value",
"value : '(' value ')'",
"value : '(' column_singleton ')'",
"value : current_user",
"value : current_role",
"value : DB_KEY",
"value : symbol_table_alias_name '.' DB_KEY",
"value : KW_VALUE",
"value : datetime_value_expression",
"datetime_value_expression : CURRENT_DATE",
"datetime_value_expression : CURRENT_TIME",
"datetime_value_expression : CURRENT_TIMESTAMP",
"array_element : column_name '[' value_list ']'",
"value_list : value",
"value_list : value_list ',' value",
"constant : u_constant",
"constant : '-' u_numeric_constant",
"u_numeric_constant : NUMERIC",
"u_numeric_constant : NUMBER",
"u_numeric_constant : FLOAT",
"u_numeric_constant : NUMBER64BIT",
"u_numeric_constant : SCALEDINT",
"u_constant : u_numeric_constant",
"u_constant : sql_string",
"u_constant : DATE STRING",
"u_constant : TIME STRING",
"u_constant : TIMESTAMP STRING",
"constant_list : constant",
"constant_list : parameter",
"constant_list : current_user",
"constant_list : current_role",
"constant_list : constant_list ',' constant",
"constant_list : constant_list ',' parameter",
"constant_list : constant_list ',' current_user",
"constant_list : constant_list ',' current_role",
"parameter : '?'",
"current_user : USER",
"current_user : CURRENT_USER",
"current_role : CURRENT_ROLE",
"sql_string : STRING",
"sql_string : INTRODUCER STRING",
"signed_short_integer : nonneg_short_integer",
"signed_short_integer : '-' neg_short_integer",
"nonneg_short_integer : NUMBER",
"neg_short_integer : NUMBER",
"pos_short_integer : nonneg_short_integer",
"unsigned_short_integer : NUMBER",
"signed_long_integer : long_integer",
"signed_long_integer : '-' long_integer",
"long_integer : NUMBER",
"function : COUNT '(' '*' ')'",
"function : COUNT '(' all_noise value ')'",
"function : COUNT '(' DISTINCT value ')'",
"function : SUM '(' all_noise value ')'",
"function : SUM '(' DISTINCT value ')'",
"function : AVG '(' all_noise value ')'",
"function : AVG '(' DISTINCT value ')'",
"function : MINIMUM '(' all_noise value ')'",
"function : MINIMUM '(' DISTINCT value ')'",
"function : MAXIMUM '(' all_noise value ')'",
"function : MAXIMUM '(' DISTINCT value ')'",
"function : CAST '(' rhs AS data_type_descriptor ')'",
"function : KW_UPPER '(' value ')'",
"function : GEN_ID '(' symbol_generator_name ',' value ')'",
"function : EXTRACT '(' timestamp_part FROM value ')'",
"function : SUBSTRING '(' value FROM pos_short_integer ')'",
"function : SUBSTRING '(' value FROM pos_short_integer FOR nonneg_short_integer ')'",
"udf : symbol_UDF_name '(' value_list ')'",
"udf : symbol_UDF_name '(' ')'",
"timestamp_part : YEAR",
"timestamp_part : MONTH",
"timestamp_part : DAY",
"timestamp_part : HOUR",
"timestamp_part : MINUTE",
"timestamp_part : SECOND",
"timestamp_part : WEEKDAY",
"timestamp_part : YEARDAY",
"all_noise : ALL",
"all_noise :",
"null_value : KW_NULL",
"symbol_UDF_name : SYMBOL",
"symbol_blob_subtype_name : SYMBOL",
"symbol_character_set_name : SYMBOL",
"symbol_collation_name : SYMBOL",
"symbol_column_name : SYMBOL",
"symbol_constraint_name : SYMBOL",
"symbol_cursor_name : SYMBOL",
"symbol_domain_name : SYMBOL",
"symbol_exception_name : SYMBOL",
"symbol_filter_name : SYMBOL",
"symbol_gdscode_name : SYMBOL",
"symbol_generator_name : SYMBOL",
"symbol_index_name : SYMBOL",
"symbol_item_alias_name : SYMBOL",
"symbol_procedure_name : SYMBOL",
"symbol_role_name : SYMBOL",
"symbol_table_alias_name : SYMBOL",
"symbol_table_name : SYMBOL",
"symbol_trigger_name : SYMBOL",
"symbol_user_name : SYMBOL",
"symbol_variable_name : SYMBOL",
"symbol_view_name : SYMBOL",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
static int yydebug;
static int yynerrs;
#ifndef SHLIB_DEFS
int DSQL_yyerrflag;
#endif
#ifndef SHLIB_DEFS
int DSQL_yychar;
#endif
short *yyssp;
static YYSTYPE *yyvsp;
static YYSTYPE yyval;
static YYSTYPE yylval;
static short yyss[YYSTACKSIZE];
static YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE

/*
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		lex.c
 *	DESCRIPTION:	Lexical routine
 *
 */

#include "../dsql/chars.h"

#define MAX_TOKEN_LEN   256
#define CHECK_BOUND(to)\
    {\
    if ((to - string) >= MAX_TOKEN_LEN)        \
	yyabandon (-104, isc_token_too_long); \
    }
#define CHECK_COPY_INCR(to,ch){CHECK_BOUND(to); *to++=ch;}


static TEXT	*lex_position (void);
static BOOLEAN	long_int (NOD, SLONG *);
static FLD	make_field (NOD);
static FIL	make_file (void);
static NOD	make_list (NOD);
static NOD	make_node (NOD_TYPE, int, ...);
static NOD	make_flag_node (NOD_TYPE, SSHORT, int, ...);
static void	prepare_console_debug (int, int *);
static BOOLEAN	short_int (NOD, SLONG *, SSHORT);
static void	stack_nodes (NOD, LLS *);
static int 	swallow_single_line_comment (void);
static int	yylex (USHORT, USHORT, USHORT, BOOLEAN *);
static void	yyabandon (SSHORT, STATUS);
#ifndef WINDOWS_ONLY
static void	check_log_file_attrs (void);
#endif

static TEXT	*ptr, *end, *last_token, *line_start;
static TEXT	*last_token_bk, *line_start_bk;
static SSHORT	lines, att_charset;
static SSHORT	lines_bk;
static BOOLEAN	first_time;

typedef struct tok {
    USHORT	tok_ident;
    CONST SCHAR	*tok_string;
    CONST USHORT tok_version;
} TOK;

#define DSQL_KEYWORD(tok_nr, tok_str, tok_ver) tok_nr, tok_str, tok_ver,

static CONST TOK tokens [] = {
#include "../dsql/keywords.h"
    0, 0, 0
    };

#undef DSQL_KEYWORD


void LEX_dsql_init (void)
{
/**************************************
 *
 *	L E X _ d s q l _ i n i t
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX for processing.  This is called only once
 *	per session.
 *
 **************************************/
CONST TOK	*token;

for (token = tokens; token->tok_string; ++token)
    {
    SYM         symbol;
    STR         str;

    symbol = (SYM) ALLOCPV (type_sym, 0);
    symbol->sym_string = (TEXT *) token->tok_string;
    symbol->sym_length = strlen (token->tok_string);
    symbol->sym_type = SYM_keyword;
    symbol->sym_keyword = token->tok_ident;
    symbol->sym_version = token->tok_version;
    str = (STR) ALLOCPV (type_str, symbol->sym_length);
    str->str_length = symbol->sym_length;
    strncpy (str->str_data, symbol->sym_string, symbol->sym_length);
    symbol->sym_object = (void *) str;
    HSHD_insert (symbol);
    }

}

void LEX_string (
    TEXT	*string,
    USHORT	length,
    SSHORT	character_set)
{
/**************************************
 *
 *	L E X _ s t r i n g
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX to process a string.
 *
 **************************************/

line_start = ptr = string;
end = string + length;
lines = 1;
att_charset = character_set;
line_start_bk = line_start;
lines_bk = lines;
first_time = TRUE;
}

#ifndef WINDOWS_ONLY
static void check_log_file_attrs (void)
{
/**********************************************
 *
 *	c h e c k _ l o g _ f i l e _ a t t r s
 *
 **********************************************
 *
 * Functional description
 *	Check if log file attributes are valid
 *
 *********************************************/

if (g_file->fil_partitions)
    {
    if (!g_file->fil_length)
	{
	yyabandon (-261, isc_log_length_spec);
	/* Total length of a partitioned log must be specified */
	}

    if (PARTITION_SIZE (OneK * g_file->fil_length, g_file->fil_partitions) <
	(OneK*MIN_LOG_LENGTH))
	{
	yyabandon (-239, isc_partition_too_small);
	    /* Log partition size too small */
	}
    }
else
    {
    if ((g_file->fil_length) && (g_file->fil_length < MIN_LOG_LENGTH))
	{
	yyabandon (-239, isc_log_too_small);   /* Log size too small */
	}
    }     
}
#endif

static TEXT *lex_position (void)
{
/**************************************
 *
 *	l e x _ p o s i t i o n
 *
 **************************************
 *
 * Functional description
 *	Return the current position of LEX 
 *	in the input string.
 *
 **************************************/

return ptr;
}

static BOOLEAN long_int (
    NOD		string,
    SLONG	*long_value)
{
/*************************************
 *
 *	l o n g _ i n t
 * 
 *************************************
 *
 * Functional description
 *	checks for all digits in the
 *	number and return an atol().
 *
 *************************************/
UCHAR	*p;

for (p = ((STR) string)->str_data; classes [*p] & CHR_DIGIT; p++)
    if (!(classes [*p] & CHR_DIGIT))
	return FALSE;

*long_value = atol ((char *)((STR) string)->str_data);

return TRUE;
}

static FLD make_field (
    NOD		field_name)
{
/**************************************
 *
 *	m a k e _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Make a field block of given name.
 *
 **************************************/
FLD	field;
STR	string;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;
       
if (field_name == NULL)
   {
    field = (FLD) ALLOCDV (type_fld, sizeof (INTERNAL_FIELD_NAME));
    strcpy (field->fld_name, (TEXT*) INTERNAL_FIELD_NAME);
    return field;
   }
string = (STR) field_name->nod_arg [1];
field = (FLD) ALLOCDV (type_fld, strlen ((SCHAR*) string->str_data));
strcpy (field->fld_name, (TEXT*) string->str_data);

return field;
}

static FIL make_file (void)
{
/**************************************
 *
 *	m a k e _ f i l e 
 *
 **************************************
 *
 * Functional description
 *	Make a file block
 *
 **************************************/
FIL	temp_file;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;
       
temp_file = (FIL) ALLOCD (type_fil);

return temp_file;
}

static NOD make_list (
    NOD		node)
{
/**************************************
 *
 *	m a k e _ l i s t
 *
 **************************************
 *
 * Functional description
 *	Collapse nested list nodes into single list.
 *
 **************************************/
NOD	*ptr;
LLS	stack, temp;
USHORT	l;
NOD	old;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;

if (!node)
    return node;

stack = 0;
stack_nodes (node, &stack);
for (l = 0, temp = stack; temp; temp = temp->lls_next)
    l++;

old  = node;
node = (NOD) ALLOCDV (type_nod, l);
node->nod_count = l;
node->nod_type  = nod_list;
node->nod_flags = old->nod_flags;
ptr = node->nod_arg + node->nod_count;

while (stack)
    *--ptr = (NOD) LLS_POP (&stack);

return node;
}

static NOD make_node (
    NOD_TYPE	type,
    int		count,
    ...)
{
/**************************************
 *
 *	m a k e _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type.
 *	Any change should also be made to function below
 *
 **************************************/
NOD	node, *p;
va_list	ptr;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;

node = (NOD) ALLOCDV (type_nod, count);
node->nod_type = type;
node->nod_line = (USHORT) lines_bk;
node->nod_column = (USHORT) (last_token_bk - line_start_bk + 1);
node->nod_count = count;
p = node->nod_arg;
VA_START (ptr, count);

while (--count >= 0)
    *p++ = va_arg (ptr, NOD);

return node;
}

static NOD make_flag_node (
    NOD_TYPE	type,
    SSHORT	flag,
    int		count,
    ...)
{
/**************************************
 *
 *	m a k e _ f l a g _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type. Set flag field
 *
 **************************************/
NOD	node, *p;
va_list	ptr;
TSQL    tdsql;

tdsql = GET_THREAD_DATA;

node = (NOD) ALLOCDV (type_nod, count);
node->nod_type = type;
node->nod_flags = flag;
node->nod_line = (USHORT) lines_bk;
node->nod_column = (USHORT) (last_token_bk - line_start_bk + 1);
node->nod_count = count;
p = node->nod_arg;
VA_START (ptr, count);

while (--count >= 0)
    *p++ = va_arg (ptr, NOD);

return node;
}

static void prepare_console_debug (int level, int *yydeb)
{
/*************************************
 *
 *	p r e p a r e _ c o n s o l e _ d e b u g
 * 
 *************************************
 *
 * Functional description
 *	Activate debug info. In WinNT, redirect the standard
 *	output so one can see the generated information.
 *	Feel free to add your platform specific code.
 *
 *************************************/
DSQL_debug = level;
if (level > 10)
	*yydeb = level;
/* CVC: I added this code form Mike Nordell to see the output from internal
operations that's generated in DEV build when DEBUG <n> is typed into isql.exe.
When n>0, the output console is activated; otherwise it's closed. */
#if defined(DEV_BUILD) && defined(WIN32) && defined(SUPERSERVER)
if (level > 0)
{
	/* Console debug code inside this scope */
	if (AllocConsole())
	{
    		redirected_output = freopen("CONOUT$", "wt", stdout);
    		printf("DebugConsole - Yes, it's working.\n");
	}
}
else if (level <= 0 && redirected_output)
{
	fclose (redirected_output);
	redirected_output = 0;
	FreeConsole();
}
#endif
}

static BOOLEAN short_int (
    NOD		string,
    SLONG	*long_value,
    SSHORT	range)
{
/*************************************
 *
 *	s h o r t _ i n t
 * 
 *************************************
 *
 * Functional description
 *	is the string a valid representation 
 *	of a positive short int?
 *
 *************************************/
UCHAR	*p;
SCHAR	buf [10];    
BOOLEAN return_value;

if (((STR) string)->str_length > 5)
    return FALSE;

for (p = ((STR) string)->str_data; classes [*p] & CHR_DIGIT; p++)
    if (!(classes [*p] & CHR_DIGIT))
	return FALSE;

/* there are 5 or fewer digits, it's value may still be greater
 * than 32767... */

buf [0] = ((STR) string)->str_data[0];
buf [1] = ((STR) string)->str_data[1];
buf [2] = ((STR) string)->str_data[2];
buf [3] = ((STR) string)->str_data[3];
buf [4] = ((STR) string)->str_data[4];
buf [5] = '\0';

*long_value = atoi (buf);

switch (range) 
    {
    case POSITIVE:
        return_value = *long_value > SHRT_POS_MAX;		
	break;
    case NEGATIVE:
	return_value = *long_value > SHRT_NEG_MAX;
	break;
    case UNSIGNED:
	return_value = *long_value > SHRT_UNSIGNED_MAX;		
	break;
    }
return !return_value;
}

static void stack_nodes (
    NOD		node,
    LLS		*stack)
{
/**************************************
 *
 *	s t a c k _ n o d e s
 *
 **************************************
 *
 * Functional description
 *	Assist in turning a tree of misc nodes into a clean list.
 *
 **************************************/
NOD	*ptr, *end;
NOD     curr_node, next_node, start_chain, end_chain, save_link;

if (node->nod_type != nod_list)
    {
    LLS_PUSH (node, stack);
    return;
    }

/* To take care of cases where long lists of nodes are in a chain
   of list nodes with exactly one entry, this algorithm will look
   for a pattern of repeated list nodes with two entries, the first
   being a list node and the second being a non-list node.   Such
   a list will be reverse linked, and then re-reversed, stacking the
   non-list nodes in the process.   The purpose of this is to avoid
   massive recursion of this function. */

start_chain = node;
end_chain = (NOD) NULL;
curr_node = node;
next_node = node->nod_arg[0];
while ( curr_node->nod_count == 2 &&
        curr_node->nod_arg[0]->nod_type == nod_list &&
        curr_node->nod_arg[1]->nod_type != nod_list &&
        next_node->nod_arg[0]->nod_type == nod_list &&
        next_node->nod_arg[1]->nod_type != nod_list)
    {

    /* pattern was found so reverse the links and go to next node */

    save_link = next_node->nod_arg[0];
    next_node->nod_arg[0] = curr_node;
    curr_node = next_node;
    next_node = save_link;
    end_chain = curr_node;
    }

/* see if any chain was found */

if ( end_chain)
    {

    /* first, handle the rest of the nodes */
    /* note that next_node still points to the first non-pattern node */

    stack_nodes( next_node, stack);

    /* stack the non-list nodes and reverse the chain on the way back */
    
    curr_node = end_chain;
    while ( TRUE)
        {
        LLS_PUSH( curr_node->nod_arg[1], stack);
        if ( curr_node == start_chain)
            break;
        save_link = curr_node->nod_arg[0];
        curr_node->nod_arg[0] = next_node;
        next_node = curr_node;
        curr_node = save_link;
        }
    return;
    }

for (ptr = node->nod_arg, end = ptr + node->nod_count; ptr < end; ptr++)
    stack_nodes (*ptr, stack);
}

static int swallow_single_line_comment (void)
{
/**************************************
 *
 *	s w a l l o w _ s i n g l e _ l i n e _ c o m m e n t
 *
 **************************************
 *
 * Functional description:
 *  Discard single line comments (SLC) starting with --
 *  and takes care of end of input if necessary.
 *  There may be multiple consecutive SLC, multiple SLC
 *  separated by valid commands or by LF.
 *
 **************************************/
	SSHORT	c;
	
	if (ptr >= end)
		return -1;
	while (ptr + 1 < end)
	{
		c = *ptr++;
		if (c == '-' && *ptr == '-')
		{
			ptr++;
			while (ptr < end)
				if ((c = *ptr++) == '\n')
				{
					lines++;
					line_start = ptr;
					break;
				}
				if (ptr >= end)
					return -1;
		}
		else 
		{
			--ptr;
			break;
		}
	}
	return 0;
}

static int yylex (
    USHORT	client_dialect,
    USHORT	db_dialect,
    USHORT	parser_version,
    BOOLEAN	*stmt_ambiguous)
{
/**************************************
 *
 *	y y l e x
 *
 **************************************
 *
 * Functional description: lexer.
 *
 **************************************/
UCHAR	*p, class, string [MAX_TOKEN_LEN], *buffer, *buffer_end, *new_buffer;
SYM	sym;
SSHORT	c;
USHORT	buffer_len;

STR	delimited_id_str;

/* Find end of white space and skip comments */

/* CVC: Experiment to see if -- can be implemented as one-line comment. 
This is almost the same block than below in the loop when \n is detected,
but here we should "unget" the first character if there're not 2 hyphens. */
if (first_time)
{
	first_time = FALSE;
	if (swallow_single_line_comment() < 0)
		return -1;
}

for (;;)
    {
    if (ptr >= end)
		return -1;
    
    c = *ptr++;

    while (c == '\n')
    {
		lines++;
		line_start = ptr /* + 1*/; /* CVC: +1 left out. */
		/* CVC: Experiment to see if -- can be implemented as one-line comment. */
		if (swallow_single_line_comment() < 0)
			return -1;
		c = *ptr++;
	}

    if ((c == '/') && (*ptr == '*'))
	{
	ptr++;
	while (ptr < end)
	    {
	    if ((c = *ptr++) == '*')
		{
		if (*ptr == '/')
		    break;
		}
	    if (c == '\n')
		{
		lines++;
		line_start = ptr /* + 1*/; /* CVC: +1 left out. */
		}
	    }
	if (ptr >= end)
	    return -1;
	ptr++;
	continue;
	}

#if (! ( defined JPN_SJIS || defined JPN_EUC) )
    class = classes [c];
#else
    c = c & 0xff;
    class = (JPN1_CHAR(c) ? CHR_LETTER : classes[c]);
#endif /*JPN_SJIS || JPN_EUC */

    if (!(class & CHR_WHITE))
	break;
    }

/* Depending on class of token, parse token */

last_token = ptr - 1;

if (class & CHR_INTRODUCER)
    {
    /* The Introducer (_) is skipped, all other idents are copied
     * to become the name of the character set
     */
    p = string;
    for (; ptr < end && classes [*ptr] & CHR_IDENT; ptr++)
	{
	if (ptr >= end)
	    return -1;
	CHECK_COPY_INCR(p, UPPER7(*ptr));
	}
    
    CHECK_BOUND(p);
    *p = 0;

    /* make a string value to hold the name, the name 
     * is resolved in pass1_constant */

    yylval = (NOD) (MAKE_string (string, p - string))->str_data;

    return INTRODUCER;
    }

/* parse a quoted string, being sure to look for double quotes */

if (class & CHR_QUOTE)
    {
    buffer = string;
    buffer_len = sizeof (string);
    buffer_end = buffer + buffer_len - 1;
    for (p = buffer; ; p++)
	{
	if (ptr >= end)
	    {
	    if (buffer != string)
       		gds__free (buffer);
	    return -1;
	    }
	/* *ptr is quote - if next != quote we're at the end */
	if ((*ptr == c) && ((++ptr == end) || (*ptr != c)))
	    break;
        if (p > buffer_end)
	    {
	    new_buffer = (UCHAR *) gds__alloc (2 * buffer_len);
	    /* FREE: at outer block */
	    if (!new_buffer)		/* NOMEM: */
		{
		if (buffer != string)
		    gds__free (buffer);
		return -1;
		}
            memcpy (new_buffer, buffer, buffer_len);
	    if (buffer != string)
        	gds__free (buffer);
	    buffer = new_buffer;
	    p = buffer + buffer_len;
	    buffer_len = 2 * buffer_len;
	    buffer_end = buffer + buffer_len - 1;
	    }
	*p = *ptr++;
	}
    if (c == '"')
	{
	*stmt_ambiguous = TRUE; /* string delimited by double quotes could be
				**   either a string constant or a SQL delimited
				**   identifier, therefore marks the SQL
				**   statement as ambiguous  */
	if (client_dialect == SQL_DIALECT_V6_TRANSITION)
	    {
	    if (buffer != string)
		gds__free (buffer);
	    yyabandon (-104, isc_invalid_string_constant);
	    }
	else if (client_dialect >= SQL_DIALECT_V6)
	    {
	    if ((p - buffer) >= MAX_TOKEN_LEN)
		{
		if (buffer != string)
		    gds__free (buffer);
		yyabandon (-104, isc_token_too_long);
		}
	    yylval = (NOD) MAKE_string (buffer, p - buffer);
	    delimited_id_str = (STR) yylval;
	    delimited_id_str->str_flags |= STR_delimited_id;
	    if (buffer != string)
		gds__free (buffer);
	    return SYMBOL;
	    }
	}
    yylval = (NOD) MAKE_string (buffer, p - buffer);
    if (buffer != string)
	gds__free (buffer);
    return STRING;
    }
                                                 
/* 
 * Check for a numeric constant, which starts either with a digit or with
 * a decimal point followed by a digit.
 * 
 * This code recognizes the following token types:
 * 
 * NUMBER: string of digits which fits into a 32-bit integer
 * 
 * NUMBER64BIT: string of digits whose value might fit into an SINT64,
 *   depending on whether or not there is a preceding '-', which is to
 *   say that "9223372036854775808" is accepted here.
 *
 * SCALEDINT: string of digits and a single '.', where the digits
 *   represent a value which might fit into an SINT64, depending on
 *   whether or not there is a preceding '-'.
 *
 * FLOAT: string of digits with an optional '.', and followed by an "e"
 *   or "E" and an optionally-signed exponent.
 *
 * NOTE: we swallow leading or trailing blanks, but we do NOT accept
 *   embedded blanks:
 *
 * Another note: c is the first character which need to be considered,
 *   ptr points to the next character.
 */

assert(ptr <= end);

if ((class & CHR_DIGIT) ||
    ((c == '.') && (ptr < end) && (classes [*ptr] & CHR_DIGIT)))
    {
    /* The following variables are used to recognize kinds of numbers. */

    BOOLEAN have_error     = FALSE;	/* syntax error or value too large */
    BOOLEAN have_digit     = FALSE;	/* we've seen a digit              */
    BOOLEAN have_decimal   = FALSE;	/* we've seen a '.'                */
    BOOLEAN have_exp       = FALSE;	/* digit ... [eE]                  */
    BOOLEAN have_exp_sign  = FALSE; /* digit ... [eE] {+-]             */
    BOOLEAN have_exp_digit = FALSE; /* digit ... [eE] ... digit        */
    UINT64	number         = 0;
    UINT64	limit_by_10    = MAX_SINT64 / 10;

    for (--ptr ; ptr < end ; ptr++)
      {
	c = *ptr;
	if (have_exp_digit && (! (classes [c]  & CHR_DIGIT)))
	  /* First non-digit after exponent and digit terminates
	     the token. */
	    break;
	else if (have_exp_sign && (! (classes [c]  & CHR_DIGIT)))
	    {
	    /* only digits can be accepted after "1E-" */
	      have_error = TRUE;
	      break;
	    }
	else if (have_exp)
	    {
	    /* We've seen e or E, but nothing beyond that. */
	    if ( ('-' == c) || ('+' == c) )
		have_exp_sign = TRUE;
	    else if ( classes [c]  & CHR_DIGIT )
		/* We have a digit: we haven't seen a sign yet,
		   but it's too late now. */
		have_exp_digit = have_exp_sign  = TRUE;
	    else
		{
		/* end of the token */
		have_error = TRUE;
		break;
		}
	    }
	else if ('.' == c)
	    {
	    if (!have_decimal)
		have_decimal = TRUE;
	    else
		{
		have_error = TRUE;
		break;
		}
	    }
	else if (classes [c] & CHR_DIGIT)
	  {
	    /* Before computing the next value, make sure there will be
	       no overflow.  */

	    have_digit = TRUE;

	    if (number >= limit_by_10)
		/* possibility of an overflow */
		if ((number > limit_by_10) || (c > '8'))
		    {
		    have_error = TRUE;
		    break;
		    }
	    number = number * 10 + (c - '0');
	  }
	else if ( (('E' == c) || ('e' == c)) && have_digit )
	    have_exp = TRUE;
	else
	    /* Unexpected character: this is the end of the number. */
	    break;
      }

    /* We're done scanning the characters: now return the right kind
       of number token, if any fits the bill. */

    if (!have_error)
	{
	assert(have_digit);

	if (have_exp_digit)
	    {
	    yylval = (NOD) MAKE_string ((UCHAR *) last_token,
					ptr - last_token);
	    last_token_bk = last_token;
	    line_start_bk = line_start;
	    lines_bk = lines;
	    return FLOAT;
	    }
	else if (!have_exp)
	    {

	    /* We should return some kind (scaled-) integer type
	       except perhaps in dialect 1. */

	    if (!have_decimal && (number <= MAX_SLONG))
		{
		yylval = (NOD) number;
		return NUMBER;
		}
	    else
		{
		/* We have either a decimal point with no exponent
		   or a string of digits whose value exceeds MAX_SLONG:
		   the returned type depends on the client dialect,
		   so warn of the difference if the client dialect is
		   SQL_DIALECT_V6_TRANSITION.
		*/

		if (SQL_DIALECT_V6_TRANSITION == client_dialect)
		    {
		    /* Issue a warning about the ambiguity of the numeric
		     * numeric literal.  There are multiple calls because
		     * the message text exceeds the 119-character limit
		     * of our message database.
		     */
		    ERRD_post_warning( isc_dsql_warning_number_ambiguous,
				       gds_arg_string,
				       ERR_string( last_token,
						   ptr - last_token ),
				       gds_arg_end );
		    ERRD_post_warning( isc_dsql_warning_number_ambiguous1,
				       gds_arg_end );
		    }

		yylval = (NOD) MAKE_string ((UCHAR *) last_token,
					    ptr - last_token);

		last_token_bk = last_token;
		line_start_bk = line_start;
		lines_bk = lines;
		if (client_dialect < SQL_DIALECT_V6_TRANSITION)
		    return FLOAT;
		else if (have_decimal)
		    return SCALEDINT;
		else
		    return NUMBER64BIT;
		}
	    } /* else if (!have_exp) */
	} /* if (!have_error) */

    /* we got some kind of error or overflow, so don't recognize this
     * as a number: just pass it through to the next part of the lexer.
     */
    }

/* Restore the status quo ante, before we started our unsuccessful
   attempt to recognize a number. */
ptr = last_token;
c   = *ptr++;
/* We never touched class, so it doesn't need to be restored. */

/* end of number-recognition code */


if (class & CHR_LETTER)
    {
#if (! ( defined JPN_SJIS || defined JPN_EUC) )
    p = string;
    CHECK_COPY_INCR(p, UPPER (c));
    for (; ptr < end && classes [*ptr] & CHR_IDENT; ptr++)
        {
	if (ptr >= end)
	    return -1;
	CHECK_COPY_INCR(p, UPPER (*ptr));
        }
#else
    for (; ptr <= end ; c = *ptr++ , c = c & 0xff)
        {
        if (KANJI1(c))
            {
	    CHECK_COPY_INCR(p, UPPER (c));
            if (ptr >= end) 
		break; 
            
	    c = *ptr++;
            c = c & 0xff;
            if (!KANJI2(c))
                {
                ptr--;
                break;
                }
            else
		CHECK_COPY_INCR(p,c);
            }
	else
            {
#ifdef JPN_SJIS
            if ((SJIS_SINGLE(c)) || (classes[c] & CHR_IDENT) )
#else
            if (classes[c] & CHR_IDENT)
#endif 
		{	
		CHECK_COPY_INCR(p, UPPER(c));
		if (ptr >= end)
	    	    break;
		}
            else
		{
		ptr--;
                break;
		}
            }
        }
#endif /* JPN_SJIS || JPN_EUC */

    CHECK_BOUND(p);
    *p = 0;
    sym = HSHD_lookup (NULL_PTR, (TEXT *) string, p - string, SYM_keyword, parser_version);
    if (sym)
	{
	yylval = (NOD) sym->sym_object;
	return sym->sym_keyword;
	}
    yylval = (NOD) MAKE_string (string, p - string);
    last_token_bk = last_token;
    line_start_bk = line_start;
    lines_bk = lines;
    return SYMBOL;
    }

/* Must be punctuation -- test for double character punctuation */

if (last_token + 1 < end)
    {
    sym = HSHD_lookup (NULL_PTR, last_token, 2, SYM_keyword, parser_version);
    if (sym)
	{
	++ptr;
	return sym->sym_keyword;
	}
    }

/* Single character punctuation are simply passed on */

return c;
}

static void yyerror (
    TEXT	*error_string)
{
/**************************************
 *
 *	y y e r r o r
 *
 **************************************
 *
 * Functional description
 *	Print a syntax error.
 *
 **************************************/

if (DSQL_yychar < 1)
    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104,
	gds_arg_gds, gds__command_end_err,    /* Unexpected end of command */
	0);
else
    {
    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104,
 	gds_arg_gds, gds__dsql_token_unk_err, 
	gds_arg_number, (SLONG) lines, 
	gds_arg_number, (SLONG) (last_token - line_start + 1), /*CVC: +1*/
	    /* Token unknown - line %d, char %d */
 	gds_arg_gds, gds__random, 
	gds_arg_cstring, (int) (ptr - last_token), last_token,
 	0);
    }
}

static void yyabandon (
    SSHORT      sql_code,
    STATUS      error_symbol)
{
/**************************************
 *
 *	y y a b a n d o n
 *
 **************************************
 *
 * Functional description
 *	Abandon the parsing outputting the supplied string
 *
 **************************************/

ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) sql_code, 
	gds_arg_gds, error_symbol, 0);
}
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, BOOLEAN *stmt_ambiguous)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

#ifndef WINCE
    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif
#endif

    yynerrs = 0;
    DSQL_yyerrflag = 0;
    DSQL_yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (DSQL_yychar < 0)
    {
        if ((DSQL_yychar = yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) DSQL_yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (DSQL_yychar <= YYMAXTOKEN) yys = yyname[DSQL_yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, DSQL_yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += DSQL_yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == DSQL_yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        DSQL_yychar = (-1);
        if (DSQL_yyerrflag > 0)  --DSQL_yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += DSQL_yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == DSQL_yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (DSQL_yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (DSQL_yyerrflag < 3)
    {
        DSQL_yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (DSQL_yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (DSQL_yychar <= YYMAXTOKEN) yys = yyname[DSQL_yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, DSQL_yychar, yys);
        }
#endif
        DSQL_yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
{ DSQL_parse = yyvsp[0]; }
break;
case 2:
{ DSQL_parse = yyvsp[-1]; }
break;
case 19:
{ prepare_console_debug ((int) yyvsp[0], &yydebug);
			  yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 20:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-5], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 21:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 22:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-4], yyvsp[-2], make_list(yyvsp[0]), NULL); }
break;
case 23:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), NULL); }
break;
case 24:
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					make_list(yyvsp[-3]), make_list(yyvsp[-1]), NULL, yyvsp[0]); }
break;
case 26:
{ yyval = yyvsp[0]; }
break;
case 27:
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 28:
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 29:
{ yyval = make_list (yyvsp[0]); }
break;
case 31:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 32:
{ yyval = make_list (make_node (nod_execute, (int) 0, NULL)); }
break;
case 33:
{ yyval = make_node (nod_select, (int) 0, NULL); }
break;
case 34:
{ yyval = make_node (nod_insert, (int) 0, NULL); }
break;
case 35:
{ yyval = make_node (nod_delete, (int) 0, NULL); }
break;
case 36:
{ yyval = make_node (nod_update, (int) 1, yyvsp[0]); }
break;
case 37:
{ yyval = make_node (nod_references, (int) 1, yyvsp[0]); }
break;
case 38:
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 39:
{ yyval = 0; }
break;
case 40:
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 41:
{ yyval = 0; }
break;
case 42:
{ yyval = make_node (nod_procedure_name, (int) 1, yyvsp[0]); }
break;
case 43:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-4], yyvsp[-2],
				make_list(yyvsp[0]), yyvsp[-5]); }
break;
case 44:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-5], yyvsp[-2],
				make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 45:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-4], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 46:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-5], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 47:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-4], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 48:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, yyvsp[-5], yyvsp[-2],
				make_list(yyvsp[0]), NULL); }
break;
case 49:
{ yyval = make_node (nod_revoke, 
				(int) e_grant_count, make_list(yyvsp[-2]), make_list(yyvsp[0]),
				NULL, NULL); }
break;
case 50:
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 52:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 53:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 54:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 55:
{ yyval = make_node (nod_proc_obj, (int) 1, yyvsp[0]); }
break;
case 56:
{ yyval = make_node (nod_trig_obj, (int) 1, yyvsp[0]); }
break;
case 57:
{ yyval = make_node (nod_view_obj, (int) 1, yyvsp[0]); }
break;
case 58:
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 60:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 61:
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 62:
{ yyval = make_node (nod_user_name, (int) 2, yyvsp[0], NULL); }
break;
case 63:
{ yyval = make_node (nod_user_group, (int) 1, yyvsp[0]); }
break;
case 65:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 66:
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 68:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 69:
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 70:
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 71:
{ yyval = yyvsp[0];}
break;
case 72:
{ yyval = yyvsp[0]; }
break;
case 73:
{ yyval = yyvsp[0]; }
break;
case 74:
{ yyval = make_node (nod_def_udf, (int) e_udf_count, 
				yyvsp[-7], yyvsp[-2], yyvsp[0], make_list (yyvsp[-6]), yyvsp[-4]); }
break;
case 76:
{ g_field->fld_dtype = dtype_blob; }
break;
case 77:
{ 
			g_field->fld_dtype = dtype_cstring; 
			g_field->fld_character_length = (SLONG) yyvsp[-2]; }
break;
case 78:
{ yyval = (NOD) NULL; }
break;
case 80:
{ yyval = yyvsp[-1]; }
break;
case 82:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 83:
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
				yyvsp[-1], NULL); }
break;
case 84:
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
				yyvsp[-3], MAKE_constant ((STR) FUN_descriptor, CONSTANT_SLONG)); }
break;
case 86:
{ yyval = yyvsp[-1]; }
break;
case 87:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-1], 
				MAKE_constant ((STR) FUN_reference, CONSTANT_SLONG));}
break;
case 88:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-2], 
				MAKE_constant ((STR) (-1 * FUN_reference), CONSTANT_SLONG));}
break;
case 89:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-3], 
				MAKE_constant ((STR) FUN_value, CONSTANT_SLONG));}
break;
case 90:
{ yyval = make_node (nod_udf_return_value, (int) 2, yyvsp[-3],
				MAKE_constant ((STR) FUN_descriptor, CONSTANT_SLONG));}
break;
case 91:
{ yyval = make_node (nod_udf_return_value, (int) 2, 
		  		(NOD) NULL, MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG));}
break;
case 92:
{ yyval = make_node (nod_def_filter, (int) e_filter_count, 
						yyvsp[-8], yyvsp[-6], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 93:
{ yyval = yyvsp[0]; }
break;
case 94:
{ yyval = make_node (nod_def_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 95:
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 96:
{ yyval = yyvsp[0]; }
break;
case 97:
{ yyval = yyvsp[0]; }
break;
case 98:
{ yyval = yyvsp[0]; }
break;
case 99:
{ yyval = yyvsp[0]; }
break;
case 100:
{ yyval = yyvsp[0]; }
break;
case 101:
{ yyval = yyvsp[0]; }
break;
case 102:
{ yyval = yyvsp[0]; }
break;
case 103:
{ yyval = yyvsp[0]; }
break;
case 104:
{ yyval = yyvsp[0]; }
break;
case 105:
{ yyval = yyvsp[0]; }
break;
case 106:
{ yyval = yyvsp[0]; }
break;
case 107:
{ yyval = yyvsp[0]; }
break;
case 108:
{ yyval = make_node (nod_unique, (int) 0, NULL); }
break;
case 109:
{ yyval = NULL; }
break;
case 110:
{ yyval = make_list (yyvsp[0]); }
break;
case 112:
{ yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 113:
{ yyval = make_node (nod_def_shadow, (int) e_shadow_count,
			     yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], make_list (yyvsp[0])); }
break;
case 114:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 115:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 116:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 117:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 118:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 119:
{ yyval = (NOD) 0;}
break;
case 120:
{ yyval = yyvsp[-1]; }
break;
case 121:
{ yyval = (NOD) NULL; }
break;
case 124:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 125:
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
                                          yyvsp[-7], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 126:
{ yyval = NULL; }
break;
case 127:
{ yyval = NULL; }
break;
case 128:
{ yyval = yyvsp[0]; }
break;
case 129:
{ yyval = (NOD) NULL; }
break;
case 130:
{ yyval = (NOD) NULL; }
break;
case 133:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 134:
{ yyval = make_node (nod_rel_constraint, (int) 2, NULL, yyvsp[0]);}
break;
case 137:
{ yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 138:
{ yyval = make_node (nod_def_constraint, 
				  (int) e_cnstr_count, MAKE_string (NULL_STRING, 0), NULL, 
				  NULL, NULL, yyvsp[-2], NULL, yyvsp[0], NULL, NULL); }
break;
case 139:
{ yyval = make_node (nod_def_generator, 
						(int) e_gen_count, yyvsp[0]); }
break;
case 140:
{ yyval = make_node (nod_def_role, 
						(int) 1, yyvsp[0]); }
break;
case 141:
{ yyval = make_node (nod_def_database, (int) e_cdb_count,
				 yyvsp[-2], make_list(yyvsp[-1]), make_list (yyvsp[0]));}
break;
case 144:
{ log_defined = FALSE;
			  cache_defined = FALSE;
			  yyval = (NOD) yyvsp[0]; }
break;
case 145:
{yyval = (NOD) NULL;}
break;
case 148:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 149:
{ yyval = make_node (nod_page_size, 1, yyvsp[0]);}
break;
case 150:
{ yyval = make_node (nod_file_length, 1, yyvsp[-1]);}
break;
case 151:
{ yyval = make_node (nod_user_name, 1, yyvsp[0]);}
break;
case 152:
{ yyval = make_node (nod_password, 1, yyvsp[0]);}
break;
case 153:
{ yyval = make_node (nod_lc_ctype, 1, yyvsp[0]);}
break;
case 154:
{yyval = (NOD) NULL;}
break;
case 157:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 161:
{ yyval = make_node (nod_dfl_charset, 1, yyvsp[0]);}
break;
case 162:
{ yyval = make_node (nod_group_commit_wait, 1, yyvsp[0]);}
break;
case 163:
{ yyval = make_node (nod_check_point_len, 1, yyvsp[0]);}
break;
case 164:
{ yyval = make_node (nod_num_log_buffers, 1, yyvsp[0]);}
break;
case 165:
{ yyval = make_node (nod_log_buffer_size, 1, yyvsp[0]);}
break;
case 166:
{ if (log_defined)
			    yyabandon (-260, isc_log_redef);  /* Log redefined */
			  log_defined = TRUE;
			  yyval = yyvsp[0]; }
break;
case 167:
{ if (log_defined)
			    yyabandon (-260, isc_log_redef);
			  log_defined = TRUE;
			  yyval = yyvsp[0]; }
break;
case 168:
{ g_file->fil_flags |= LOG_serial | LOG_overflow; 
			  if (g_file->fil_partitions)
			      yyabandon (-261, isc_partition_not_supp);
			/* Partitions not supported in series of log file specification */
			 yyval = make_node (nod_list, 2, yyvsp[-3], yyvsp[0]); }
break;
case 169:
{ g_file->fil_flags |= LOG_serial;
			  if (g_file->fil_partitions)
			      yyabandon (-261, isc_partition_not_supp);
			  yyval = yyvsp[0]; }
break;
case 170:
{ g_file = make_file(); 
			  g_file->fil_flags = LOG_serial | LOG_default;
			  yyval = make_node (nod_log_file_desc, (int) 1,
						(NOD) g_file);}
break;
case 171:
{ g_file->fil_name = (STR) yyvsp[-1]; 
			  yyval = (NOD) make_node (nod_file_desc, (int) 1,
						(NOD) g_file); }
break;
case 173:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 174:
{ 
#ifndef WINDOWS_ONLY
		         check_log_file_attrs(); 
#endif
			 yyval = (NOD) make_node (nod_log_file_desc, (int) 1,
                                                (NOD) g_file); }
break;
case 175:
{ g_file = make_file();
			  g_file->fil_name = (STR) yyvsp[0]; }
break;
case 178:
{ g_file->fil_length = (SLONG) yyvsp[0]; }
break;
case 179:
{ g_file  = make_file ();}
break;
case 184:
{ g_file->fil_start = (SLONG) yyvsp[0];}
break;
case 185:
{ g_file->fil_length = (SLONG) yyvsp[-1];}
break;
case 192:
{ yyval = make_node (nod_def_relation, 
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 193:
{ yyval = make_node (nod_redef_relation, 
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 194:
{ yyval = yyvsp[0]; }
break;
case 195:
{ yyval = yyvsp[0]; }
break;
case 196:
{ yyval = (NOD) NULL; }
break;
case 198:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 201:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0], yyvsp[-4], NULL); }
break;
case 202:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				    yyvsp[-2], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 203:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				    yyvsp[-1], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 204:
{ 
			g_field->fld_flags |= FLD_computed;
			yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 207:
{ yyval = NULL; }
break;
case 208:
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
                                            yyvsp[-1], NULL, NULL, NULL, NULL); }
break;
case 209:
{ yyval = yyvsp[0]; }
break;
case 210:
{ yyval = (NOD) NULL; }
break;
case 211:
{ g_field_name = yyvsp[0];
			  g_field = make_field (yyvsp[0]);
			  yyval = (NOD) g_field; }
break;
case 212:
{ g_field = make_field (yyvsp[0]);
				  yyval = (NOD) g_field; }
break;
case 213:
{ yyval = yyvsp[-1]; }
break;
case 214:
{ g_field = make_field (NULL);
			  yyval = (NOD) g_field; }
break;
case 215:
{ yyval = yyvsp[0]; }
break;
case 216:
{ yyval = (NOD) NULL; }
break;
case 217:
{ yyval = yyvsp[0]; }
break;
case 220:
{ yyval = yyvsp[0]; }
break;
case 221:
{ yyval = yyvsp[0]; }
break;
case 222:
{ yyval = (NOD) NULL; }
break;
case 225:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 226:
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 227:
{ yyval = make_node (nod_null, (int) 1, NULL); }
break;
case 228:
{ yyval = make_node (nod_foreign, e_for_count,
                        make_node (nod_list, (int) 1, g_field_name), yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 230:
{ yyval = make_node (nod_unique, (int) 0, NULL); }
break;
case 231:
{ yyval = make_node (nod_primary, (int) 0, NULL); }
break;
case 232:
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 233:
{ yyval = yyvsp[0]; }
break;
case 234:
{ yyval = NULL ;}
break;
case 239:
{ yyval = make_node (nod_unique, 1, yyvsp[0]); }
break;
case 240:
{ yyval = make_node (nod_primary, e_pri_count, yyvsp[0]); }
break;
case 241:
{ yyval = make_node (nod_foreign, e_for_count, yyvsp[-4], yyvsp[-2], 
			         yyvsp[-1], yyvsp[0]); }
break;
case 242:
{ yyval = make_node (nod_def_constraint, 
				(int) e_cnstr_count, MAKE_string (NULL_STRING, 0), NULL, 
				NULL, NULL, yyvsp[-2], NULL, yyvsp[0], NULL, NULL); }
break;
case 243:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, yyvsp[0], NULL);}
break;
case 244:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, NULL, yyvsp[0]);}
break;
case 245:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, yyvsp[0], yyvsp[-1]); }
break;
case 246:
{ yyval = make_node (nod_ref_upd_del, e_ref_upd_del_count, yyvsp[-1], yyvsp[0]);}
break;
case 247:
{ yyval = NULL;}
break;
case 248:
{ yyval = yyvsp[0];}
break;
case 249:
{ yyval = yyvsp[0];}
break;
case 250:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_CASCADE, e_ref_trig_action_count, NULL);}
break;
case 251:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_DEFAULT, e_ref_trig_action_count, NULL);}
break;
case 252:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_NULL, e_ref_trig_action_count, NULL);}
break;
case 253:
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_NONE, e_ref_trig_action_count, NULL);}
break;
case 254:
{ yyval = make_node (nod_def_procedure,
						  (int) e_prc_count, 
					          yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 255:
{ yyval = make_node (nod_redef_procedure,
						  (int) e_prc_count, 
					          yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 256:
{ yyval = make_node (nod_mod_procedure,
						  (int) e_prc_count, 
					          yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 257:
{ yyval = make_list (yyvsp[-1]); }
break;
case 258:
{ yyval = NULL; }
break;
case 259:
{ yyval = yyvsp[0]; }
break;
case 260:
{ yyval = NULL; }
break;
case 262:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 263:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-1], NULL, NULL, NULL, NULL, NULL, NULL); }
break;
case 264:
{ yyval = make_list (yyvsp[0]); }
break;
case 265:
{ yyval = NULL; }
break;
case 267:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 268:
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-2], NULL, NULL, NULL, NULL, NULL, NULL); }
break;
case 271:
{ yyval = make_node (nod_block, e_blk_count,
					make_list (yyvsp[-1]), NULL);}
break;
case 272:
{ yyval = make_node (nod_block, e_blk_count,
					make_list (yyvsp[-2]), make_list (yyvsp[-1]));}
break;
case 274:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 277:
{ yyval = make_node (nod_exception_stmt, 1, yyvsp[-1]); }
break;
case 282:
{ yyval = make_node (nod_post, e_pst_count, yyvsp[-1]); }
break;
case 286:
{ yyval = make_node (nod_return, e_rtn_count, NULL); }
break;
case 287:
{ yyval = make_node (nod_exit, 0, NULL); }
break;
case 288:
{ yyval = make_node (nod_breakleave, e_break_count, NULL); }
break;
case 289:
{ yyval = make_node (nod_exec_procedure, e_exe_count, yyvsp[-3],
					  yyvsp[-2], yyvsp[-1]); }
break;
case 290:
{ yyval = make_node (nod_for_select, e_flp_count, yyvsp[-5],
					  make_list (yyvsp[-3]), yyvsp[-2], yyvsp[0], NULL); }
break;
case 291:
{ yyval = make_node (nod_if, e_if_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 292:
{ yyval = make_node (nod_if, e_if_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 293:
{ yyval = make_node (nod_for_select, e_flp_count, yyvsp[-3],
					  make_list (yyvsp[-1]), NULL, NULL); }
break;
case 294:
{ yyval = make_node (nod_var_name, (int) e_vrn_count, 
							yyvsp[0]); }
break;
case 295:
{ yyval = make_list (yyvsp[0]); }
break;
case 296:
{ yyval = make_list (yyvsp[-1]); }
break;
case 297:
{ yyval = NULL; }
break;
case 298:
{ yyval = make_list (yyvsp[0]); }
break;
case 299:
{ yyval = make_list (yyvsp[-1]); }
break;
case 300:
{ yyval = NULL; }
break;
case 305:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 306:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 307:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 308:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 311:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 312:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 313:
{ yyval = make_node (nod_while, e_while_count,
					  yyvsp[-3], yyvsp[0], NULL); }
break;
case 314:
{ yyval = make_node (nod_cursor, e_cur_count, yyvsp[0], NULL, NULL); }
break;
case 315:
{ yyval = NULL; }
break;
case 317:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 318:
{ yyval = make_node (nod_on_error, e_err_count,
					make_list (yyvsp[-2]), yyvsp[0]); }
break;
case 320:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 321:
{ yyval = make_node (nod_sqlcode, 1, yyvsp[0]); }
break;
case 322:
{ yyval = make_node (nod_gdscode, 1, yyvsp[0]); }
break;
case 323:
{ yyval = make_node (nod_exception, 1, yyvsp[0]); }
break;
case 324:
{ yyval = make_node (nod_default, 1, NULL); }
break;
case 325:
{ yyval = make_node (nod_exec_procedure, e_exe_count, yyvsp[-1],
				  yyvsp[0], make_node (nod_all, (int) 0, NULL)); }
break;
case 326:
{ yyval = make_list (yyvsp[0]); }
break;
case 327:
{ yyval = make_list (yyvsp[-1]); }
break;
case 328:
{ yyval = NULL; }
break;
case 332:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 333:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 334:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 335:
{ yyval = make_node (nod_def_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 336:
{ yyval = make_node (nod_select, (int) 2, yyvsp[0], NULL); }
break;
case 337:
{ yyval = make_node (nod_list, (int) 1, yyvsp[0]); }
break;
case 338:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 339:
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 340:
{ yyval = make_node (nod_select_expr, e_sel_count, 
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 341:
{ yyval = make_list (yyvsp[0]); }
break;
case 343:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 346:
{ yyval = make_node (nod_join, (int) e_join_count,
						yyvsp[-5], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 347:
{ yyval = yyvsp[-1]; }
break;
case 348:
{ beginning = lex_position(); }
break;
case 349:
{ yyval = (NOD) MAKE_string ((UCHAR *) beginning, 
			       (lex_position() == end) ?
			       lex_position()-beginning : last_token-beginning);}
break;
case 350:
{ beginning = last_token; }
break;
case 351:
{ yyval = (NOD) MAKE_string ((UCHAR *) beginning, 
					lex_position()-beginning); }
break;
case 352:
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count, 
					MAKE_string (NULL_STRING, 0), NULL, NULL, NULL, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 353:
{ yyval = 0; }
break;
case 354:
{ yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-8], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], NULL); }
break;
case 355:
{ yyval = MAKE_constant ((STR) 0, CONSTANT_SLONG); }
break;
case 356:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 357:
{ yyval = NULL; }
break;
case 358:
{ yyval = MAKE_constant ((STR) 1, CONSTANT_SLONG); }
break;
case 359:
{ yyval = MAKE_constant ((STR) 2, CONSTANT_SLONG); }
break;
case 360:
{ yyval = MAKE_constant ((STR) 3, CONSTANT_SLONG); }
break;
case 361:
{ yyval = MAKE_constant ((STR) 4, CONSTANT_SLONG); }
break;
case 362:
{ yyval = MAKE_constant ((STR) 5, CONSTANT_SLONG); }
break;
case 363:
{ yyval = MAKE_constant ((STR) 6, CONSTANT_SLONG); }
break;
case 364:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 365:
{ yyval = NULL; }
break;
case 366:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 367:
{ yyval = yyvsp[0]; }
break;
case 368:
{ yyval = make_node (nod_mod_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 369:
{ yyval = make_node (nod_mod_relation, (int) e_alt_count, 
						yyvsp[-1], make_list (yyvsp[0])); }
break;
case 370:
{ yyval = yyvsp[0]; }
break;
case 371:
{ yyval = yyvsp[0]; }
break;
case 372:
{ yyval = make_node (nod_mod_database, (int) e_adb_count,
				make_list (yyvsp[0])); }
break;
case 373:
{ yyval = make_node (nod_mod_domain, (int) e_alt_count,
                                          yyvsp[-1], make_list (yyvsp[0])); }
break;
case 374:
{ yyval = make_node (nod_mod_index, 
				     (int) e_mod_idx_count, yyvsp[0]); }
break;
case 375:
{ yyval = yyvsp[0]; }
break;
case 376:
{ yyval = make_node (nod_def_constraint, 
				  (int) e_cnstr_count, MAKE_string (NULL_STRING, 0), NULL, 
				  NULL, NULL, yyvsp[-2], NULL, yyvsp[0], NULL, NULL); }
break;
case 378:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 379:
{ yyval = make_node (nod_def_default, (int) e_dft_count,
					    yyvsp[-1], yyvsp[0]); }
break;
case 380:
{ yyval = yyvsp[0]; }
break;
case 381:
{ yyval = yyvsp[0]; }
break;
case 382:
{yyval = make_node (nod_del_default, (int) 0, NULL); }
break;
case 383:
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, NULL); }
break;
case 384:
{ yyval = yyvsp[0]; }
break;
case 385:
{ yyval = make_node (nod_mod_domain_type, 2, yyvsp[-1]); }
break;
case 387:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 388:
{ yyval = make_node (nod_del_field, 2, yyvsp[-1], yyvsp[0]); }
break;
case 389:
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, yyvsp[0]);}
break;
case 390:
{ yyval = yyvsp[0]; }
break;
case 391:
{ yyval = yyvsp[0]; }
break;
case 392:
{ yyval = make_node (nod_mod_field_pos, 2, yyvsp[-2],
				MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG)); }
break;
case 393:
{ yyval = make_node (nod_mod_field_name, 2, yyvsp[-2], yyvsp[0]); }
break;
case 394:
{ yyval = make_node (nod_mod_field_type, 3, yyvsp[-3], yyvsp[0], yyvsp[-1]); }
break;
case 395:
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 418:
{ yyval = NULL; }
break;
case 419:
{ yyval = NULL; }
break;
case 420:
{ yyval = NULL; }
break;
case 421:
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
                                        	    yyvsp[-1], NULL, NULL, NULL, NULL); }
break;
case 422:
{ g_field_name = yyvsp[0];
			  g_field = make_field (yyvsp[0]);
			  yyval = (NOD) g_field; }
break;
case 423:
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 424:
{ yyval = make_node (nod_cascade, 0, NULL); }
break;
case 425:
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 426:
{ yyval = make_node (nod_idx_active, 1, yyvsp[-1]); }
break;
case 427:
{ yyval = make_node (nod_idx_inactive, 1, yyvsp[-1]); }
break;
case 428:
{ log_defined = FALSE;
			  cache_defined = FALSE;
			  yyval = (NOD) NULL; }
break;
case 430:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 431:
{ yyval = yyvsp[0]; }
break;
case 432:
{ yyval = make_node (nod_drop_log, (int) 0, NULL); }
break;
case 433:
{ yyval = yyvsp[0]; }
break;
case 434:
{ yyval = yyvsp[0]; }
break;
case 436:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 437:
{ yyval = make_node (nod_mod_trigger, (int) e_trg_count,
				yyvsp[-6], NULL, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], NULL); }
break;
case 439:
{ yyval = NULL; }
break;
case 441:
{ yyval = NULL; }
break;
case 442:
{ yyval = yyvsp[0]; }
break;
case 443:
{ yyval = make_node (nod_del_exception, 1, yyvsp[0]); }
break;
case 444:
{ yyval = make_node (nod_del_index, (int) 1, yyvsp[0]); }
break;
case 445:
{ yyval = make_node (nod_del_procedure, (int) 1, yyvsp[0]); }
break;
case 446:
{ yyval = make_node (nod_del_relation, (int) 1, yyvsp[0]); }
break;
case 447:
{ yyval = make_node (nod_del_trigger, (int) 1, yyvsp[0]); }
break;
case 448:
{ yyval = make_node (nod_del_view, (int) 1, yyvsp[0]); }
break;
case 449:
{ yyval = make_node (nod_del_filter, (int) 1, yyvsp[0]); }
break;
case 450:
{ yyval = make_node (nod_del_domain, (int) 1, yyvsp[0]); }
break;
case 451:
{ yyval = make_node (nod_del_udf, (int) 1, yyvsp[0]); }
break;
case 452:
{ yyval = make_node (nod_del_shadow, (int) 1, yyvsp[0]); }
break;
case 453:
{ yyval = make_node (nod_del_role, (int) 1, yyvsp[0]); }
break;
case 454:
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 459:
{ g_field->fld_ranges = make_list (yyvsp[-1]);
		      g_field->fld_dimensions = g_field->fld_ranges->nod_count / 2;
		      g_field->fld_element_dtype = g_field->fld_dtype;
		      yyval = yyvsp[-3]; }
break;
case 460:
{ g_field->fld_ranges = make_list (yyvsp[-2]);
		      g_field->fld_dimensions = g_field->fld_ranges->nod_count / 2;
		      g_field->fld_element_dtype = g_field->fld_dtype;
		      yyval = yyvsp[-4]; }
break;
case 462:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 463:
{ if ((SLONG) yyvsp[0] < 1)
		     		yyval = make_node (nod_list, (int) 2, 
					MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG), 
					MAKE_constant ((STR) 1, CONSTANT_SLONG)); 
		          else
		     		yyval = make_node (nod_list, (int) 2, 
			   		MAKE_constant ((STR) 1, CONSTANT_SLONG), 
					MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG) ); }
break;
case 464:
{ yyval = make_node (nod_list, (int) 2, 
			 	MAKE_constant ((STR) yyvsp[-2], CONSTANT_SLONG),
				MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG)); }
break;
case 470:
{ 
			g_field->fld_dtype = dtype_long; 
			g_field->fld_length = sizeof (SLONG); 
			}
break;
case 471:
{ 
			g_field->fld_dtype = dtype_short; 
			g_field->fld_length = sizeof (SSHORT); 
			}
break;
case 472:
{ 
			*stmt_ambiguous = TRUE;
			if (client_dialect <= SQL_DIALECT_V5)
			    {
			    /* Post warning saying that DATE is equivalent to TIMESTAMP */
		            ERRD_post_warning (isc_sqlwarn, gds_arg_number, (SLONG) 301, 
                                               isc_arg_warning, isc_dtype_renamed, 0);
			    g_field->fld_dtype = dtype_timestamp; 
			    g_field->fld_length = sizeof (GDS_TIMESTAMP);
			    }
			else if (client_dialect == SQL_DIALECT_V6_TRANSITION)
			    yyabandon (-104, isc_transitional_date);
			else
			    {
			    g_field->fld_dtype = dtype_sql_date; 
			    g_field->fld_length = sizeof (ULONG);
			    }
			}
break;
case 473:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "TIME",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "TIME",
				    0);
			g_field->fld_dtype = dtype_sql_time; 
			g_field->fld_length = sizeof (SLONG);
			}
break;
case 474:
{ 
			g_field->fld_dtype = dtype_timestamp; 
			g_field->fld_length = sizeof (GDS_TIMESTAMP);
			}
break;
case 477:
{ 
			g_field->fld_dtype = dtype_blob; 
			}
break;
case 478:
{ 
			g_field->fld_dtype = dtype_blob; 
			g_field->fld_seg_length = (SLONG) yyvsp[-1];
			g_field->fld_sub_type = 0;
			}
break;
case 479:
{ 
			g_field->fld_dtype = dtype_blob; 
			g_field->fld_seg_length = (SLONG) yyvsp[-3];
			g_field->fld_sub_type = (SLONG) yyvsp[-1];
			}
break;
case 480:
{ 
			g_field->fld_dtype = dtype_blob; 
			g_field->fld_seg_length = 80;
			g_field->fld_sub_type = (SLONG) yyvsp[-1];
			}
break;
case 481:
{
			g_field->fld_seg_length = (SLONG) yyvsp[0];
		  	}
break;
case 482:
{
			g_field->fld_seg_length = (SLONG) 80;
		  	}
break;
case 483:
{
			g_field->fld_sub_type = (SLONG) yyvsp[0];
			}
break;
case 484:
{
			g_field->fld_sub_type_name = yyvsp[0];
			}
break;
case 485:
{
			g_field->fld_sub_type = (SLONG) 0;
			}
break;
case 486:
{
			g_field->fld_character_set = yyvsp[0];
			}
break;
case 488:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			g_field->fld_flags |= FLD_national;
			}
break;
case 489:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = 1; 
			g_field->fld_flags |= FLD_national;
			}
break;
case 490:
{ 
			g_field->fld_dtype = dtype_varying; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			g_field->fld_flags |= FLD_national;
			}
break;
case 491:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			}
break;
case 492:
{ 
			g_field->fld_dtype = dtype_text; 
			g_field->fld_character_length = 1; 
			}
break;
case 493:
{ 
			g_field->fld_dtype = dtype_varying; 
			g_field->fld_character_length = (SLONG) yyvsp[-1]; 
			}
break;
case 502:
{ 
			  g_field->fld_sub_type = dsc_num_type_numeric;
			}
break;
case 503:
{  
			   g_field->fld_sub_type = dsc_num_type_decimal;
			   if (g_field->fld_dtype == dtype_short)
				{
				g_field->fld_dtype = dtype_long;
				g_field->fld_length = sizeof (SLONG);
				}
			}
break;
case 504:
{ yyval = make_node (nod_position, 1, yyvsp[0]); }
break;
case 505:
{
			g_field->fld_dtype = dtype_long; 
		    	g_field->fld_length = sizeof (SLONG); 
			g_field->fld_precision = 9;
		    	}
break;
case 506:
{         
			if ( ((SLONG) yyvsp[-1] < 1) || ((SLONG) yyvsp[-1] > 18) )
			    yyabandon (-842, isc_precision_err);
				/* Precision most be between 1 and 18. */ 
			if ((SLONG) yyvsp[-1] > 9)
			    {
			    if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect     >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect     <= SQL_DIALECT_V5) ) )
			        ERRD_post (gds__sqlerr,
					   gds_arg_number, (SLONG) -817,
					   gds_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   gds_arg_number, (SLONG) db_dialect,
					   0);
			    if (client_dialect <= SQL_DIALECT_V5)
			        {
				g_field->fld_dtype = dtype_double;
				g_field->fld_length = sizeof (double);
			        }
			    else
			        {
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				    {
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					gds_arg_end );

				    }
				g_field->fld_dtype = dtype_int64;
				g_field->fld_length = sizeof (SINT64);
			        }
			    }
			else 
			    if ((SLONG) yyvsp[-1] < 5)
			    	{
			    	g_field->fld_dtype = dtype_short; 
			    	g_field->fld_length = sizeof (SSHORT); 
			    	}
			    else
			    	{
			    	g_field->fld_dtype = dtype_long; 
			    	g_field->fld_length = sizeof (SLONG); 
			    	}
			g_field->fld_precision = (SLONG) yyvsp[-1];
			}
break;
case 507:
{ 
			if ( ((SLONG) yyvsp[-3] < 1) || ((SLONG) yyvsp[-3] > 18) )
			    yyabandon (-842, isc_precision_err);
				/* Precision should be between 1 and 18 */ 
			if (((SLONG) yyvsp[-1] > (SLONG) yyvsp[-3]) || ((SLONG) yyvsp[-1] < 0))
			    yyabandon (-842, isc_scale_nogt);
				/* Scale must be between 0 and precision */
			if ((SLONG) yyvsp[-3] > 9)
			    {
			    if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect     >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect     <= SQL_DIALECT_V5) ) )
			        ERRD_post (gds__sqlerr,
					   gds_arg_number, (SLONG) -817,
					   gds_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   gds_arg_number, (SLONG) db_dialect,
					   0);
			    if (client_dialect <= SQL_DIALECT_V5)
			        {
				g_field->fld_dtype = dtype_double;
				g_field->fld_length = sizeof (double); 
			        }
			    else
			        {
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				  {
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					gds_arg_end );
				    ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					gds_arg_end );
				  }
				  /* client_dialect >= SQL_DIALECT_V6 */
				g_field->fld_dtype = dtype_int64;
				g_field->fld_length = sizeof (SINT64);
			        }
			    }
			else
			    {
			    if ((SLONG) yyvsp[-3] < 5)
			    	{
			    	g_field->fld_dtype = dtype_short; 
			    	g_field->fld_length = sizeof (SSHORT); 
			    	}
			    else
			    	{
			    	g_field->fld_dtype = dtype_long; 
			    	g_field->fld_length = sizeof (SLONG); 
			    	}
			    }
			g_field->fld_precision = (SLONG) yyvsp[-3];
			g_field->fld_scale = - (SLONG) yyvsp[-1];
			}
break;
case 510:
{ 
			if ((SLONG) yyvsp[0] > 7)
			    {
			    g_field->fld_dtype = dtype_double;
			    g_field->fld_length = sizeof (double); 
			    }
			else
			    {
			    g_field->fld_dtype = dtype_real; 
			    g_field->fld_length = sizeof (float);
			    }
			}
break;
case 511:
{ 
			g_field->fld_dtype = dtype_double; 
			g_field->fld_length = sizeof (double); 
			}
break;
case 512:
{ 
			g_field->fld_dtype = dtype_real; 
			g_field->fld_length = sizeof (float); 
			}
break;
case 513:
{ 
			g_field->fld_dtype = dtype_double; 
			g_field->fld_length = sizeof (double); 
			}
break;
case 514:
{ yyval = yyvsp[-1]; }
break;
case 515:
{ yyval = 0; }
break;
case 519:
{ 
			  yyval = make_node (nod_set_generator2,e_gen_id_count,yyvsp[-2],
						MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG));
			}
break;
case 520:
{
			  yyval = make_node (nod_set_generator2,e_gen_id_count,yyvsp[-2],
				       MAKE_constant((STR)yyvsp[0], CONSTANT_SINT64));
			}
break;
case 521:
{
			  yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
					  make_node(nod_negate, 1,
						    MAKE_constant((STR)yyvsp[0], CONSTANT_SINT64)));
			}
break;
case 522:
{ yyval = make_node (nod_commit, 1, yyvsp[0]); }
break;
case 523:
{ yyval = make_node (nod_rollback, 0, NULL); }
break;
case 526:
{ yyval = make_node (nod_commit_retain, 0, NULL); }
break;
case 527:
{ yyval = (NOD) NULL; }
break;
case 529:
{ yyval = (NOD) NULL; }
break;
case 530:
{yyval = make_node (nod_trans, 1, make_list (yyvsp[0])); }
break;
case 532:
{ yyval = (NOD) NULL; }
break;
case 534:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 539:
{ yyval = make_flag_node (nod_access, NOD_READ_ONLY, (int) 0, NULL); }
break;
case 540:
{ yyval = make_flag_node (nod_access, NOD_READ_WRITE, (int) 0, NULL); }
break;
case 541:
{ yyval = make_flag_node (nod_wait, NOD_WAIT, (int) 0, NULL); }
break;
case 542:
{ yyval = make_flag_node (nod_wait, NOD_NO_WAIT, (int) 0, NULL); }
break;
case 543:
{ yyval = yyvsp[0];}
break;
case 545:
{ yyval = yyvsp[0];}
break;
case 546:
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 547:
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 548:
{ yyval = make_flag_node (nod_isolation, NOD_CONCURRENCY, 0, NULL); }
break;
case 549:
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 550:
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 551:
{ yyval = make_flag_node (nod_version, NOD_VERSION, 0, NULL); }
break;
case 552:
{ yyval = make_flag_node (nod_version, NOD_NO_VERSION, 0, NULL); }
break;
case 553:
{ yyval = 0; }
break;
case 554:
{ yyval = make_node (nod_reserve, 1, make_list (yyvsp[0])); }
break;
case 555:
{ yyval = (NOD) NOD_SHARED; }
break;
case 556:
{ yyval = (NOD) NOD_PROTECTED ; }
break;
case 557:
{ yyval = (NOD) 0; }
break;
case 558:
{ yyval = (NOD) NOD_READ; }
break;
case 559:
{ yyval = (NOD) NOD_WRITE; }
break;
case 561:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 562:
{ yyval = make_node (nod_table_lock, (int) 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 563:
{ yyval = make_flag_node (nod_lock_mode, ((SSHORT) yyvsp[-1] | (SSHORT) yyvsp[0]), 0, NULL); }
break;
case 564:
{ yyval = 0; }
break;
case 566:
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 567:
{yyval = make_node (nod_set_statistics, 
				(int)e_stat_count, yyvsp[0]); }
break;
case 568:
{ yyval = make_node (nod_select, 3, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 569:
{ yyval = make_node (nod_list, 1, yyvsp[0]); }
break;
case 570:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 571:
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 572:
{ yyval = make_list (yyvsp[0]); }
break;
case 573:
{ yyval = 0; }
break;
case 575:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 576:
{ yyval = make_node (nod_order, e_order_count, yyvsp[-2], yyvsp[0], yyvsp[-1]); }
break;
case 577:
{ yyval = make_node (nod_order, e_order_count, yyvsp[-2], yyvsp[0], yyvsp[-1]); }
break;
case 578:
{ yyval = 0; }
break;
case 579:
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 580:
{ yyval = 0; }
break;
case 581:
{ yyval = yyvsp[0]; }
break;
case 582:
{ yyval = 0; }
break;
case 583:
{ yyval = yyvsp[0]; }
break;
case 584:
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 585:
{ yyval = make_node (nod_select_expr, e_sel_count, 
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 586:
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 587:
{ yyval = 0; }
break;
case 588:
{ yyval = make_list (yyvsp[0]); }
break;
case 589:
{ yyval = 0; }
break;
case 591:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 593:
{ yyval = make_node (nod_alias, 2, yyvsp[-1], yyvsp[0]); }
break;
case 594:
{ yyval = make_node (nod_alias, 2, yyvsp[-2], yyvsp[0]); }
break;
case 595:
{ yyval = make_list (yyvsp[0]); }
break;
case 597:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 600:
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-5], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 601:
{ yyval = yyvsp[-1]; }
break;
case 602:
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-2], yyvsp[0], yyvsp[-1]); }
break;
case 603:
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 604:
{ yyval = make_list (yyvsp[-1]); }
break;
case 605:
{ yyval = NULL; }
break;
case 607:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 611:
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[-1], yyvsp[0]); }
break;
case 612:
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[0], NULL); }
break;
case 613:
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 614:
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 615:
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 616:
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 617:
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 618:
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 619:
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 620:
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 621:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 622:
{ yyval = yyvsp[-1]; }
break;
case 623:
{ yyval = yyvsp[0]; }
break;
case 624:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 625:
{ yyval = yyvsp[-1]; }
break;
case 626:
{ yyval = yyvsp[0]; }
break;
case 627:
{ yyval = make_node (nod_limit, e_limit_count, yyvsp[0], yyvsp[-1]); }
break;
case 628:
{ yyval = make_node (nod_limit, e_limit_count, NULL, yyvsp[0]); }
break;
case 629:
{ yyval = make_node (nod_limit, e_limit_count, yyvsp[0], NULL); }
break;
case 630:
{ yyval = 0; }
break;
case 631:
{ yyval = make_list (yyvsp[0]); }
break;
case 632:
{ yyval = 0; }
break;
case 634:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 637:
{ yyval = make_node (nod_collate, e_coll_count, (NOD) yyvsp[0], yyvsp[-2]); }
break;
case 638:
{ yyval = yyvsp[0]; }
break;
case 639:
{ yyval = 0; }
break;
case 640:
{ yyval = yyvsp[0]; }
break;
case 641:
{ yyval = 0; }
break;
case 642:
{ yyval = yyvsp[0]; }
break;
case 643:
{ yyval = 0; }
break;
case 644:
{ yyval = make_node (nod_plan_expr, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 645:
{ yyval = 0; }
break;
case 646:
{ yyval = make_node (nod_merge, (int) 0, NULL); }
break;
case 647:
{ yyval = make_node (nod_merge, (int) 0, NULL); }
break;
case 648:
{ yyval = 0; }
break;
case 649:
{ yyval = 0; }
break;
case 651:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 652:
{ yyval = make_node (nod_plan_item, 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 655:
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 656:
{ yyval = make_node (nod_natural, (int) 0, NULL); }
break;
case 657:
{ yyval = make_node (nod_index, 1, make_list (yyvsp[-1])); }
break;
case 658:
{ yyval = make_node (nod_index_order, 1, yyvsp[0]); }
break;
case 660:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 661:
{ yyval = make_node (nod_insert, e_ins_count, 
			  yyvsp[-5], make_list (yyvsp[-4]), make_list (yyvsp[-1]), NULL); }
break;
case 662:
{ yyval = make_node (nod_insert, e_ins_count, yyvsp[-2], yyvsp[-1], NULL, yyvsp[0]); }
break;
case 664:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 667:
{ yyval = make_node (nod_delete, e_del_count, yyvsp[-1], yyvsp[0], NULL); }
break;
case 668:
{ yyval = make_node (nod_delete, e_del_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 669:
{ yyval = make_node (nod_cursor, e_cur_count, yyvsp[0], NULL, NULL); }
break;
case 672:
{ yyval = make_node (nod_update, e_upd_count, 
				yyvsp[-3], make_list (yyvsp[-1]), yyvsp[0], NULL); }
break;
case 673:
{ yyval = make_node (nod_update, e_upd_count,
			  	yyvsp[-3], make_list (yyvsp[-1]), NULL, yyvsp[0]); }
break;
case 675:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 676:
{ yyval = make_node (nod_assign, 2, yyvsp[0], yyvsp[-2]); }
break;
case 679:
{ yyval = make_node (nod_get_segment, e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 680:
{ yyval = make_node (nod_put_segment, e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 681:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 682:
{ yyval = make_node (nod_list, 2, NULL, yyvsp[0]); }
break;
case 686:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 687:
{ yyval = yyvsp[0]; }
break;
case 689:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 692:
{ yyval = NULL; }
break;
case 693:
{ yyval = make_list (yyvsp[-1]); }
break;
case 695:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 697:
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 698:
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], NULL); }
break;
case 699:
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 701:
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 703:
{ yyval = make_node (nod_or, 2, yyvsp[-2], yyvsp[0]); }
break;
case 704:
{ yyval = make_node (nod_and, 2, yyvsp[-2], yyvsp[0]); }
break;
case 705:
{ yyval = make_node (nod_not, 1, yyvsp[0]); }
break;
case 716:
{ yyval = yyvsp[-1]; }
break;
case 717:
{ yyval = make_node (nod_eql, 2, yyvsp[-2], yyvsp[0]); }
break;
case 718:
{ yyval = make_node (nod_lss, 2, yyvsp[-2], yyvsp[0]); }
break;
case 719:
{ yyval = make_node (nod_gtr, 2, yyvsp[-2], yyvsp[0]); }
break;
case 720:
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 721:
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 722:
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 723:
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 724:
{ yyval = make_node (nod_neq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 725:
{ yyval = make_node (nod_eql_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 726:
{ yyval = make_node (nod_lss_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 727:
{ yyval = make_node (nod_gtr_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 728:
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 729:
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 730:
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 731:
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 732:
{ yyval = make_node (nod_neq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 733:
{ yyval = make_node (nod_eql_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 734:
{ yyval = make_node (nod_lss_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 735:
{ yyval = make_node (nod_gtr_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 736:
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 737:
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 738:
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 739:
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 740:
{ yyval = make_node (nod_neq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 743:
{ yyval = make_node (nod_between, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 744:
{ yyval = make_node (nod_not, 1, make_node (nod_between, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 745:
{ yyval = make_node (nod_like, 2, yyvsp[-2], yyvsp[0]); }
break;
case 746:
{ yyval = make_node (nod_not, 1, make_node (nod_like, 2, yyvsp[-3], yyvsp[0])); }
break;
case 747:
{ yyval = make_node (nod_like, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 748:
{ yyval = make_node (nod_not, 1, make_node (nod_like, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 749:
{ yyval = make_node (nod_eql_any, 2, yyvsp[-2], yyvsp[0]); }
break;
case 750:
{ yyval = make_node (nod_not, 1, make_node (nod_eql_any, 2, yyvsp[-3], yyvsp[0])); }
break;
case 751:
{ yyval = make_node (nod_containing, 2, yyvsp[-2], yyvsp[0]); }
break;
case 752:
{ yyval = make_node (nod_not, 1, make_node (nod_containing, 2, yyvsp[-3], yyvsp[0])); }
break;
case 753:
{ yyval = make_node (nod_starting, 2, yyvsp[-2], yyvsp[0]); }
break;
case 754:
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-3], yyvsp[0])); }
break;
case 755:
{ yyval = make_node (nod_starting, 2, yyvsp[-3], yyvsp[0]); }
break;
case 756:
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-4], yyvsp[0])); }
break;
case 757:
{ yyval = make_node (nod_exists, 1, yyvsp[-1]); }
break;
case 758:
{ yyval = make_node (nod_singular, 1, yyvsp[-1]); }
break;
case 759:
{ yyval = make_node (nod_missing, 1, yyvsp[-2]); }
break;
case 760:
{ yyval = make_node (nod_not, 1, make_node (nod_missing, 1, yyvsp[-3])); }
break;
case 761:
{ yyval = make_list (yyvsp[-1]); }
break;
case 762:
{ yyval = yyvsp[-1]; }
break;
case 763:
{ yyval = make_node (nod_select_expr, e_sel_count, 
				yyvsp[-7], yyvsp[-6], make_list(yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0], NULL); }
break;
case 764:
{ yyval = make_node (nod_select_expr, e_sel_count, 
		 		yyvsp[-7], yyvsp[-6], make_list(yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0],
				MAKE_constant ((STR) 1, CONSTANT_SLONG)); }
break;
case 772:
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 773:
{ yyval = yyvsp[0]; }
break;
case 774:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_add2, 2, yyvsp[-2], yyvsp[0]);
			  else
			      yyval = make_node (nod_add, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 775:
{ yyval = make_node (nod_concatenate, 2, yyvsp[-2], yyvsp[0]); }
break;
case 776:
{ yyval = make_node (nod_collate, e_coll_count, (NOD) yyvsp[0], yyvsp[-2]); }
break;
case 777:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_subtract2, 2, yyvsp[-2], yyvsp[0]);
			  else 
			      yyval = make_node (nod_subtract, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 778:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			       yyval = make_node (nod_multiply2, 2, yyvsp[-2], yyvsp[0]);
			  else
			       yyval = make_node (nod_multiply, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 779:
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_divide2, 2, yyvsp[-2], yyvsp[0]);
			  else
			      yyval = make_node (nod_divide, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 780:
{ yyval = yyvsp[-1]; }
break;
case 781:
{ yyval = yyvsp[-1]; }
break;
case 784:
{ yyval = make_node (nod_dbkey, 1, NULL); }
break;
case 785:
{ yyval = make_node (nod_dbkey, 1, yyvsp[-2]); }
break;
case 786:
{ 
			  yyval = make_node (nod_dom_value, 0, NULL);
                        }
break;
case 787:
{ yyval = yyvsp[0]; }
break;
case 788:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "DATE",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "DATE",
				    0);
			yyval = make_node (nod_current_date, 0, NULL);
			}
break;
case 789:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "TIME",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "TIME",
				    0);
			yyval = make_node (nod_current_time, 0, NULL);
			}
break;
case 790:
{ yyval = make_node (nod_current_timestamp, 0, NULL); }
break;
case 791:
{ yyval = make_node (nod_array, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 793:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 795:
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 796:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_STRING); }
break;
case 797:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SLONG); }
break;
case 798:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_DOUBLE); }
break;
case 799:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SINT64); }
break;
case 800:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_SINT64); }
break;
case 802:
{ yyval = MAKE_str_constant ((STR) yyvsp[0], att_charset); }
break;
case 803:
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "DATE",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "DATE",
				    0);
			yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_DATE);
			}
break;
case 804:
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_dialect_datatype_unsupport,
				    gds_arg_number, client_dialect,
				    gds_arg_string, "TIME",
				    0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			    ERRD_post (gds__sqlerr, gds_arg_number, (SLONG) -104, 
				    gds_arg_gds, isc_sql_db_dialect_dtype_unsupport,
				    gds_arg_number, db_dialect,
				    gds_arg_string, "TIME",
				    0);
			yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_TIME); 
			}
break;
case 805:
{ yyval = MAKE_constant ((STR) yyvsp[0], CONSTANT_TIMESTAMP); }
break;
case 810:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 811:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 812:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 813:
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 814:
{ yyval = make_node (nod_parameter, 0, NULL); }
break;
case 815:
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 816:
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 817:
{ yyval = make_node (nod_current_role, 0, NULL); }
break;
case 818:
{ yyval = yyvsp[0]; }
break;
case 819:
{ ((STR) yyvsp[0])->str_charset = (TEXT *) yyvsp[-1];
			  yyval = yyvsp[0]; }
break;
case 821:
{ yyval = (NOD) - (SLONG) yyvsp[0]; }
break;
case 822:
{ if ((SLONG) yyvsp[0] > SHRT_POS_MAX)
			    yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 823:
{ if ((SLONG) yyvsp[0] > SHRT_NEG_MAX)
			    yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 824:
{ if ((SLONG) yyvsp[0] == 0)
			    yyabandon (-842, isc_expec_positive);
				/* Positive number expected */
			  yyval = yyvsp[0];}
break;
case 825:
{ if ((SLONG) yyvsp[0] > SHRT_UNSIGNED_MAX)
			    yyabandon (-842, isc_expec_ushort);
				/* Unsigned short integer expected */
			  yyval = yyvsp[0];}
break;
case 827:
{ yyval = (NOD) - (SLONG) yyvsp[0]; }
break;
case 828:
{ yyval = yyvsp[0];}
break;
case 829:
{ yyval = make_node (nod_agg_count, 0, NULL); }
break;
case 830:
{ yyval = make_node (nod_agg_count, 1, yyvsp[-1]); }
break;
case 831:
{ yyval = make_flag_node (nod_agg_count,
                                       NOD_AGG_DISTINCT, 1, yyvsp[-1]); }
break;
case 832:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_agg_total2, 1, yyvsp[-1]);
			  else
			      yyval = make_node (nod_agg_total, 1, yyvsp[-1]);
			}
break;
case 833:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_flag_node (nod_agg_total2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
			      yyval = make_flag_node (nod_agg_total,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 834:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_agg_average2, 1, yyvsp[-1]);
			  else
			      yyval = make_node (nod_agg_average, 1, yyvsp[-1]);
			}
break;
case 835:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_flag_node (nod_agg_average2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
			      yyval = make_flag_node (nod_agg_average,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 836:
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 837:
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 838:
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 839:
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 840:
{ yyval = make_node (nod_cast, e_cast_count, yyvsp[-1], yyvsp[-3]); }
break;
case 841:
{ yyval = make_node (nod_upcase, 1, yyvsp[-1]); }
break;
case 842:
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
			      yyval = make_node (nod_gen_id2, 2, yyvsp[-3], yyvsp[-1]);
			  else
			      yyval = make_node (nod_gen_id, 2, yyvsp[-3], yyvsp[-1]);
			}
break;
case 843:
{ yyval = make_node (nod_extract, e_extract_count, yyvsp[-3], yyvsp[-1]); }
break;
case 844:
{ yyval = make_node (nod_substr, e_substr_count, yyvsp[-3],
				MAKE_constant ((STR) ((SLONG)(yyvsp[-1]) - 1), CONSTANT_SLONG),
				MAKE_constant ((STR) SHRT_POS_MAX, CONSTANT_SLONG)); }
break;
case 845:
{ yyval = make_node (nod_substr, e_substr_count, yyvsp[-5],
				MAKE_constant ((STR) ((SLONG)(yyvsp[-3]) - 1), CONSTANT_SLONG),
				MAKE_constant ((STR) (yyvsp[-1]), CONSTANT_SLONG)); }
break;
case 846:
{ yyval = make_node (nod_udf, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 847:
{ yyval = make_node (nod_udf, 1, yyvsp[-2]); }
break;
case 848:
{ yyval = MAKE_constant (blr_extract_year, CONSTANT_SLONG); }
break;
case 849:
{ yyval = MAKE_constant (blr_extract_month, CONSTANT_SLONG); }
break;
case 850:
{ yyval = MAKE_constant (blr_extract_day, CONSTANT_SLONG); }
break;
case 851:
{ yyval = MAKE_constant (blr_extract_hour, CONSTANT_SLONG); }
break;
case 852:
{ yyval = MAKE_constant (blr_extract_minute, CONSTANT_SLONG); }
break;
case 853:
{ yyval = MAKE_constant (blr_extract_second, CONSTANT_SLONG); }
break;
case 854:
{ yyval = MAKE_constant (blr_extract_weekday, CONSTANT_SLONG); }
break;
case 855:
{ yyval = MAKE_constant (blr_extract_yearday, CONSTANT_SLONG); }
break;
case 858:
{ yyval = make_node (nod_null, 0, NULL); }
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (DSQL_yychar < 0)
        {
            if ((DSQL_yychar = yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) DSQL_yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (DSQL_yychar <= YYMAXTOKEN) yys = yyname[DSQL_yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, DSQL_yychar, yys);
            }
#endif
        }
        if (DSQL_yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
